import 'reflect-metadata';
import { DataProviderFactory, DataApiRequest } from "../core/dataInterfaces1";
import { Action } from '../core/restDataProvider';
import { DirectSQL, Allowed } from './Context';
import { SQLConnectionProvider } from '../core/utils';
interface inArgs {
    args: any[];
}
interface result {
    data: any;
}
export declare class ActualDirectSQL extends DirectSQL {
    private dp;
    execute(sql: string): Promise<import("../core/utils").SQLQueryResult>;
    constructor(dp: SQLConnectionProvider);
}
export declare class myServerAction extends Action<inArgs, result> {
    private types;
    private options;
    private originalMethod;
    constructor(name: string, types: any[], options: ServerFunctionOptions, originalMethod: (args: any[]) => any);
    dataSource: DataProviderFactory;
    protected execute(info: inArgs, req: DataApiRequest): Promise<result>;
}
export interface ServerFunctionOptions {
    allowed: Allowed;
    blockUser?: boolean;
}
export declare const actionInfo: {
    allActions: any[];
    runningOnServer: boolean;
};
export declare function ServerFunction(options: ServerFunctionOptions): (target: any, key: string, descriptor: any) => any;
export declare const serverActionField: unique symbol;
export {};
