import { SQLConnectionProvider, SQLCommand, Entity } from "./utils";
import { DataProvider, FilterBase, FindOptions } from "./dataInterfaces1";
export declare class ActualSQLServerDataProvider<T extends Entity<any>> implements DataProvider {
    private entityFactory;
    private name;
    private sql;
    private factory;
    static LogToConsole: boolean;
    constructor(entityFactory: () => Entity<any>, name: string, sql: SQLConnectionProvider, factory: () => T);
    static decorateSqlConnectionProvider(sql: SQLConnectionProvider): SQLConnectionProvider;
    createDirectSQLCommand(): SQLCommand;
    private entity;
    count(where: FilterBase): Promise<number>;
    find(options?: FindOptions): Promise<any[]>;
    update(id: any, data: any): Promise<any>;
    delete(id: any): Promise<void>;
    insert(data: any): Promise<any>;
}
