import { Entity } from './utils';
import { FilterBase, DataProviderFactory, DataProvider, FindOptions, RowsOfDataForTesting } from './dataInterfaces1';
export declare class InMemoryDataProvider implements DataProviderFactory, RowsOfDataForTesting {
    rows: any;
    provideFor<T extends Entity<any>>(name: string, factory: () => T): DataProvider;
    toString(): string;
}
export declare class ActualInMemoryDataProvider<T extends Entity<any>> implements DataProvider {
    private factory;
    private rows?;
    constructor(factory: () => T, rows?: any[]);
    count(where?: FilterBase): Promise<number>;
    find(options?: FindOptions): Promise<any[]>;
    map(i: any): any;
    private entity;
    private idMatches;
    update(id: any, data: any): Promise<any>;
    delete(id: any): Promise<void>;
    insert(data: any): Promise<any>;
}
export declare function pageArray(rows: any[], options?: FindOptions): any[];
