import { DataProvider, DataProviderFactory, DataApiRequest } from './dataInterfaces1';
import { DataApiResponse } from '../server/DataApi';
import { HttpClient } from '@angular/common/http';
export declare class RestDataProvider implements DataProviderFactory {
    private url;
    private http;
    constructor(url: string, http: restDataProviderHttpProvider);
    provideFor(name: string): DataProvider;
}
export interface restDataProviderHttpProvider {
    post(url: string, data: any): Promise<any>;
    delete(url: string): Promise<void>;
    put(url: string, data: any): Promise<any>;
    get(url: string): Promise<any>;
}
export declare class angularHttpProvider implements restDataProviderHttpProvider {
    private http;
    constructor(http: HttpClient);
    post(url: string, data: any): Promise<any>;
    delete(url: string): Promise<void>;
    put(url: string, data: any): Promise<any>;
    get(url: string): Promise<any>;
}
export declare class restDataProviderHttpProviderUsingFetch implements restDataProviderHttpProvider {
    private addRequestHeader?;
    constructor(addRequestHeader?: (add: ((name: string, value: string) => void)) => void);
    get(url: string): Promise<any>;
    put(url: string, data: any): Promise<any>;
    delete(url: string): Promise<any>;
    post(url: string, data: any): Promise<any>;
}
export interface WrapFetchInterface {
    wrap: () => (() => void);
}
export declare const wrapFetch: WrapFetchInterface;
export declare function myFetch(url: string, init: RequestInit, ...addRequestHeader: ((add: ((name: string, value: string) => void)) => void)[]): Promise<any>;
export declare abstract class Action<inParam, outParam> {
    private serverUrl;
    private actionUrl?;
    constructor(serverUrl: string, actionUrl?: string, addRequestHeader?: (add: ((name: string, value: string) => void)) => void);
    static provider: restDataProviderHttpProvider;
    run(pIn: inParam): Promise<outParam>;
    protected abstract execute(info: inParam, req: DataApiRequest): Promise<outParam>;
    __register(reg: (url: string, what: ((data: any, req: DataApiRequest, res: DataApiResponse) => void)) => void): void;
}
