import { Router, Route, CanActivate, ActivatedRouteSnapshot } from '@angular/router';
import { Injector } from '@angular/core';
import { Context, Allowed, AngularComponent } from './context/Context';
export declare class RouteHelperService {
    private router;
    private injector;
    constructor(router: Router, injector: Injector);
    navigateToComponent(toComponent: {
        new (...args: any[]): any;
    }): void;
    canNavigateToRoute(route: Route): boolean;
}
export declare class SignedInGuard implements CanActivate {
    protected context: Context;
    private router;
    private helper;
    constructor(context: Context, router: Router, helper: RouteHelperService);
    isAllowed(): Allowed;
    static componentToNavigateIfNotAllowed: AngularComponent;
    canActivate(route: ActivatedRouteSnapshot): boolean;
}
export declare class NotSignedInGuard implements CanActivate {
    private context;
    private router;
    constructor(context: Context, router: Router);
    canActivate(route: ActivatedRouteSnapshot): boolean;
}
