import { ErrorStateMatcher } from '@angular/material/core';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { isBoolean, isString, isArray, isFunction } from 'util';
import { JwtHelperService } from '@auth0/angular-jwt';
import { Router, ActivatedRouteSnapshot } from '@angular/router';
import { HttpClient, HttpClientModule, HTTP_INTERCEPTORS } from '@angular/common/http';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import { finalize } from 'rxjs/operators';
import { MatDialogModule } from '@angular/material/dialog';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { MatFormFieldModule } from '@angular/material/form-field';
import { MatInputModule } from '@angular/material/input';
import { MatDialog, MatIconModule, MatButtonModule, MatCheckboxModule } from '@angular/material';
import { Component, Input, ViewChild, Injectable, Injector, ViewEncapsulation, NgModule } from '@angular/core';
import 'reflect-metadata';
import { __awaiter, __generator, __extends, __values, __spread } from 'tslib';
import { v4 } from 'uuid';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} name
 * @return {?}
 */
function makeTitle(name) {
    // insert a space before all caps
    return name.replace(/([A-Z])/g, ' $1')
        // uppercase the first character
        .replace(/^./, (/**
     * @param {?} str
     * @return {?}
     */
    function (str) { return str.toUpperCase(); })).replace('Email', 'eMail').replace(" I D", " ID");
}
/**
 * @param {?} functionToCheck
 * @return {?}
 */
function isFunction$1(functionToCheck) {
    /** @type {?} */
    var getType = {};
    return functionToCheck && getType.toString.call(functionToCheck) === '[object Function]';
}
/**
 * @param {?} f
 * @return {?}
 */
function functionOrString(f) {
    if (isFunction$1(f)) {
        /** @type {?} */
        var x = (/** @type {?} */ (f));
        return x();
    }
    return f.toString();
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var testing = 'testing 123';
/**
 * @template rowType
 */
var  /**
 * @template rowType
 */
DataAreaSettings = /** @class */ (function () {
    function DataAreaSettings(settings, columns, entity) {
        var e_1, _a;
        this.settings = settings;
        this.columns = columns;
        this.lines = [];
        if (columns == undefined) {
            columns = new ColumnCollection((/**
             * @return {?}
             */
            function () { return undefined; }), (/**
             * @return {?}
             */
            function () { return true; }), undefined, (/**
             * @return {?}
             */
            function () { return true; }));
            columns.numOfColumnsInGrid = 0;
            this.columns = columns;
        }
        if (settings && settings.columnSettings) {
            try {
                for (var _b = __values(settings.columnSettings(entity)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var colSettings = _c.value;
                    if (isArray(colSettings)) {
                        /** @type {?} */
                        var x = columns.items.length;
                        //@ts-ignore
                        columns.add.apply(columns, __spread(colSettings));
                        /** @type {?} */
                        var line = [];
                        for (var index = x; index < columns.items.length; index++) {
                            line.push(columns.items[index]);
                        }
                        this.lines.push(line);
                    }
                    else {
                        columns.add((/** @type {?} */ (colSettings)));
                        this.lines.push([columns.items[columns.items.length - 1]]);
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
    }
    return DataAreaSettings;
}());
/**
 * @template rowType
 */
var  /**
 * @template rowType
 */
GridSettings = /** @class */ (function () {
    function GridSettings(entity, settings) {
        var _a;
        var _this = this;
        this.entity = entity;
        this.settings = settings;
        this.showSelectColumn = false;
        this.allowUpdate = false;
        this.allowInsert = false;
        this.allowDelete = false;
        this.hideDataArea = false;
        this._buttons = [];
        this.filterHelper = new FilterHelper((/**
         * @return {?}
         */
        function () {
            _this.page = 1;
            _this.getRecords();
        }));
        this.page = 1;
        this.rowsPerPageOptions = [10, 25, 50, 100, 500, 1000];
        this.restList = new DataList(entity);
        if (entity)
            this.filterHelper.filterRow = entity.source.createNewItem();
        this.columns = new ColumnCollection((/**
         * @return {?}
         */
        function () { return _this.currentRow; }), (/**
         * @return {?}
         */
        function () { return _this.allowUpdate; }), this.filterHelper, (/**
         * @return {?}
         */
        function () { return _this.currentRow ? true : false; }));
        this.restList._rowReplacedListeners.push((/**
         * @param {?} old
         * @param {?} curr
         * @return {?}
         */
        function (old, curr) {
            if (old == _this.currentRow)
                _this.setCurrentRow(curr);
        }));
        if (settings) {
            if (settings.columnSettings)
                (_a = this.columns).add.apply(_a, __spread(settings.columnSettings(entity)));
            if (settings.allowUpdate)
                this.allowUpdate = true;
            if (settings.allowDelete)
                this.allowDelete = true;
            if (settings.allowInsert)
                this.allowInsert = true;
            if (settings.hideDataArea)
                this.hideDataArea = settings.hideDataArea;
            if (settings.numOfColumnsInGrid != undefined)
                this.columns.numOfColumnsInGrid = settings.numOfColumnsInGrid;
            if (settings.rowButtons)
                this._buttons = settings.rowButtons;
            if (settings.rowCssClass)
                this.rowClass = settings.rowCssClass;
            if (settings.onSavingRow)
                this.onSavingRow = settings.onSavingRow;
            if (settings.onEnterRow)
                this.onEnterRow = settings.onEnterRow;
            if (settings.onNewRow)
                this.onNewRow = settings.onNewRow;
            if (settings.onValidate)
                this.onValidate = settings.onValidate;
            if (settings.caption)
                this.caption = settings.caption;
            if (!this.caption && entity) {
                this.caption = entity.source.createNewItem().__getCaption();
            }
            this.setGetOptions(settings.get);
        }
    }
    /**
     * @return {?}
     */
    GridSettings.prototype.initOrigList = /**
     * @return {?}
     */
    function () {
        var _a;
        if (!this.origList) {
            this.origList = [];
            this.origNumOfColumns = this.columns.numOfColumnsInGrid;
            (_a = this.origList).push.apply(_a, __spread(this.columns.items));
        }
    };
    /**
     * @return {?}
     */
    GridSettings.prototype.userChooseColumns = /**
     * @return {?}
     */
    function () {
        this.initOrigList();
        if (!this.currList) {
            this.resetColumns();
        }
        this.showSelectColumn = !this.showSelectColumn;
    };
    /**
     * @return {?}
     */
    GridSettings.prototype.resetColumns = /**
     * @return {?}
     */
    function () {
        this.currList = [];
        this.columns.items = this.currList;
        this.columns.numOfColumnsInGrid = this.origNumOfColumns;
        for (var i = 0; i < this.origList.length; i++) {
            if (i < this.columns.numOfColumnsInGrid)
                this.currList.push(this.origList[i]);
        }
    };
    /**
     * @param {?} c
     * @return {?}
     */
    GridSettings.prototype.addCol = /**
     * @param {?} c
     * @return {?}
     */
    function (c) {
        this.columns.addCol(c);
        this.adjustColumns();
    };
    /**
     * @param {?} c
     * @return {?}
     */
    GridSettings.prototype.deleteCol = /**
     * @param {?} c
     * @return {?}
     */
    function (c) {
        this.columns.deleteCol(c);
        this.adjustColumns();
    };
    /**
     * @return {?}
     */
    GridSettings.prototype.adjustColumns = /**
     * @return {?}
     */
    function () {
        this.columns.items.forEach((/**
         * @param {?} c
         * @return {?}
         */
        function (c) { return c.designMode = false; }));
        this.columns.numOfColumnsInGrid = this.columns.items.length;
    };
    /**
     * @private
     * @param {?} get
     * @return {?}
     */
    GridSettings.prototype.setGetOptions = /**
     * @private
     * @param {?} get
     * @return {?}
     */
    function (get) {
        this.getOptions = get;
        if (get && get.limit)
            this.rowsPerPage = get.limit;
        else
            this.rowsPerPage = 7;
        if (this.rowsPerPageOptions.indexOf(this.rowsPerPage) < 0) {
            this.rowsPerPageOptions.push(this.rowsPerPage);
            this.rowsPerPageOptions.sort((/**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */
            function (a, b) { return +a - +b; }));
        }
        this._currentOrderBy = undefined;
        if (this.getOptions && this.getOptions.orderBy)
            this._currentOrderBy = extractSortFromSettings(this.entity, this.getOptions);
    };
    /**
     * @return {?}
     */
    GridSettings.prototype.addNewRow = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var r = this.restList.add();
        this.columns.items.forEach((/**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            if (item.defaultValue) {
                /** @type {?} */
                var result = item.defaultValue(r);
            }
        }));
        if (this.onNewRow)
            this.onNewRow(r);
        this.setCurrentRow(r);
    };
    /**
     * @param {?} settings
     * @return {?}
     */
    GridSettings.prototype.addArea = /**
     * @param {?} settings
     * @return {?}
     */
    function (settings) {
        var _this = this;
        /** @type {?} */
        var col = new ColumnCollection((/**
         * @return {?}
         */
        function () { return _this.currentRow; }), (/**
         * @return {?}
         */
        function () { return _this.allowUpdate; }), this.filterHelper, (/**
         * @return {?}
         */
        function () { return _this.currentRow ? true : false; }));
        col.numOfColumnsInGrid = 0;
        return new DataAreaSettings(settings, col, this.entity);
    };
    /**
     * @param {?} row
     * @return {?}
     */
    GridSettings.prototype.setCurrentRow = /**
     * @param {?} row
     * @return {?}
     */
    function (row) {
        if (this.currentRow != row) {
            this.currentRow = row;
            if (this.onEnterRow && row) {
                this.onEnterRow(row);
            }
        }
    };
    /**
     * @return {?}
     */
    GridSettings.prototype.nextRow = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (!this.currentRow && this.items.length > 0)
            this.setCurrentRow(this.items[0]);
        if (this.currentRow) {
            /** @type {?} */
            var currentRowPosition = this.items.indexOf(this.currentRow);
            if (currentRowPosition < this.items.length - 1)
                this.setCurrentRow(this.items[currentRowPosition + 1]);
            else
                this.nextPage().then((/**
                 * @return {?}
                 */
                function () {
                    if (_this.items.length > 0)
                        _this.setCurrentRow(_this.items[0]);
                }));
        }
    };
    /**
     * @return {?}
     */
    GridSettings.prototype.previousRowAllowed = /**
     * @return {?}
     */
    function () {
        return this.currentRow && this.items.indexOf(this.currentRow) > 0 || this.page > 1;
    };
    /**
     * @return {?}
     */
    GridSettings.prototype.previousRow = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (!this.previousRowAllowed())
            return;
        /** @type {?} */
        var currentRowPosition = this.items.indexOf(this.currentRow);
        if (currentRowPosition > 0)
            this.setCurrentRow(this.items[currentRowPosition - 1]);
        else {
            if (this.page > 1)
                this.previousPage().then((/**
                 * @return {?}
                 */
                function () {
                    if (_this.items.length > 0)
                        _this.setCurrentRow(_this.items[_this.items.length - 1]);
                }));
        }
    };
    /**
     * @return {?}
     */
    GridSettings.prototype.deleteCurentRow = /**
     * @return {?}
     */
    function () {
        if (!this.deleteCurrentRowAllowed)
            return;
        this.currentRowAsRestListItemRow().delete();
    };
    /**
     * @return {?}
     */
    GridSettings.prototype.currentRowAsRestListItemRow = /**
     * @return {?}
     */
    function () {
        if (!this.currentRow)
            return undefined;
        return (/** @type {?} */ (this.currentRow));
    };
    /**
     * @return {?}
     */
    GridSettings.prototype.cancelCurrentRowChanges = /**
     * @return {?}
     */
    function () {
        if (this.currentRowAsRestListItemRow() && this.currentRowAsRestListItemRow().reset)
            this.currentRowAsRestListItemRow().reset();
    };
    /**
     * @return {?}
     */
    GridSettings.prototype.deleteCurrentRowAllowed = /**
     * @return {?}
     */
    function () {
        return this.currentRowAsRestListItemRow() && this.currentRowAsRestListItemRow().delete && this.allowDelete && !isNewRow(this.currentRow);
    };
    /**
     * @return {?}
     */
    GridSettings.prototype.currentRowChanged = /**
     * @return {?}
     */
    function () {
        return this.currentRowAsRestListItemRow() && this.currentRowAsRestListItemRow().__wasChanged && this.currentRowAsRestListItemRow().__wasChanged();
    };
    /**
     * @return {?}
     */
    GridSettings.prototype.saveCurrentRow = /**
     * @return {?}
     */
    function () {
        if (this.currentRowAsRestListItemRow() && this.currentRowAsRestListItemRow().save)
            this.currentRowAsRestListItemRow().save();
    };
    /**
     * @param {?} s
     * @return {?}
     */
    GridSettings.prototype._doSavingRow = /**
     * @param {?} s
     * @return {?}
     */
    function (s) {
        return s.save(this.onValidate, this.onSavingRow);
    };
    /**
     * @return {?}
     */
    GridSettings.prototype.nextPage = /**
     * @return {?}
     */
    function () {
        this.page++;
        return this.getRecords();
    };
    /**
     * @return {?}
     */
    GridSettings.prototype.previousPage = /**
     * @return {?}
     */
    function () {
        if (this.page <= 1)
            return;
        this.page--;
        return this.getRecords();
    };
    /**
     * @return {?}
     */
    GridSettings.prototype.firstPage = /**
     * @return {?}
     */
    function () {
        this.page = 1;
        return this.getRecords();
    };
    /**
     * @param {?} options
     * @return {?}
     */
    GridSettings.prototype.get = /**
     * @param {?} options
     * @return {?}
     */
    function (options) {
        this.setGetOptions(options);
        this.page = 1;
        return this.getRecords();
    };
    /**
     * @param {?} column
     * @return {?}
     */
    GridSettings.prototype.sort = /**
     * @param {?} column
     * @return {?}
     */
    function (column) {
        /** @type {?} */
        var done = false;
        if (this._currentOrderBy && this._currentOrderBy.Segments.length > 0) {
            if (this._currentOrderBy.Segments[0].column == column) {
                this._currentOrderBy.Segments[0].descending = !this._currentOrderBy.Segments[0].descending;
                done = true;
            }
        }
        if (!done)
            this._currentOrderBy = new Sort({ column: column });
        this.getRecords();
    };
    /**
     * @param {?} column
     * @return {?}
     */
    GridSettings.prototype.sortedAscending = /**
     * @param {?} column
     * @return {?}
     */
    function (column) {
        if (!this._currentOrderBy)
            return false;
        if (!column)
            return false;
        return this._currentOrderBy.Segments.length > 0 &&
            this._currentOrderBy.Segments[0].column == column &&
            !this._currentOrderBy.Segments[0].descending;
    };
    /**
     * @param {?} column
     * @return {?}
     */
    GridSettings.prototype.sortedDescending = /**
     * @param {?} column
     * @return {?}
     */
    function (column) {
        if (!this._currentOrderBy)
            return false;
        if (!column)
            return false;
        return this._currentOrderBy.Segments.length > 0 &&
            this._currentOrderBy.Segments[0].column == column &&
            !!this._currentOrderBy.Segments[0].descending;
    };
    /**
     * @return {?}
     */
    GridSettings.prototype.getRecords = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var opt = {};
        if (this.getOptions) {
            opt = Object.assign(opt, this.getOptions);
        }
        if (this._currentOrderBy)
            opt.orderBy = (/**
             * @param {?} r
             * @return {?}
             */
            function (r) { return _this._currentOrderBy; });
        opt.limit = this.rowsPerPage;
        if (this.page > 1)
            opt.page = this.page;
        this.filterHelper.addToFindOptions(opt);
        /** @type {?} */
        var result = this.restList.get(opt).then((/**
         * @return {?}
         */
        function () {
            if (_this.restList.items.length == 0) {
                _this.setCurrentRow(undefined);
                _this.columns.autoGenerateColumnsBasedOnData(_this.entity);
            }
            else {
                _this.setCurrentRow(_this.restList.items[0]);
                _this.columns.autoGenerateColumnsBasedOnData(_this.entity);
            }
            return _this.restList;
        }));
        if (this.settings && this.settings.knowTotalRows) {
            this.restList.count(opt.where).then((/**
             * @param {?} x
             * @return {?}
             */
            function (x) {
                _this.totalRows = x;
            }));
        }
        return result;
    };
    Object.defineProperty(GridSettings.prototype, "items", {
        get: /**
         * @return {?}
         */
        function () {
            if (this.restList)
                return this.restList.items;
            return undefined;
        },
        enumerable: true,
        configurable: true
    });
    return GridSettings;
}());
/**
 * @template rowType
 */
var  /**
 * @template rowType
 */
FilterHelper = /** @class */ (function () {
    function FilterHelper(reloadData) {
        this.reloadData = reloadData;
        this.filterColumns = [];
        this.forceEqual = [];
    }
    /**
     * @param {?} column
     * @return {?}
     */
    FilterHelper.prototype.isFiltered = /**
     * @param {?} column
     * @return {?}
     */
    function (column) {
        return this.filterColumns.indexOf(column) >= 0;
    };
    /**
     * @param {?} column
     * @param {?} clearFilter
     * @param {?} forceEqual
     * @return {?}
     */
    FilterHelper.prototype.filterColumn = /**
     * @param {?} column
     * @param {?} clearFilter
     * @param {?} forceEqual
     * @return {?}
     */
    function (column, clearFilter, forceEqual) {
        if (!column)
            return;
        if (clearFilter) {
            this.filterColumns.splice(this.filterColumns.indexOf(column, 1), 1);
            this.forceEqual.splice(this.forceEqual.indexOf(column, 1), 1);
        }
        else if (this.filterColumns.indexOf(column) < 0) {
            this.filterColumns.push(column);
            if (forceEqual)
                this.forceEqual.push(column);
        }
        this.reloadData();
    };
    /**
     * @param {?} opt
     * @return {?}
     */
    FilterHelper.prototype.addToFindOptions = /**
     * @param {?} opt
     * @return {?}
     */
    function (opt) {
        var _this = this;
        this.filterColumns.forEach((/**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            /** @type {?} */
            var val = _this.filterRow.__getColumn(c).value;
            /** @type {?} */
            var f = c.isEqualTo(val);
            if (c instanceof StringColumn) {
                /** @type {?} */
                var fe = _this.forceEqual;
                if (fe.indexOf(c) < 0)
                    f = c.isContains(val);
            }
            if (c instanceof DateTimeColumn) {
                if (val) {
                    /** @type {?} */
                    var v = DateTimeColumn.stringToDate(val);
                    v = new Date(v.getFullYear(), v.getMonth(), v.getDate());
                    f = c.isGreaterOrEqualTo(v).and(c.isLessThan((new Date(v.getFullYear(), v.getMonth(), v.getDate() + 1))));
                }
            }
            if (opt.where) {
                /** @type {?} */
                var x_1 = opt.where;
                opt.where = (/**
                 * @param {?} r
                 * @return {?}
                 */
                function (r) { return new AndFilter(x_1(r), f); });
            }
            else
                opt.where = (/**
                 * @param {?} r
                 * @return {?}
                 */
                function (r) { return f; });
        }));
    };
    return FilterHelper;
}());
/**
 * @param {?} r
 * @return {?}
 */
function isNewRow(r) {
    if (r) {
        r.__entityData.isNewRow();
    }
    return false;
}
/**
 * @template T
 */
var  /**
 * @template T
 */
DataList = /** @class */ (function () {
    function DataList(entity) {
        this.entity = entity;
        this.items = [];
        this._rowReplacedListeners = [];
        this.lastGetId = 0;
    }
    /**
     * @return {?}
     */
    DataList.prototype[Symbol.iterator] = /**
     * @return {?}
     */
    function () {
        return this.items[Symbol.iterator]();
    };
    /**
     * @param {?} options
     * @return {?}
     */
    DataList.prototype.translateOptions = /**
     * @param {?} options
     * @return {?}
     */
    function (options) {
        if (!options)
            return undefined;
        /** @type {?} */
        var getOptions = {};
        if (options.where)
            getOptions.where = options.where(this.entity);
        if (options.orderBy)
            getOptions.orderBy = extractSortFromSettings(this.entity, options);
        if (options.limit)
            getOptions.limit = options.limit;
        if (options.page)
            getOptions.page = options.page;
        if (options.additionalUrlParameters)
            getOptions.additionalUrlParameters = options.additionalUrlParameters;
        return getOptions;
    };
    /**
     * @private
     * @param {?} item
     * @return {?}
     */
    DataList.prototype.map = /**
     * @private
     * @param {?} item
     * @return {?}
     */
    function (item) {
        var _this = this;
        item.__entityData.register({
            rowReset: (/**
             * @param {?} newRow
             * @return {?}
             */
            function (newRow) {
                if (newRow)
                    _this.items.splice(_this.items.indexOf(item), 1);
            }),
            rowDeleted: (/**
             * @return {?}
             */
            function () { _this.items.splice(_this.items.indexOf(item), 1); })
        });
        return item;
    };
    /**
     * @param {?=} where
     * @return {?}
     */
    DataList.prototype.count = /**
     * @param {?=} where
     * @return {?}
     */
    function (where) {
        /** @type {?} */
        var w = undefined;
        if (where)
            w = where(this.entity);
        return this.entity.source.count(w);
    };
    /**
     * @param {?=} options
     * @return {?}
     */
    DataList.prototype.get = /**
     * @param {?=} options
     * @return {?}
     */
    function (options) {
        var _this = this;
        /** @type {?} */
        var getId = ++this.lastGetId;
        return this.entity.source.find(this.translateOptions(options)).then((/**
         * @param {?} r
         * @return {?}
         */
        function (r) {
            /** @type {?} */
            var result = r.map((/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return _this.map(x); }));
            if (getId == _this.lastGetId)
                _this.items = result;
            return result;
        }));
    };
    /**
     * @return {?}
     */
    DataList.prototype.add = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var x = this.map(this.entity.source.createNewItem());
        this.items.push(x);
        return x;
    };
    /**
     * @private
     * @param {?} originalRow
     * @param {?} newRow
     * @return {?}
     */
    DataList.prototype.replaceRow = /**
     * @private
     * @param {?} originalRow
     * @param {?} newRow
     * @return {?}
     */
    function (originalRow, newRow) {
        newRow = this.map(newRow);
        this.items[this.items.indexOf(originalRow)] = newRow;
        this._rowReplacedListeners.forEach((/**
         * @param {?} x
         * @return {?}
         */
        function (x) { return x(originalRow, newRow); }));
    };
    return DataList;
}());
var Sort = /** @class */ (function () {
    function Sort() {
        var segments = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            segments[_i] = arguments[_i];
        }
        this.Segments = segments;
    }
    return Sort;
}());
/**
 * @template lookupIdType, entityType
 */
var  /**
 * @template lookupIdType, entityType
 */
Lookup = /** @class */ (function () {
    function Lookup(entity) {
        this.entity = entity;
        this.cache = {};
        this.restList = new DataList(entity);
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    Lookup.prototype.get = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        return this.getInternal(filter).value;
    };
    /**
     * @param {?} filter
     * @return {?}
     */
    Lookup.prototype.found = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        return this.getInternal(filter).found;
    };
    /**
     * @private
     * @param {?} filter
     * @return {?}
     */
    Lookup.prototype.getInternal = /**
     * @private
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        /** @type {?} */
        var find = {};
        if (filter instanceof Column)
            find.where = (/**
             * @param {?} e
             * @return {?}
             */
            function (e) { return e.__idColumn.isEqualTo(filter); });
        else if (isFunction$1(filter)) {
            find.where = (/**
             * @param {?} e
             * @return {?}
             */
            function (e) { return filter(e); });
        }
        return this._internalGetByOptions(find);
    };
    /**
     * @param {?} find
     * @return {?}
     */
    Lookup.prototype._internalGetByOptions = /**
     * @param {?} find
     * @return {?}
     */
    function (find) {
        /** @type {?} */
        var key = "";
        /** @type {?} */
        var url = new UrlBuilder("");
        if (find.where)
            find.where(this.entity).__applyToConsumer(new FilterConsumnerBridgeToUrlBuilder(url));
        key = url.url;
        if (this.cache == undefined)
            this.cache = {};
        if (this.cache[key]) {
            return this.cache[key];
        }
        else {
            /** @type {?} */
            var res_1 = new lookupRowInfo();
            this.cache[key] = res_1;
            if (find == undefined || key == undefined) {
                res_1.loading = false;
                res_1.found = false;
                return res_1;
            }
            else {
                res_1.value = this.entity.source.createNewItem();
                res_1.promise = this.restList.get(find).then((/**
                 * @param {?} r
                 * @return {?}
                 */
                function (r) {
                    res_1.loading = false;
                    if (r.length > 0) {
                        res_1.value = r[0];
                        res_1.found = true;
                    }
                    return res_1;
                }));
            }
            return res_1;
        }
    };
    /**
     * @param {?} filter
     * @return {?}
     */
    Lookup.prototype.whenGet = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        return this.getInternal(filter).promise.then((/**
         * @param {?} r
         * @return {?}
         */
        function (r) { return r.value; }));
    };
    return Lookup;
}());
var UrlBuilder = /** @class */ (function () {
    function UrlBuilder(url) {
        this.url = url;
    }
    /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    UrlBuilder.prototype.add = /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    function (key, value) {
        if (this.url.indexOf('?') >= 0)
            this.url += '&';
        else
            this.url += '?';
        this.url += encodeURIComponent(key) + '=' + encodeURIComponent(value);
    };
    /**
     * @param {?} object
     * @param {?=} suffix
     * @return {?}
     */
    UrlBuilder.prototype.addObject = /**
     * @param {?} object
     * @param {?=} suffix
     * @return {?}
     */
    function (object, suffix) {
        if (suffix === void 0) { suffix = ''; }
        if (object != undefined)
            for (var key in object) {
                /** @type {?} */
                var val = object[key];
                if (val instanceof Column)
                    val = val.value;
                this.add(key + suffix, val);
            }
    };
    return UrlBuilder;
}());
var FilterConsumnerBridgeToUrlBuilder = /** @class */ (function () {
    function FilterConsumnerBridgeToUrlBuilder(url) {
        this.url = url;
    }
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumnerBridgeToUrlBuilder.prototype.isEqualTo = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        this.url.add(col.jsonName, val);
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumnerBridgeToUrlBuilder.prototype.isDifferentFrom = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        this.url.add(col.jsonName + '_ne', val);
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumnerBridgeToUrlBuilder.prototype.isGreaterOrEqualTo = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        this.url.add(col.jsonName + '_gte', val);
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumnerBridgeToUrlBuilder.prototype.isGreaterThan = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        this.url.add(col.jsonName + '_gt', val);
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumnerBridgeToUrlBuilder.prototype.isLessOrEqualTo = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        this.url.add(col.jsonName + '_lte', val);
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumnerBridgeToUrlBuilder.prototype.isLessThan = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        this.url.add(col.jsonName + '_lt', val);
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumnerBridgeToUrlBuilder.prototype.isContains = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        this.url.add(col.jsonName + "_contains", val);
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumnerBridgeToUrlBuilder.prototype.isStartsWith = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        this.url.add(col.jsonName + "_st", val);
    };
    return FilterConsumnerBridgeToUrlBuilder;
}());
/**
 * @template type
 */
var  /**
 * @template type
 */
lookupRowInfo = /** @class */ (function () {
    function lookupRowInfo() {
        this.found = false;
        this.loading = true;
        this.value = (/** @type {?} */ ({}));
    }
    return lookupRowInfo;
}());
/**
 * @template dataType
 */
var  /**
 * @template dataType
 */
DefaultStorage = /** @class */ (function () {
    function DefaultStorage() {
    }
    /**
     * @param {?} val
     * @return {?}
     */
    DefaultStorage.prototype.toDb = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        return val;
    };
    /**
     * @param {?} val
     * @return {?}
     */
    DefaultStorage.prototype.fromDb = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        return val;
    };
    return DefaultStorage;
}());
var DateTimeDateStorage = /** @class */ (function () {
    function DateTimeDateStorage() {
    }
    /**
     * @param {?} val
     * @return {?}
     */
    DateTimeDateStorage.prototype.toDb = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        return DateColumn.stringToDate(val);
    };
    /**
     * @param {?} val
     * @return {?}
     */
    DateTimeDateStorage.prototype.fromDb = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        /** @type {?} */
        var d = (/** @type {?} */ (val));
        return DateColumn.dateToString(d);
    };
    return DateTimeDateStorage;
}());
var CharDateStorage = /** @class */ (function () {
    function CharDateStorage() {
    }
    /**
     * @param {?} val
     * @return {?}
     */
    CharDateStorage.prototype.toDb = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        return val.replace(/-/g, '');
    };
    /**
     * @param {?} val
     * @return {?}
     */
    CharDateStorage.prototype.fromDb = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        return val.substring(0, 4) + '-' + val.substring(4, 6) + '-' + val.substring(6, 8);
    };
    return CharDateStorage;
}());
var DateTimeStorage = /** @class */ (function () {
    function DateTimeStorage() {
    }
    /**
     * @param {?} val
     * @return {?}
     */
    DateTimeStorage.prototype.toDb = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        return DateTimeColumn.stringToDate(val);
    };
    /**
     * @param {?} val
     * @return {?}
     */
    DateTimeStorage.prototype.fromDb = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        /** @type {?} */
        var d = (/** @type {?} */ (val));
        return DateTimeColumn.dateToString(d);
    };
    return DateTimeStorage;
}());
/**
 * @param {?} number
 * @param {?=} stringLength
 * @return {?}
 */
function addZeros(number, stringLength) {
    if (stringLength === void 0) { stringLength = 2; }
    /** @type {?} */
    var to = number.toString();
    while (to.length < stringLength)
        to = '0' + to;
    return to;
}
/**
 * @template dataType
 */
var  /**
 * @template dataType
 */
Column = /** @class */ (function () {
    function Column(settingsOrCaption) {
        var _this = this;
        this.includeInApi = true;
        this.allowApiUpdate = true;
        this.__valueProvider = new dummyColumnStorage();
        if (settingsOrCaption) {
            if (typeof (settingsOrCaption) === "string") {
                this.caption = settingsOrCaption;
                this.__settings = { caption: settingsOrCaption };
            }
            else {
                this.__settings = settingsOrCaption;
                if (settingsOrCaption.jsonName)
                    this.jsonName = settingsOrCaption.jsonName;
                if (settingsOrCaption.caption)
                    this.caption = settingsOrCaption.caption;
                if (settingsOrCaption.includeInApi != undefined)
                    this.includeInApi = settingsOrCaption.includeInApi;
                if (settingsOrCaption.allowApiUpdate != undefined)
                    this.allowApiUpdate = settingsOrCaption.allowApiUpdate;
                if (settingsOrCaption.inputType)
                    this.inputType = settingsOrCaption.inputType;
                if (settingsOrCaption.dbName)
                    this.dbName = settingsOrCaption.dbName;
                if (settingsOrCaption.value != undefined)
                    this.value = settingsOrCaption.value;
                if (settingsOrCaption.valueChange)
                    this.onValueChange = (/**
                     * @return {?}
                     */
                    function () { return _this.__settings.valueChange(_this.value); });
                if (settingsOrCaption.onValidate)
                    this.onValidate = (/**
                     * @return {?}
                     */
                    function () { return settingsOrCaption.onValidate(); });
            }
        }
    }
    /**
     * @return {?}
     */
    Column.prototype.__calcVirtuals = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var x;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.__settings && this.__settings.virtualData)) return [3 /*break*/, 3];
                        x = this.__settings.virtualData();
                        if (!(x instanceof Promise)) return [3 /*break*/, 2];
                        return [4 /*yield*/, x];
                    case 1:
                        x = _a.sent();
                        _a.label = 2;
                    case 2:
                        this.value = x;
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} e
     * @return {?}
     */
    Column.prototype.__setEntity = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        this._entity = e;
    };
    /**
     * @return {?}
     */
    Column.prototype.__isVirtual = /**
     * @return {?}
     */
    function () {
        if (this.__settings && this.__settings.virtualData)
            return true;
        return false;
    };
    /**
     * @return {?}
     */
    Column.prototype.__dbReadOnly = /**
     * @return {?}
     */
    function () {
        if (this.__settings && this.__settings.dbReadOnly)
            return true;
        return this.__isVirtual();
    };
    /**
     * @return {?}
     */
    Column.prototype.__clearErrors = /**
     * @return {?}
     */
    function () {
        this.error = undefined;
    };
    /**
     * @return {?}
     */
    Column.prototype.__performValidation = /**
     * @return {?}
     */
    function () {
        if (this.onValidate) {
            this.onValidate();
        }
    };
    /**
     * @return {?}
     */
    Column.prototype.__getMemberName = /**
     * @return {?}
     */
    function () { return this.jsonName; };
    /**
     * @param {?} x
     * @return {?}
     */
    Column.prototype.__decorateDataSettings = /**
     * @param {?} x
     * @return {?}
     */
    function (x) {
        var _this = this;
        if (!x.caption && this.caption)
            x.caption = this.caption;
        if (x.readonly == undefined)
            if (this._entity)
                x.readonly = !this._entity.__getApiAllowUpdate(this.allowApiUpdate);
        if (x.inputType == undefined)
            x.inputType = this.inputType;
        if (x.getValue == undefined) {
            if (this.__settings && this.__settings.getValue)
                x.getValue = (/**
                 * @param {?} e
                 * @return {?}
                 */
                function (e) {
                    /** @type {?} */
                    var c = _this;
                    if (e)
                        c = (/** @type {?} */ (e.__getColumn(c)));
                    return c.__settings.getValue(c.value);
                });
        }
    };
    /**
     * @return {?}
     */
    Column.prototype.__getStorage = /**
     * @return {?}
     */
    function () {
        if (!this.__settings)
            this.__settings = {};
        if (!this.__settings.storage)
            this.__settings.storage = this.__defaultStorage();
        return this.__settings.storage;
    };
    /**
     * @return {?}
     */
    Column.prototype.__defaultStorage = /**
     * @return {?}
     */
    function () {
        return new DefaultStorage();
    };
    /**
     * @return {?}
     */
    Column.prototype.__getDbName = /**
     * @return {?}
     */
    function () {
        if (this.dbName)
            return functionOrString(this.dbName);
        return this.jsonName;
    };
    /**
     * @param {?} value
     * @return {?}
     */
    Column.prototype.isEqualTo = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        return new Filter((/**
         * @param {?} add
         * @return {?}
         */
        function (add) { return add.isEqualTo(_this, _this.__getVal(value)); }));
    };
    /**
     * @param {?} value
     * @return {?}
     */
    Column.prototype.isDifferentFrom = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        return new Filter((/**
         * @param {?} add
         * @return {?}
         */
        function (add) { return add.isDifferentFrom(_this, _this.__getVal(value)); }));
    };
    /**
     * @param {?} value
     * @return {?}
     */
    Column.prototype.isGreaterOrEqualTo = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        return new Filter((/**
         * @param {?} add
         * @return {?}
         */
        function (add) { return add.isGreaterOrEqualTo(_this, _this.__getVal(value)); }));
    };
    /**
     * @param {?} value
     * @return {?}
     */
    Column.prototype.isGreaterThan = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        return new Filter((/**
         * @param {?} add
         * @return {?}
         */
        function (add) { return add.isGreaterThan(_this, _this.__getVal(value)); }));
    };
    /**
     * @param {?} value
     * @return {?}
     */
    Column.prototype.isLessOrEqualTo = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        return new Filter((/**
         * @param {?} add
         * @return {?}
         */
        function (add) { return add.isLessOrEqualTo(_this, _this.__getVal(value)); }));
    };
    /**
     * @param {?} value
     * @return {?}
     */
    Column.prototype.isLessThan = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        return new Filter((/**
         * @param {?} add
         * @return {?}
         */
        function (add) { return add.isLessThan(_this, _this.__getVal(value)); }));
    };
    /**
     * @param {?} value
     * @return {?}
     */
    Column.prototype.__getVal = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        if (value instanceof Column)
            return this.toRawValue(value.value);
        else
            return this.toRawValue(value);
    };
    Object.defineProperty(Column.prototype, "value", {
        get: /**
         * @return {?}
         */
        function () {
            return this.fromRawValue(this.rawValue);
        },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.rawValue = this.toRawValue(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "originalValue", {
        get: /**
         * @return {?}
         */
        function () {
            return this.fromRawValue(this.__valueProvider.getOriginalValue(this.jsonName));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "displayValue", {
        get: /**
         * @return {?}
         */
        function () {
            if (this.value)
                return this.value.toString();
            return '';
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @protected
     * @param {?} value
     * @return {?}
     */
    Column.prototype.__processValue = /**
     * @protected
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return value;
    };
    /**
     * @param {?} value
     * @return {?}
     */
    Column.prototype.fromRawValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return value;
    };
    /**
     * @param {?} value
     * @return {?}
     */
    Column.prototype.toRawValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return value;
    };
    Object.defineProperty(Column.prototype, "rawValue", {
        get: /**
         * @return {?}
         */
        function () {
            return this.__valueProvider.getValue(this.jsonName);
        },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.__valueProvider.setValue(this.jsonName, this.__processValue(value));
            this.error = undefined;
            if (this.onValueChange)
                this.onValueChange();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Column.prototype, "inputValue", {
        get: /**
         * @return {?}
         */
        function () {
            return this.rawValue;
        },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.rawValue = value;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} pojo
     * @return {?}
     */
    Column.prototype.__addToPojo = /**
     * @param {?} pojo
     * @return {?}
     */
    function (pojo) {
        pojo[this.jsonName] = this.rawValue;
    };
    /**
     * @param {?} pojo
     * @return {?}
     */
    Column.prototype.__loadFromToPojo = /**
     * @param {?} pojo
     * @return {?}
     */
    function (pojo) {
        /** @type {?} */
        var x = pojo[this.jsonName];
        if (x != undefined)
            this.rawValue = x;
    };
    return Column;
}());
var dummyColumnStorage = /** @class */ (function () {
    function dummyColumnStorage() {
    }
    /**
     * @param {?} key
     * @return {?}
     */
    dummyColumnStorage.prototype.getValue = /**
     * @param {?} key
     * @return {?}
     */
    function (key) {
        return this._val;
    };
    /**
     * @param {?} key
     * @return {?}
     */
    dummyColumnStorage.prototype.getOriginalValue = /**
     * @param {?} key
     * @return {?}
     */
    function (key) {
        return this._val;
    };
    /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    dummyColumnStorage.prototype.setValue = /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    function (key, value) {
        this._val = value;
    };
    return dummyColumnStorage;
}());
var Filter = /** @class */ (function () {
    function Filter(apply) {
        this.apply = apply;
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    Filter.prototype.and = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        return new AndFilter(this, filter);
    };
    /**
     * @param {?} add
     * @return {?}
     */
    Filter.prototype.__applyToConsumer = /**
     * @param {?} add
     * @return {?}
     */
    function (add) {
        this.apply(add);
    };
    return Filter;
}());
var AndFilter = /** @class */ (function () {
    function AndFilter(a, b) {
        this.a = a;
        this.b = b;
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    AndFilter.prototype.and = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        return new AndFilter(this, filter);
    };
    /**
     * @param {?} add
     * @return {?}
     */
    AndFilter.prototype.__applyToConsumer = /**
     * @param {?} add
     * @return {?}
     */
    function (add) {
        if (this.a)
            this.a.__applyToConsumer(add);
        if (this.b)
            this.b.__applyToConsumer(add);
    };
    return AndFilter;
}());
//@dynamic
/**
 * @template idType
 */
var  
//@dynamic
/**
 * @template idType
 */
Entity = /** @class */ (function () {
    function Entity(options, factory) {
        var _this = this;
        this.factory = factory;
        //@internal
        this.__onSavingRow = (/**
         * @return {?}
         */
        function () { });
        //@internal
        this.__onValidate = (/**
         * @return {?}
         */
        function () { });
        //@internal
        this.__columns = [];
        if (!factory) {
            this.factory = (/**
             * @return {?}
             */
            function () { return _this.__createInstance(); });
        }
        if (options) {
            if (typeof (options) === "string") {
                this.__options = { name: options };
            }
            else {
                this.__options = options;
                if (options.onSavingRow)
                    this.__onSavingRow = (/**
                     * @return {?}
                     */
                    function () { return options.onSavingRow(); });
                if (options.onValidate)
                    this.__onValidate = (/**
                     * @return {?}
                     */
                    function () { return options.onValidate(_this); });
            }
        }
        else {
            this.__options = {
                name: undefined
            };
        }
        this.__entityData = new __EntityValueProvider((/**
         * @return {?}
         */
        function () { return _this.source.__getDataProvider(); }));
        this._noContextErrorWithStack = new Error('@EntityClass not used or context was not set for ' + this.constructor.name);
    }
    /**
     * @param {?} context
     * @return {?}
     */
    Entity.prototype._setContext = /**
     * @param {?} context
     * @return {?}
     */
    function (context) {
        this.__context = context;
    };
    /**
     * @param {?} allowed
     * @return {?}
     */
    Entity.prototype.__getApiAllowUpdate = /**
     * @param {?} allowed
     * @return {?}
     */
    function (allowed) {
        if (!this.__context && isBoolean(allowed))
            return allowed;
        return this.__context.isAllowed(allowed);
    };
    /**
     * @param {?} entityType
     * @return {?}
     */
    Entity.prototype._setFactoryClassAndDoInitColumns = /**
     * @param {?} entityType
     * @return {?}
     */
    function (entityType) {
        this.__entityType = entityType;
        this.__initColumns(((/** @type {?} */ (this))).id);
    };
    /**
     * @param {?} x
     * @param {?} context
     * @return {?}
     */
    Entity.prototype._getExcludedColumns = /**
     * @param {?} x
     * @param {?} context
     * @return {?}
     */
    function (x, context) {
        /** @type {?} */
        var r = x.__iterateColumns().filter((/**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            return !context.isAllowed(c.includeInApi);
        }));
        return r;
    };
    /**
     * @param {?} r
     * @return {?}
     */
    Entity.prototype._getEntityApiSettings = /**
     * @param {?} r
     * @return {?}
     */
    function (r) {
        var _this = this;
        /** @type {?} */
        var x = (/** @type {?} */ (r.for(this.__entityType).create()));
        /** @type {?} */
        var options = x.__options;
        if (options.allowApiCRUD) {
            options.allowApiDelete = true;
            options.allowApiInsert = true;
            options.allowApiUpdate = true;
        }
        return {
            allowRead: r.isAllowed(options.allowApiRead),
            allowUpdate: r.isAllowed(options.allowApiUpdate),
            allowDelete: r.isAllowed(options.allowApiDelete),
            allowInsert: r.isAllowed(options.allowApiInsert),
            excludeColumns: (/**
             * @param {?} x
             * @return {?}
             */
            function (x) {
                return _this._getExcludedColumns(x, r);
            }),
            readonlyColumns: (/**
             * @param {?} x
             * @return {?}
             */
            function (x) {
                return x.__iterateColumns().filter((/**
                 * @param {?} c
                 * @return {?}
                 */
                function (c) { return !r.isAllowed(c.allowApiUpdate); }));
            }),
            get: {
                where: (/**
                 * @param {?} x
                 * @return {?}
                 */
                function (x) { return options.apiDataFilter ? options.apiDataFilter() : undefined; })
            }
        };
    };
    //@internal
    //@internal
    /**
     * @return {?}
     */
    Entity.prototype.__createInstance = 
    //@internal
    /**
     * @return {?}
     */
    function () {
        if (!this.__context) {
            throw this._noContextErrorWithStack;
        }
        if (!this.__entityType) {
            throw this._noContextErrorWithStack;
        }
        return this.__context.create(this.__entityType);
    };
    /**
     * @return {?}
     */
    Entity.prototype.__getName = /**
     * @return {?}
     */
    function () {
        return this.__options.name;
    };
    /**
     * @return {?}
     */
    Entity.prototype.__getDbName = /**
     * @return {?}
     */
    function () {
        if (!this.__options.dbName)
            this.__options.dbName = this.__getName();
        return functionOrString(this.__options.dbName);
    };
    /**
     * @return {?}
     */
    Entity.prototype.__getCaption = /**
     * @return {?}
     */
    function () {
        if (!this.__options.caption) {
            this.__options.caption = makeTitle(this.__getName());
        }
        return this.__options.caption;
    };
    /**
     * @param {?=} idColumn
     * @return {?}
     */
    Entity.prototype.__initColumns = /**
     * @param {?=} idColumn
     * @return {?}
     */
    function (idColumn) {
        if (idColumn)
            this.__idColumn = idColumn;
        /** @type {?} */
        var x = (/** @type {?} */ (this));
        for (var c in x) {
            /** @type {?} */
            var y = x[c];
            if (y instanceof Column) {
                if (!y.jsonName)
                    y.jsonName = c;
                if (!this.__idColumn && y.jsonName == 'id')
                    this.__idColumn = y;
                this.__applyColumn(y);
            }
        }
        if (!this.__idColumn)
            this.__idColumn = this.__iterateColumns()[0];
    };
    /**
     * @return {?}
     */
    Entity.prototype.isValid = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var ok = true;
        this.__iterateColumns().forEach((/**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            if (c.error)
                ok = false;
        }));
        return ok;
    };
    /**
     * @return {?}
     */
    Entity.prototype.isNew = /**
     * @return {?}
     */
    function () {
        return this.__entityData.isNewRow();
    };
    /**
     * @return {?}
     */
    Entity.prototype.__getValidationError = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var result = {};
        result.modelState = {};
        this.__iterateColumns().forEach((/**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            if (c.error)
                result.modelState[c.jsonName] = c.error;
        }));
        return result;
    };
    /**
     * @param {?} dp
     * @return {?}
     */
    Entity.prototype.setSource = /**
     * @param {?} dp
     * @return {?}
     */
    function (dp) {
        var _this = this;
        this.source = new EntitySource(this.__getName(), (/**
         * @template THIS
         * @this {THIS}
         * @return {THIS}
         */
        function () { return (/** @type {?} */ (_this.factory())); }), dp);
    };
    /**
     * @return {?}
     */
    Entity.prototype.__assertValidity = /**
     * @return {?}
     */
    function () {
        if (!this.isValid()) {
            throw this.__getValidationError();
        }
    };
    /**
     * @param {?=} validate
     * @param {?=} onSavingRow
     * @return {?}
     */
    Entity.prototype.save = /**
     * @param {?=} validate
     * @param {?=} onSavingRow
     * @return {?}
     */
    function (validate, onSavingRow) {
        var _this = this;
        this.__clearErrors();
        this.__iterateColumns().forEach((/**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            c.__performValidation();
        }));
        if (this.__onValidate)
            this.__onValidate();
        if (validate)
            validate(this);
        this.__assertValidity();
        /** @type {?} */
        var performEntitySave = (/**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var x = _this.__onSavingRow();
            /** @type {?} */
            var doSave = (/**
             * @return {?}
             */
            function () {
                _this.__assertValidity();
                return _this.__entityData.save(_this).catch((/**
                 * @param {?} e
                 * @return {?}
                 */
                function (e) { return _this.catchSaveErrors(e); }));
            });
            if (x instanceof Promise) {
                return x.then((/**
                 * @return {?}
                 */
                function () {
                    return doSave();
                }));
            }
            else {
                return doSave();
            }
        });
        if (!onSavingRow)
            return performEntitySave();
        /** @type {?} */
        var y = onSavingRow(this);
        if (y instanceof Promise) {
            return y.then((/**
             * @return {?}
             */
            function () { return performEntitySave(); }));
        }
        return performEntitySave();
    };
    /**
     * @param {?} err
     * @return {?}
     */
    Entity.prototype.catchSaveErrors = /**
     * @param {?} err
     * @return {?}
     */
    function (err) {
        var _this = this;
        /** @type {?} */
        var e = err;
        if (e instanceof Promise) {
            return e.then((/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return _this.catchSaveErrors(x); }));
        }
        if (e.error) {
            e = e.error;
        }
        if (e.message)
            this.error = e.message;
        else if (e.Message)
            this.error = e.Message;
        else
            this.error = e;
        /** @type {?} */
        var s = e.modelState;
        if (!s)
            s = e.ModelState;
        if (s) {
            Object.keys(s).forEach((/**
             * @param {?} k
             * @return {?}
             */
            function (k) {
                /** @type {?} */
                var c = _this.__getColumnByJsonName(k);
                if (c)
                    c.error = s[k];
            }));
        }
        throw err;
    };
    /**
     * @return {?}
     */
    Entity.prototype.delete = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return this.__entityData.delete().catch((/**
         * @param {?} e
         * @return {?}
         */
        function (e) { return _this.catchSaveErrors(e); }));
    };
    /**
     * @return {?}
     */
    Entity.prototype.reset = /**
     * @return {?}
     */
    function () {
        this.__entityData.reset();
        this.__clearErrors();
    };
    //@internal
    //@internal
    /**
     * @return {?}
     */
    Entity.prototype.__clearErrors = 
    //@internal
    /**
     * @return {?}
     */
    function () {
        this.__iterateColumns().forEach((/**
         * @param {?} c
         * @return {?}
         */
        function (c) { return c.__clearErrors(); }));
        this.error = undefined;
    };
    /**
     * @return {?}
     */
    Entity.prototype.wasChanged = /**
     * @return {?}
     */
    function () {
        return this.__entityData.wasChanged();
    };
    /**
     * @param {?} excludeColumns
     * @return {?}
     */
    Entity.prototype.__toPojo = /**
     * @param {?} excludeColumns
     * @return {?}
     */
    function (excludeColumns) {
        return __awaiter(this, void 0, void 0, function () {
            var r;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        r = {};
                        return [4 /*yield*/, Promise.all(this.__iterateColumns().map((/**
                             * @param {?} c
                             * @return {?}
                             */
                            function (c) { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, c.__calcVirtuals()];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/];
                                    }
                                });
                            }); })))];
                    case 1:
                        _a.sent();
                        this.__iterateColumns().forEach((/**
                         * @param {?} c
                         * @return {?}
                         */
                        function (c) {
                            if (!excludeColumns.contains(c))
                                c.__addToPojo(r);
                        }));
                        return [2 /*return*/, r];
                }
            });
        });
    };
    /**
     * @param {?} r
     * @param {?} excludeColumns
     * @return {?}
     */
    Entity.prototype.__fromPojo = /**
     * @param {?} r
     * @param {?} excludeColumns
     * @return {?}
     */
    function (r, excludeColumns) {
        this.__iterateColumns().forEach((/**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            if (!excludeColumns.contains(c))
                c.__loadFromToPojo(r);
        }));
    };
    //@internal
    //@internal
    /**
     * @param {?} y
     * @return {?}
     */
    Entity.prototype.__applyColumn = 
    //@internal
    /**
     * @param {?} y
     * @return {?}
     */
    function (y) {
        if (!y.caption)
            y.caption = makeTitle(y.jsonName);
        y.__valueProvider = this.__entityData;
        if (this.__columns.indexOf(y) < 0)
            this.__columns.push(y);
        y.__setEntity(this);
    };
    /**
     * @template T
     * @param {?} col
     * @return {?}
     */
    Entity.prototype.__getColumn = /**
     * @template T
     * @param {?} col
     * @return {?}
     */
    function (col) {
        return this.__getColumnByJsonName(col.jsonName);
    };
    /**
     * @param {?} key
     * @return {?}
     */
    Entity.prototype.__getColumnByJsonName = /**
     * @param {?} key
     * @return {?}
     */
    function (key) {
        /** @type {?} */
        var result;
        this.__iterateColumns().forEach((/**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            if (c.jsonName == key)
                result = c;
        }));
        return result;
    };
    /**
     * @return {?}
     */
    Entity.prototype.__iterateColumns = /**
     * @return {?}
     */
    function () {
        return this.__columns;
    };
    return Entity;
}());
var ColumnHashSet = /** @class */ (function () {
    function ColumnHashSet() {
        this._names = [];
    }
    /**
     * @param {...?} columns
     * @return {?}
     */
    ColumnHashSet.prototype.add = /**
     * @param {...?} columns
     * @return {?}
     */
    function () {
        var columns = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            columns[_i] = arguments[_i];
        }
        var e_2, _a;
        if (columns)
            try {
                for (var columns_1 = __values(columns), columns_1_1 = columns_1.next(); !columns_1_1.done; columns_1_1 = columns_1.next()) {
                    var c = columns_1_1.value;
                    this._names.push(c.__getMemberName());
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (columns_1_1 && !columns_1_1.done && (_a = columns_1.return)) _a.call(columns_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
    };
    /**
     * @param {?} column
     * @return {?}
     */
    ColumnHashSet.prototype.contains = /**
     * @param {?} column
     * @return {?}
     */
    function (column) {
        return this._names.indexOf(column.__getMemberName()) >= 0;
    };
    return ColumnHashSet;
}());
var CompoundIdColumn = /** @class */ (function (_super) {
    __extends(CompoundIdColumn, _super);
    function CompoundIdColumn(entity) {
        var columns = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            columns[_i - 1] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.columns = columns;
        return _this;
    }
    /**
     * @return {?}
     */
    CompoundIdColumn.prototype.__isVirtual = /**
     * @return {?}
     */
    function () { return true; };
    /**
     * @param {?} value
     * @return {?}
     */
    CompoundIdColumn.prototype.isEqualTo = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        return new Filter((/**
         * @param {?} add
         * @return {?}
         */
        function (add) {
            /** @type {?} */
            var val = _this.__getVal(value);
            /** @type {?} */
            var id = val.split(',');
            /** @type {?} */
            var result;
            _this.columns.forEach((/**
             * @param {?} c
             * @param {?} i
             * @return {?}
             */
            function (c, i) {
                if (!result)
                    result = c.isEqualTo(id[i]);
                else
                    result = new AndFilter(result, c.isEqualTo(id[i]));
            }));
            return result.__applyToConsumer(add);
        }));
    };
    /**
     * @param {?} p
     * @return {?}
     */
    CompoundIdColumn.prototype.__addIdToPojo = /**
     * @param {?} p
     * @return {?}
     */
    function (p) {
        if (p.id)
            return;
        /** @type {?} */
        var r = "";
        this.columns.forEach((/**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            if (r.length > 0)
                r += ',';
            r += p[c.jsonName];
        }));
        p.id = r;
    };
    /**
     * @param {?} id
     * @param {?} data
     * @return {?}
     */
    CompoundIdColumn.prototype.resultIdFilter = /**
     * @param {?} id
     * @param {?} data
     * @return {?}
     */
    function (id, data) {
        var _this = this;
        return new Filter((/**
         * @param {?} add
         * @return {?}
         */
        function (add) {
            /** @type {?} */
            var idParts = [];
            if (id != undefined)
                idParts = id.split(',');
            /** @type {?} */
            var result;
            _this.columns.forEach((/**
             * @param {?} c
             * @param {?} i
             * @return {?}
             */
            function (c, i) {
                /** @type {?} */
                var val = undefined;
                if (i < idParts.length)
                    val = idParts[i];
                if (data[c.jsonName] != undefined)
                    val = data[c.jsonName];
                if (!result)
                    result = c.isEqualTo(val);
                else
                    result = new AndFilter(result, c.isEqualTo(val));
            }));
            return result.__applyToConsumer(add);
        }));
    };
    return CompoundIdColumn;
}(Column));
/**
 * @template T
 */
var  /**
 * @template T
 */
EntitySource = /** @class */ (function () {
    function EntitySource(name, factory, dataProvider) {
        this.factory = factory;
        if (dataProvider)
            this._provider = dataProvider.provideFor(name, factory);
    }
    /**
     * @param {?=} options
     * @return {?}
     */
    EntitySource.prototype.find = /**
     * @param {?=} options
     * @return {?}
     */
    function (options) {
        var _this = this;
        if (options)
            options.orderBy = translateSort(options.orderBy);
        return this._provider.find((/** @type {?} */ (options)))
            .then((/**
         * @param {?} arr
         * @return {?}
         */
        function (arr) {
            return arr.map((/**
             * @param {?} i
             * @return {?}
             */
            function (i) {
                /** @type {?} */
                var r = _this.factory();
                r.__entityData.setData(i, r);
                r.source = _this;
                return r;
            }));
        }));
    };
    /**
     * @param {?} r
     * @return {?}
     */
    EntitySource.prototype.fromPojo = /**
     * @param {?} r
     * @return {?}
     */
    function (r) {
        /** @type {?} */
        var f = this.factory();
        f.__entityData.setData(r, f);
        f.source = this;
        return f;
    };
    /**
     * @param {?=} where
     * @return {?}
     */
    EntitySource.prototype.count = /**
     * @param {?=} where
     * @return {?}
     */
    function (where) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this._provider.count(where)];
            });
        });
    };
    /**
     * @param {?} col
     * @param {?=} filter
     * @return {?}
     */
    EntitySource.prototype.max = /**
     * @param {?} col
     * @param {?=} filter
     * @return {?}
     */
    function (col, filter) {
        return __awaiter(this, void 0, void 0, function () {
            var x;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.find({ where: filter, limit: 1, orderBy: new Sort({ column: col, descending: true }) })];
                    case 1:
                        x = _a.sent();
                        if (x.length == 0) {
                            return [2 /*return*/, 0];
                        }
                        return [2 /*return*/, x[0].__getColumn(col).value];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    EntitySource.prototype.__getDataProvider = /**
     * @return {?}
     */
    function () {
        return this._provider;
    };
    /**
     * @return {?}
     */
    EntitySource.prototype.createNewItem = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var r = this.factory();
        r.source = this;
        return r;
    };
    /**
     * @param {?} doOnRow
     * @return {?}
     */
    EntitySource.prototype.Insert = /**
     * @param {?} doOnRow
     * @return {?}
     */
    function (doOnRow) {
        return __awaiter(this, void 0, void 0, function () {
            var i, x;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        i = this.createNewItem();
                        x = doOnRow(i);
                        if (!(x instanceof Promise)) return [3 /*break*/, 2];
                        return [4 /*yield*/, x];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [4 /*yield*/, i.save()];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, i];
                }
            });
        });
    };
    return EntitySource;
}());
var __EntityValueProvider = /** @class */ (function () {
    function __EntityValueProvider(getDataProvider) {
        this.getDataProvider = getDataProvider;
        this.listeners = [];
        this.newRow = true;
        this.data = {};
        this.originalData = {};
    }
    /**
     * @param {?} listener
     * @return {?}
     */
    __EntityValueProvider.prototype.register = /**
     * @param {?} listener
     * @return {?}
     */
    function (listener) {
        this.listeners.push(listener);
    };
    /**
     * @return {?}
     */
    __EntityValueProvider.prototype.delete = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return this.getDataProvider().delete(this.id).then((/**
         * @return {?}
         */
        function () {
            _this.listeners.forEach((/**
             * @param {?} x
             * @return {?}
             */
            function (x) {
                if (x.rowDeleted)
                    x.rowDeleted();
            }));
        }));
    };
    /**
     * @return {?}
     */
    __EntityValueProvider.prototype.isNewRow = /**
     * @return {?}
     */
    function () {
        return this.newRow;
    };
    /**
     * @return {?}
     */
    __EntityValueProvider.prototype.wasChanged = /**
     * @return {?}
     */
    function () {
        return JSON.stringify(this.originalData) != JSON.stringify(this.data) || this.newRow;
    };
    /**
     * @return {?}
     */
    __EntityValueProvider.prototype.reset = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.data = JSON.parse(JSON.stringify(this.originalData));
        this.listeners.forEach((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            if (x.rowReset)
                x.rowReset(_this.newRow);
        }));
    };
    /**
     * @param {?} e
     * @return {?}
     */
    __EntityValueProvider.prototype.save = /**
     * @param {?} e
     * @return {?}
     */
    function (e) {
        var _this = this;
        /** @type {?} */
        var d = JSON.parse(JSON.stringify(this.data));
        if (e.__idColumn instanceof CompoundIdColumn)
            d.id = undefined;
        if (this.newRow) {
            return this.getDataProvider().insert(d).then((/**
             * @param {?} newData
             * @return {?}
             */
            function (newData) {
                _this.setData(newData, e);
                _this.listeners.forEach((/**
                 * @param {?} x
                 * @return {?}
                 */
                function (x) {
                    if (x.rowSaved)
                        x.rowSaved(true);
                }));
            }));
        }
        else {
            return this.getDataProvider().update(this.id, d).then((/**
             * @param {?} newData
             * @return {?}
             */
            function (newData) {
                _this.setData(newData, e);
                _this.listeners.forEach((/**
                 * @param {?} x
                 * @return {?}
                 */
                function (x) {
                    if (x.rowSaved)
                        x.rowSaved(false);
                }));
            }));
        }
    };
    /**
     * @param {?} data
     * @param {?} r
     * @return {?}
     */
    __EntityValueProvider.prototype.setData = /**
     * @param {?} data
     * @param {?} r
     * @return {?}
     */
    function (data, r) {
        if (!data)
            data = {};
        if (r.__idColumn instanceof CompoundIdColumn) {
            r.__idColumn.__addIdToPojo(data);
        }
        /** @type {?} */
        var id = data[r.__idColumn.jsonName];
        if (id != undefined) {
            this.id = id;
            this.newRow = false;
        }
        this.data = data;
        this.originalData = JSON.parse(JSON.stringify(this.data));
    };
    /**
     * @param {?} key
     * @return {?}
     */
    __EntityValueProvider.prototype.getValue = /**
     * @param {?} key
     * @return {?}
     */
    function (key) {
        return this.data[key];
    };
    /**
     * @param {?} key
     * @return {?}
     */
    __EntityValueProvider.prototype.getOriginalValue = /**
     * @param {?} key
     * @return {?}
     */
    function (key) {
        return this.originalData[key];
    };
    /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    __EntityValueProvider.prototype.setValue = /**
     * @param {?} key
     * @param {?} value
     * @return {?}
     */
    function (key, value) {
        this.data[key] = value;
    };
    return __EntityValueProvider;
}());
var StringColumn = /** @class */ (function (_super) {
    __extends(StringColumn, _super);
    function StringColumn(settingsOrCaption) {
        return _super.call(this, settingsOrCaption) || this;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    StringColumn.prototype.isContains = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        return new Filter((/**
         * @param {?} add
         * @return {?}
         */
        function (add) { return add.isContains(_this, _this.__getVal(value)); }));
    };
    /**
     * @param {?} value
     * @return {?}
     */
    StringColumn.prototype.isStartsWith = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        return new Filter((/**
         * @param {?} add
         * @return {?}
         */
        function (add) { return add.isStartsWith(_this, _this.__getVal(value)); }));
    };
    return StringColumn;
}(Column));
var DateColumn = /** @class */ (function (_super) {
    __extends(DateColumn, _super);
    function DateColumn(settingsOrCaption) {
        var _this = _super.call(this, settingsOrCaption) || this;
        if (!_this.inputType)
            _this.inputType = 'date';
        return _this;
    }
    /**
     * @return {?}
     */
    DateColumn.prototype.getDayOfWeek = /**
     * @return {?}
     */
    function () {
        return new Date(this.value).getDay();
    };
    Object.defineProperty(DateColumn.prototype, "displayValue", {
        get: /**
         * @return {?}
         */
        function () {
            if (!this.value)
                return '';
            return this.value.toLocaleDateString();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    DateColumn.prototype.__defaultStorage = /**
     * @return {?}
     */
    function () {
        return new DateTimeDateStorage();
    };
    /**
     * @param {?} value
     * @return {?}
     */
    DateColumn.prototype.toRawValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return DateColumn.dateToString(value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    DateColumn.prototype.fromRawValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return DateColumn.stringToDate(value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    DateColumn.stringToDate = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        if (!value || value == '' || value == '0000-00-00')
            return undefined;
        return new Date(Date.parse(value));
    };
    /**
     * @param {?} val
     * @return {?}
     */
    DateColumn.dateToString = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        /** @type {?} */
        var d = (/** @type {?} */ (val));
        if (!d)
            return '';
        /** @type {?} */
        var month = addZeros(d.getMonth() + 1);
        /** @type {?} */
        var day = addZeros(d.getDate());
        /** @type {?} */
        var year = d.getFullYear();
        return [year, month, day].join('-');
    };
    return DateColumn;
}(Column));
var DateTimeColumn = /** @class */ (function (_super) {
    __extends(DateTimeColumn, _super);
    function DateTimeColumn(settingsOrCaption) {
        var _this = _super.call(this, settingsOrCaption) || this;
        if (!_this.inputType)
            _this.inputType = 'date';
        return _this;
    }
    /**
     * @return {?}
     */
    DateTimeColumn.prototype.getDayOfWeek = /**
     * @return {?}
     */
    function () {
        return this.value.getDay();
    };
    Object.defineProperty(DateTimeColumn.prototype, "displayValue", {
        get: /**
         * @return {?}
         */
        function () {
            if (!this.value)
                return '';
            return this.value.toLocaleString();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    DateTimeColumn.prototype.__defaultStorage = /**
     * @return {?}
     */
    function () {
        return new DateTimeStorage();
    };
    /**
     * @param {?} value
     * @return {?}
     */
    DateTimeColumn.prototype.fromRawValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return DateTimeColumn.stringToDate(value);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    DateTimeColumn.prototype.toRawValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return DateTimeColumn.dateToString(value);
    };
    /**
     * @param {?} val
     * @return {?}
     */
    DateTimeColumn.stringToDate = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        if (val == undefined)
            return undefined;
        if (val == '')
            return undefined;
        if (val.startsWith('0000-00-00'))
            return undefined;
        return new Date(Date.parse(val));
    };
    /**
     * @param {?} val
     * @return {?}
     */
    DateTimeColumn.dateToString = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        /** @type {?} */
        var d = (/** @type {?} */ (val));
        if (!d)
            return '';
        return d.toISOString();
    };
    return DateTimeColumn;
}(Column));
var NumberColumn = /** @class */ (function (_super) {
    __extends(NumberColumn, _super);
    function NumberColumn(settingsOrCaption) {
        var _this = _super.call(this, settingsOrCaption) || this;
        _this.__numOfDecimalDigits = 0;
        if (!_this.inputType)
            _this.inputType = 'number';
        /** @type {?} */
        var s = (/** @type {?} */ (settingsOrCaption));
        if (s && s.decimalDigits) {
            _this.__numOfDecimalDigits = s.decimalDigits;
        }
        return _this;
    }
    /**
     * @protected
     * @param {?} value
     * @return {?}
     */
    NumberColumn.prototype.__processValue = /**
     * @protected
     * @param {?} value
     * @return {?}
     */
    function (value) {
        if (value != undefined && !(typeof value === "number"))
            return +value;
        return value;
    };
    return NumberColumn;
}(Column));
var BoolColumn = /** @class */ (function (_super) {
    __extends(BoolColumn, _super);
    function BoolColumn(settingsOrCaption) {
        var _this = _super.call(this, settingsOrCaption) || this;
        if (!_this.inputType)
            _this.inputType = 'checkbox';
        return _this;
    }
    /**
     * @return {?}
     */
    BoolColumn.prototype.__defaultStorage = /**
     * @return {?}
     */
    function () {
        return new BoolStorage();
    };
    return BoolColumn;
}(Column));
var BoolStorage = /** @class */ (function () {
    function BoolStorage() {
    }
    /**
     * @param {?} val
     * @return {?}
     */
    BoolStorage.prototype.toDb = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        return val;
    };
    /**
     * @param {?} val
     * @return {?}
     */
    BoolStorage.prototype.fromDb = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        if (isString(val))
            return val === "true";
        return val;
    };
    return BoolStorage;
}());
/**
 * @template closedListType
 */
var  /**
 * @template closedListType
 */
ClosedListColumn = /** @class */ (function (_super) {
    __extends(ClosedListColumn, _super);
    function ClosedListColumn(closedListType, settingsOrCaption) {
        var _this = _super.call(this, settingsOrCaption) || this;
        _this.closedListType = closedListType;
        return _this;
    }
    /**
     * @return {?}
     */
    ClosedListColumn.prototype.getOptions = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var result = [];
        for (var member in this.closedListType) {
            /** @type {?} */
            var s = (/** @type {?} */ (this.closedListType[member]));
            if (s && s.id != undefined) {
                result.push({
                    id: s.id,
                    caption: s.toString()
                });
            }
        }
        return result;
    };
    /**
     * @param {?} value
     * @return {?}
     */
    ClosedListColumn.prototype.toRawValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return value.id;
    };
    /**
     * @param {?} value
     * @return {?}
     */
    ClosedListColumn.prototype.fromRawValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return this.byId(+value);
    };
    Object.defineProperty(ClosedListColumn.prototype, "displayValue", {
        get: /**
         * @return {?}
         */
        function () {
            if (this.value)
                return this.value.toString();
            return '';
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} id
     * @return {?}
     */
    ClosedListColumn.prototype.byId = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        for (var member in this.closedListType) {
            /** @type {?} */
            var s = (/** @type {?} */ (this.closedListType[member]));
            if (s && s.id == id)
                return s;
        }
        return undefined;
    };
    return ClosedListColumn;
}(Column));
/**
 * @template rowType
 */
var  /**
 * @template rowType
 */
ColumnCollection = /** @class */ (function () {
    function ColumnCollection(currentRow, allowUpdate, filterHelper, showArea) {
        this.currentRow = currentRow;
        this.allowUpdate = allowUpdate;
        this.filterHelper = filterHelper;
        this.showArea = showArea;
        this.settingsByKey = {};
        this.designMode = false;
        this._colListChangeListeners = [];
        this.items = [];
        this.numOfColumnsInGrid = 5;
        if (this.allowDesignMode == undefined) {
            if (location.search)
                if (location.search.toLowerCase().indexOf('design=y') >= 0)
                    this.allowDesignMode = true;
        }
    }
    /**
     * @return {?}
     */
    ColumnCollection.prototype.__showArea = /**
     * @return {?}
     */
    function () {
        return this.showArea();
    };
    /**
     * @param {?} map
     * @param {?} record
     * @return {?}
     */
    ColumnCollection.prototype.__getColumn = /**
     * @param {?} map
     * @param {?} record
     * @return {?}
     */
    function (map, record) {
        /** @type {?} */
        var result;
        if (record)
            result = record.__getColumn(map.column);
        if (!result)
            result = map.column;
        return result;
    };
    /**
     * @param {?} map
     * @return {?}
     */
    ColumnCollection.prototype.__dataControlStyle = /**
     * @param {?} map
     * @return {?}
     */
    function (map) {
        if (map.width && map.width.trim().length > 0) {
            if ((+map.width).toString() == map.width)
                return map.width + "px";
            return map.width;
        }
        return undefined;
    };
    /**
     * @param {...?} columns
     * @return {?}
     */
    ColumnCollection.prototype.add = /**
     * @param {...?} columns
     * @return {?}
     */
    function () {
        var columns = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            columns[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var e_3, _a, promises, columns_2, columns_2_1, c, x;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        promises = [];
                        try {
                            for (columns_2 = __values(columns), columns_2_1 = columns_2.next(); !columns_2_1.done; columns_2_1 = columns_2.next()) {
                                c = columns_2_1.value;
                                x = (/** @type {?} */ (c));
                                if (!x.column && c instanceof Column) {
                                    x = {
                                        column: c,
                                    };
                                }
                                if (x.column) {
                                    x.column.__decorateDataSettings(x);
                                }
                                if (x.getValue) ;
                                else {
                                    promises.push(this.buildDropDown(x));
                                }
                                this.items.push(x);
                            }
                        }
                        catch (e_3_1) { e_3 = { error: e_3_1 }; }
                        finally {
                            try {
                                if (columns_2_1 && !columns_2_1.done && (_a = columns_2.return)) _a.call(columns_2);
                            }
                            finally { if (e_3) throw e_3.error; }
                        }
                        return [4 /*yield*/, Promise.all(promises)];
                    case 1:
                        _b.sent();
                        return [2 /*return*/, Promise.resolve()];
                }
            });
        });
    };
    /**
     * @param {?} s
     * @return {?}
     */
    ColumnCollection.prototype.buildDropDown = /**
     * @param {?} s
     * @return {?}
     */
    function (s) {
        return __awaiter(this, void 0, void 0, function () {
            var orig, result_1, populateBasedOnArray_1;
            return __generator(this, function (_a) {
                if (s.dropDown) {
                    orig = s.dropDown.items;
                    result_1 = [];
                    s.dropDown.items = result_1;
                    populateBasedOnArray_1 = (/**
                     * @param {?} arr
                     * @return {?}
                     */
                    function (arr) {
                        var e_4, _a, e_5, _b, e_6, _c;
                        try {
                            for (var arr_1 = __values(arr), arr_1_1 = arr_1.next(); !arr_1_1.done; arr_1_1 = arr_1.next()) {
                                var item = arr_1_1.value;
                                /** @type {?} */
                                var type = typeof (item);
                                if (type == "string" || type == "number")
                                    result_1.push({ id: item, caption: item });
                                else if (item instanceof Entity) {
                                    /** @type {?} */
                                    var col = void 0;
                                    if (!s.dropDown.idColumn) {
                                        if (col = item.__getColumnByJsonName('id'))
                                            s.dropDown.idColumn = col;
                                        else {
                                            try {
                                                for (var _d = __values(item.__iterateColumns()), _e = _d.next(); !_e.done; _e = _d.next()) {
                                                    var colInEntity = _e.value;
                                                    s.dropDown.idColumn = colInEntity;
                                                    break;
                                                }
                                            }
                                            catch (e_5_1) { e_5 = { error: e_5_1 }; }
                                            finally {
                                                try {
                                                    if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
                                                }
                                                finally { if (e_5) throw e_5.error; }
                                            }
                                        }
                                    }
                                    if (!s.dropDown.captionColumn) {
                                        if (col = item.__getColumnByJsonName('caption'))
                                            s.dropDown.captionColumn = col;
                                        else {
                                            try {
                                                for (var _f = __values(item.__iterateColumns()), _g = _f.next(); !_g.done; _g = _f.next()) {
                                                    var keyInItem = _g.value;
                                                    if (keyInItem != item.__getColumn(s.dropDown.idColumn)) {
                                                        s.dropDown.captionColumn = keyInItem;
                                                        break;
                                                    }
                                                }
                                            }
                                            catch (e_6_1) { e_6 = { error: e_6_1 }; }
                                            finally {
                                                try {
                                                    if (_g && !_g.done && (_c = _f.return)) _c.call(_f);
                                                }
                                                finally { if (e_6) throw e_6.error; }
                                            }
                                        }
                                    }
                                    /** @type {?} */
                                    var p = { id: item.__getColumn(s.dropDown.idColumn).value, caption: item.__getColumn(s.dropDown.captionColumn).value };
                                    if (p.id instanceof Column) {
                                        p.id = p.id.value;
                                    }
                                    if (p.caption instanceof Column)
                                        p.caption = p.caption.value;
                                    if (!p.caption)
                                        p.caption = p.id;
                                    result_1.push(p);
                                }
                                else {
                                    /** @type {?} */
                                    var x = (/** @type {?} */ (item));
                                    if (x && x.id != undefined) {
                                        result_1.push(x);
                                    }
                                }
                            }
                        }
                        catch (e_4_1) { e_4 = { error: e_4_1 }; }
                        finally {
                            try {
                                if (arr_1_1 && !arr_1_1.done && (_a = arr_1.return)) _a.call(arr_1);
                            }
                            finally { if (e_4) throw e_4.error; }
                        }
                    });
                    if (orig instanceof Array) {
                        populateBasedOnArray_1(orig);
                    }
                    else if (s.dropDown.source) {
                        if (s.dropDown.source instanceof Entity) {
                            return [2 /*return*/, new DataList(s.dropDown.source).get({ limit: 5000, orderBy: s.dropDown.orderBy }).then((/**
                                 * @param {?} arr
                                 * @return {?}
                                 */
                                function (arr) {
                                    return populateBasedOnArray_1(arr);
                                }))];
                        }
                    }
                }
                return [2 /*return*/, Promise.resolve()];
            });
        });
    };
    /**
     * @return {?}
     */
    ColumnCollection.prototype.colListChanged = /**
     * @return {?}
     */
    function () {
        this._lastNumOfColumnsInGrid = -1;
        this._colListChangeListeners.forEach((/**
         * @param {?} x
         * @return {?}
         */
        function (x) { return x(); }));
    };
    /**
     * @param {?} action
     * @return {?}
     */
    ColumnCollection.prototype.onColListChange = /**
     * @param {?} action
     * @return {?}
     */
    function (action) {
        this._colListChangeListeners.push(action);
    };
    /**
     * @param {?} col
     * @param {?} move
     * @return {?}
     */
    ColumnCollection.prototype.moveCol = /**
     * @param {?} col
     * @param {?} move
     * @return {?}
     */
    function (col, move) {
        /** @type {?} */
        var currentIndex = this.items.indexOf(col);
        /** @type {?} */
        var newIndex = currentIndex + move;
        if (newIndex < 0 || newIndex >= this.items.length)
            return;
        this.items.splice(currentIndex, 1);
        this.items.splice(newIndex, 0, col);
        this.colListChanged();
    };
    /**
     * @param {?} col
     * @return {?}
     */
    ColumnCollection.prototype.filterRows = /**
     * @param {?} col
     * @return {?}
     */
    function (col) {
        col._showFilter = false;
        this.filterHelper.filterColumn(col.column, false, (col.dropDown != undefined || col.click != undefined));
    };
    /**
     * @param {?} col
     * @return {?}
     */
    ColumnCollection.prototype.clearFilter = /**
     * @param {?} col
     * @return {?}
     */
    function (col) {
        col._showFilter = false;
        this.filterHelper.filterColumn(col.column, true, false);
    };
    /**
     * @param {?} col
     * @return {?}
     */
    ColumnCollection.prototype._shouldShowFilterDialog = /**
     * @param {?} col
     * @return {?}
     */
    function (col) {
        return col && col._showFilter;
    };
    /**
     * @param {?} col
     * @return {?}
     */
    ColumnCollection.prototype.showFilterDialog = /**
     * @param {?} col
     * @return {?}
     */
    function (col) {
        col._showFilter = !col._showFilter;
    };
    /**
     * @param {?} col
     * @return {?}
     */
    ColumnCollection.prototype.deleteCol = /**
     * @param {?} col
     * @return {?}
     */
    function (col) {
        this.items.splice(this.items.indexOf(col), 1);
        this.colListChanged();
    };
    /**
     * @param {?} col
     * @return {?}
     */
    ColumnCollection.prototype.addCol = /**
     * @param {?} col
     * @return {?}
     */
    function (col) {
        this.items.splice(this.items.indexOf(col) + 1, 0, { designMode: true });
        this.colListChanged();
    };
    /**
     * @param {?} col
     * @return {?}
     */
    ColumnCollection.prototype.designColumn = /**
     * @param {?} col
     * @return {?}
     */
    function (col) {
        col.designMode = !col.designMode;
    };
    /**
     * @param {?} col
     * @return {?}
     */
    ColumnCollection.prototype._getEditable = /**
     * @param {?} col
     * @return {?}
     */
    function (col) {
        if (!this.allowUpdate())
            return false;
        if (!col.column)
            return false;
        return !col.readonly;
    };
    /**
     * @param {?} col
     * @param {?} row
     * @return {?}
     */
    ColumnCollection.prototype._click = /**
     * @param {?} col
     * @param {?} row
     * @return {?}
     */
    function (col, row) {
        col.click(row, (/**
         * @param {?} what
         * @return {?}
         */
        function (what) {
            what();
        }));
    };
    /**
     * @param {?} col
     * @param {?} row
     * @return {?}
     */
    ColumnCollection.prototype._getColDisplayValue = /**
     * @param {?} col
     * @param {?} row
     * @return {?}
     */
    function (col, row) {
        var e_7, _a;
        /** @type {?} */
        var r;
        if (col.getValue) {
            r = col.getValue(row);
            if (r instanceof Column)
                r = r.value;
        }
        else if (col.column) {
            if (col.dropDown && col.dropDown.items) {
                try {
                    for (var _b = __values(col.dropDown.items), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var x = _c.value;
                        if (x.id == this.__getColumn(col, row).value)
                            return x.caption;
                    }
                }
                catch (e_7_1) { e_7 = { error: e_7_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_7) throw e_7.error; }
                }
            }
            r = this.__getColumn(col, row).displayValue;
        }
        return r;
    };
    /**
     * @param {?} col
     * @return {?}
     */
    ColumnCollection.prototype._getColDataType = /**
     * @param {?} col
     * @return {?}
     */
    function (col) {
        if (col.inputType)
            return col.inputType;
        return "text";
    };
    /**
     * @param {?} col
     * @param {?} row
     * @return {?}
     */
    ColumnCollection.prototype._getColumnClass = /**
     * @param {?} col
     * @param {?} row
     * @return {?}
     */
    function (col, row) {
        if (col.cssClass)
            if (isFunction$1(col.cssClass)) {
                /** @type {?} */
                var anyFunc = col.cssClass;
                return anyFunc(row);
            }
            else
                return col.cssClass;
        return '';
    };
    /**
     * @param {?} col
     * @param {?} r
     * @return {?}
     */
    ColumnCollection.prototype._getError = /**
     * @param {?} col
     * @param {?} r
     * @return {?}
     */
    function (col, r) {
        if (!col.column)
            return undefined;
        return this.__getColumn(col, r).error;
    };
    /**
     * @param {?} r
     * @return {?}
     */
    ColumnCollection.prototype.autoGenerateColumnsBasedOnData = /**
     * @param {?} r
     * @return {?}
     */
    function (r) {
        if (this.items.length == 0) {
            if (r) {
                this.add.apply(this, __spread(r.__iterateColumns()));
            }
        }
    };
    /**
     * @return {?}
     */
    ColumnCollection.prototype.__columnSettingsTypeScript = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var memberName = 'x';
        if (this.currentRow())
            memberName = this.currentRow().__getName();
        memberName = memberName[0].toLocaleLowerCase() + memberName.substring(1);
        /** @type {?} */
        var result = '';
        this.items.forEach((/**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            if (result.length > 0)
                result += ',\n';
            result += '  ' + _this.__columnTypeScriptDescription(c, memberName);
        }));
        result = "columnSettings: " + memberName + " => [\n" + result + "\n]";
        return result;
    };
    /**
     * @param {?} c
     * @param {?} memberName
     * @return {?}
     */
    ColumnCollection.prototype.__columnTypeScriptDescription = /**
     * @param {?} c
     * @param {?} memberName
     * @return {?}
     */
    function (c, memberName) {
        /** @type {?} */
        var properties = "";
        /**
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
        function addToProperties(name, value) {
            if (properties.length > 0)
                properties += ', ';
            properties += "\n    " + name + ": " + value;
        }
        /**
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
        function addString(name, value) {
            addToProperties(name, "'" + value + "'");
        }
        /** @type {?} */
        var columnMember = '';
        if (c.column) {
            columnMember += memberName + "." + c.column.__getMemberName();
            if (c == c.column)
                columnMember += '/*equal*/';
            if (c.caption != c.column.caption) {
                addString('caption', c.caption);
            }
        }
        else {
            addString('caption', c.caption);
        }
        if (c.width && c.width.length > 0)
            addString('width', c.width);
        if (properties.length > 0) {
            if (columnMember != '') {
                properties = '\n    column: ' + columnMember + ', ' + properties;
            }
        }
        /** @type {?} */
        var whatToAdd = '';
        if (properties.length > 0)
            whatToAdd = "{" + properties + "\n  }";
        else if (columnMember != '')
            whatToAdd = columnMember;
        return whatToAdd;
    };
    /**
     * @param {?} col
     * @param {?} what
     * @return {?}
     */
    ColumnCollection.prototype.__changeWidth = /**
     * @param {?} col
     * @param {?} what
     * @return {?}
     */
    function (col, what) {
        /** @type {?} */
        var width = col.width;
        if (!width)
            width = '50';
        width = ((+width) + what).toString();
        col.width = width;
    };
    /**
     * @param {?} col
     * @param {?} r
     * @return {?}
     */
    ColumnCollection.prototype._colValueChanged = /**
     * @param {?} col
     * @param {?} r
     * @return {?}
     */
    function (col, r) {
        if (col.onUserChangedValue)
            col.onUserChangedValue(r);
    };
    /**
     * @private
     * @return {?}
     */
    ColumnCollection.prototype._initColumnsArrays = /**
     * @private
     * @return {?}
     */
    function () {
        var e_8, _a;
        if (this._lastColumnCount != this.items.length || this._lastNumOfColumnsInGrid != this.numOfColumnsInGrid) {
            this._lastNumOfColumnsInGrid = this.numOfColumnsInGrid;
            this._lastColumnCount = this.items.length;
            this.gridColumns = [];
            this.nonGridColumns = [];
            /** @type {?} */
            var i = 0;
            try {
                for (var _b = __values(this.items), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (i++ < this._lastNumOfColumnsInGrid)
                        this.gridColumns.push(c);
                    else
                        this.nonGridColumns.push(c);
                }
            }
            catch (e_8_1) { e_8 = { error: e_8_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_8) throw e_8.error; }
            }
        }
    };
    /**
     * @return {?}
     */
    ColumnCollection.prototype.getGridColumns = /**
     * @return {?}
     */
    function () {
        this._initColumnsArrays();
        return this.gridColumns;
    };
    /**
     * @return {?}
     */
    ColumnCollection.prototype.getNonGridColumns = /**
     * @return {?}
     */
    function () {
        this._initColumnsArrays();
        return this.nonGridColumns;
    };
    return ColumnCollection;
}());
/**
 * @template T
 * @param {?} entity
 * @param {?} opt
 * @return {?}
 */
function extractSortFromSettings(entity, opt) {
    if (!opt)
        return undefined;
    if (!opt.orderBy)
        return undefined;
    /** @type {?} */
    var x = opt.orderBy(entity);
    return translateSort(x);
}
/**
 * @param {?} sort
 * @return {?}
 */
function translateSort(sort) {
    if (sort instanceof Sort)
        return sort;
    if (sort instanceof Column)
        return new Sort({ column: sort });
    if (sort instanceof Array) {
        /** @type {?} */
        var r_1 = new Sort();
        sort.forEach((/**
         * @param {?} i
         * @return {?}
         */
        function (i) {
            if (i instanceof Column)
                r_1.Segments.push({ column: i });
            else
                r_1.Segments.push(i);
        }));
        return r_1;
    }
}
var FilterConsumerBridgeToSqlRequest = /** @class */ (function () {
    function FilterConsumerBridgeToSqlRequest(r) {
        this.r = r;
        this.where = "";
    }
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumerBridgeToSqlRequest.prototype.isEqualTo = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        this.add(col, val, "=");
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumerBridgeToSqlRequest.prototype.isDifferentFrom = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        this.add(col, val, "<>");
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumerBridgeToSqlRequest.prototype.isGreaterOrEqualTo = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        this.add(col, val, ">=");
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumerBridgeToSqlRequest.prototype.isGreaterThan = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        this.add(col, val, ">");
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumerBridgeToSqlRequest.prototype.isLessOrEqualTo = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        this.add(col, val, "<=");
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumerBridgeToSqlRequest.prototype.isLessThan = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        this.add(col, val, "<");
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumerBridgeToSqlRequest.prototype.isContains = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        this.add(col, '%' + val + '%', 'like');
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumerBridgeToSqlRequest.prototype.isStartsWith = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        this.add(col, val + '%', 'like');
    };
    /**
     * @private
     * @param {?} col
     * @param {?} val
     * @param {?} operator
     * @return {?}
     */
    FilterConsumerBridgeToSqlRequest.prototype.add = /**
     * @private
     * @param {?} col
     * @param {?} val
     * @param {?} operator
     * @return {?}
     */
    function (col, val, operator) {
        if (this.where.length == 0) {
            this.where += ' where ';
        }
        else
            this.where += ' and ';
        this.where += col.__getDbName() + ' ' + operator + ' ' + this.r.addParameterToCommandAndReturnParameterName(col, val);
    };
    return FilterConsumerBridgeToSqlRequest;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DataControlComponent = /** @class */ (function () {
    function DataControlComponent() {
        this.settings = new ColumnCollection(undefined, (/**
         * @return {?}
         */
        function () { return true; }), undefined, undefined);
    }
    Object.defineProperty(DataControlComponent.prototype, "column", {
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.map = {
                column: value
            };
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    DataControlComponent.prototype.showDescription = /**
     * @return {?}
     */
    function () {
        return (this.map.column) && this.map.getValue;
    };
    /**
     * @return {?}
     */
    DataControlComponent.prototype.dataControlStyle = /**
     * @return {?}
     */
    function () {
        return this.settings.__dataControlStyle(this.map);
    };
    /**
     * @return {?}
     */
    DataControlComponent.prototype._getColumn = /**
     * @return {?}
     */
    function () {
        return this.settings.__getColumn(this.map, this.record);
    };
    /**
     * @return {?}
     */
    DataControlComponent.prototype._getEditable = /**
     * @return {?}
     */
    function () {
        if (this.notReadonly)
            return true;
        return this.settings._getEditable(this.map);
    };
    /**
     * @return {?}
     */
    DataControlComponent.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    DataControlComponent.prototype.isSelect = /**
     * @return {?}
     */
    function () {
        if (this.map.dropDown)
            return true;
        return false;
    };
    /**
     * @return {?}
     */
    DataControlComponent.prototype.showTextBox = /**
     * @return {?}
     */
    function () {
        return !this.isSelect() && !this.showCheckbox();
    };
    /**
     * @return {?}
     */
    DataControlComponent.prototype.showCheckbox = /**
     * @return {?}
     */
    function () {
        return this.settings._getColDataType(this.map) == 'checkbox';
    };
    DataControlComponent.decorators = [
        { type: Component, args: [{
                    selector: 'data-control',
                    template: "\n<span *ngIf=\"!_getEditable()\" >{{settings._getColDisplayValue(map,record)}}</span>\n<div *ngIf=\"_getEditable()\" class=\"\" [class.has-error]=\"settings._getError(map,record)\">\n    <div >\n        <div [class.input-group]=\"showDescription()||map.click\" *ngIf=\"showTextBox()\" style=\"width:100%\">\n            <div class=\"input-group-btn\" *ngIf=\"map.click\">\n                <button type=\"button\" class=\"btn btn-default\" (click)=\"settings._click(map,record)\" > <span class=\"glyphicon glyphicon-chevron-down\"></span></button>\n            </div>\n\n            <input class=\"form-control\"  [(ngModel)]=\"_getColumn().inputValue\" type=\"{{settings._getColDataType(map)}}\" (ngModelChange)=\"settings._colValueChanged(map,record)\" *ngIf=\"!map.hideDataOnInput\" />\n            <div class=\"input-group-addon\" style=\"width:60%;text-align:start\" *ngIf=\"showDescription()\">{{settings._getColDisplayValue(map,record)}}</div>\n\n        </div>\n        <div *ngIf=\"isSelect()\">\n            <select  class=\"form-control\" [(ngModel)]=\"_getColumn().inputValue\" (ngModelChange)=\"settings._colValueChanged(map,record)\" >\n                <option *ngFor=\"let v of map.dropDown.items\" value=\"{{v.id}}\">{{v.caption}}</option>\n\n            </select>\n        </div>\n        <div *ngIf=\"showCheckbox()\" style=\"width:100%\">\n        <input class=\"form-control\"  [(ngModel)]=\"_getColumn().inputValue\" type=\"checkbox\" (ngModelChange)=\"settings._colValueChanged(map,record)\" *ngIf=\"!map.hideDataOnInput\" />\n        \n\n    </div>\n    <span class=\"help-block\" *ngIf=\"settings._getError(map,record)\">{{settings._getError(map,record)}}</span>\n\n    </div>\n</div>"
                }] }
    ];
    DataControlComponent.propDecorators = {
        map: [{ type: Input }],
        column: [{ type: Input }],
        record: [{ type: Input }],
        notReadonly: [{ type: Input }],
        settings: [{ type: Input }]
    };
    return DataControlComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DataControl2Component = /** @class */ (function () {
    function DataControl2Component() {
        this.settings = new ColumnCollection(undefined, (/**
         * @return {?}
         */
        function () { return true; }), undefined, undefined);
        this.ngErrorStateMatches = new /** @class */ (function (_super) {
            __extends(class_1, _super);
            function class_1(parent) {
                var _this = _super.call(this) || this;
                _this.parent = parent;
                return _this;
            }
            /**
             * @return {?}
             */
            class_1.prototype.isErrorState = /**
             * @return {?}
             */
            function () {
                return !!this.parent.getError();
            };
            return class_1;
        }(ErrorStateMatcher))(this);
    }
    Object.defineProperty(DataControl2Component.prototype, "column", {
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.map = {
                column: value
            };
            this.map.column.__decorateDataSettings(this.map);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    DataControl2Component.prototype.showDescription = /**
     * @return {?}
     */
    function () {
        return (this.map.column) && this.map.getValue || !this._getEditable();
    };
    /**
     * @return {?}
     */
    DataControl2Component.prototype.showClick = /**
     * @return {?}
     */
    function () {
        if (!this.map.click)
            return false;
        if (this.map.allowClick === undefined) {
            return true;
        }
        return this.map.allowClick(this.record);
    };
    /**
     * @return {?}
     */
    DataControl2Component.prototype.getClickIcon = /**
     * @return {?}
     */
    function () {
        if (this.map.clickIcon)
            return this.map.clickIcon;
        return 'keyboard_arrow_down';
    };
    /**
     * @return {?}
     */
    DataControl2Component.prototype.dataControlStyle = /**
     * @return {?}
     */
    function () {
        return this.settings.__dataControlStyle(this.map);
    };
    /**
     * @return {?}
     */
    DataControl2Component.prototype._getColumn = /**
     * @return {?}
     */
    function () {
        if (!this.map.column)
            return new StringColumn();
        return this.settings.__getColumn(this.map, this.record);
    };
    /**
     * @return {?}
     */
    DataControl2Component.prototype._getEditable = /**
     * @return {?}
     */
    function () {
        if (this.notReadonly)
            return true;
        return this.settings._getEditable(this.map);
    };
    /**
     * @return {?}
     */
    DataControl2Component.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    DataControl2Component.prototype.isSelect = /**
     * @return {?}
     */
    function () {
        if (this.map.dropDown)
            return true;
        return false;
    };
    /**
     * @return {?}
     */
    DataControl2Component.prototype.showTextBox = /**
     * @return {?}
     */
    function () {
        return !this.isSelect() && !this.showCheckbox();
    };
    /**
     * @return {?}
     */
    DataControl2Component.prototype.showCheckbox = /**
     * @return {?}
     */
    function () {
        return this.settings._getColDataType(this.map) == 'checkbox';
    };
    /**
     * @return {?}
     */
    DataControl2Component.prototype.getError = /**
     * @return {?}
     */
    function () {
        return this.settings._getError(this.map, this.record);
    };
    /**
     * @return {?}
     */
    DataControl2Component.prototype.getStyle = /**
     * @return {?}
     */
    function () {
        if (this.showDescription()) {
            if (this.map.hideDataOnInput || !this._getEditable()) {
                return { display: 'none' };
            }
            return { width: '50px' };
        }
        return {};
    };
    /**
     * @return {?}
     */
    DataControl2Component.prototype.getFloatLabel = /**
     * @return {?}
     */
    function () {
        if (this.showDescription()) {
            if (this.settings._getColDisplayValue(this.map, this.record))
                return 'always';
        }
        return '';
    };
    DataControl2Component.decorators = [
        { type: Component, args: [{
                    selector: 'data-control2',
                    template: "\r\n<div class=\"data-control2\">\r\n    <mat-form-field appearance=\"outline\" [floatLabel]=\"getFloatLabel()\" *ngIf=\"!showCheckbox()\" class=\"full-width-form-field dense-form-field\">\r\n        <mat-label>{{map.caption}}</mat-label>\r\n        <div style=\"display:flex;\" *ngIf=\"showTextBox()\">\r\n            <input #theId matInput [(ngModel)]=\"_getColumn().inputValue\" type=\"{{settings._getColDataType(map)}}\"\r\n                (ngModelChange)=\"settings._colValueChanged(map,record)\" [errorStateMatcher]=\"ngErrorStateMatches\"\r\n                [ngStyle]=\"getStyle()\" />\r\n            <div *ngIf=\"showDescription()\" style=\"white-space: nowrap;\r\n            overflow: hidden;\r\n            text-overflow: ellipsis;\r\n            padding-left:10px;\">\r\n                {{settings._getColDisplayValue(map,record)}}&nbsp;</div>\r\n        </div>\r\n        <div *ngIf=\"isSelect()\">\r\n            <select matNativeControl [(ngModel)]=\"_getColumn().inputValue\"\r\n                (ngModelChange)=\"settings._colValueChanged(map,record)\">\r\n                <option *ngFor=\"let v of map.dropDown.items\" value=\"{{v.id}}\">{{v.caption}}</option>\r\n\r\n            </select>\r\n        </div>\r\n\r\n        <button mat-icon-button matSuffix *ngIf=\"showClick()\" (click)=\"settings._click(map,record)\">\r\n            <mat-icon>{{getClickIcon()}}  </mat-icon>\r\n        </button>\r\n\r\n        <mat-error *ngIf=\"getError()\" [id]=\"theId\">{{getError()}}</mat-error>\r\n    </mat-form-field>\r\n    <div *ngIf=\"showCheckbox()\">\r\n        <mat-checkbox #theId1 [(ngModel)]=\"_getColumn().inputValue\"\r\n            (ngModelChange)=\"settings._colValueChanged(map,record)\" class=\"fix-label\">{{map.caption}}</mat-checkbox>\r\n        <mat-error *ngIf=\"getError()\" [id]=\"theId1\">{{getError()}}</mat-error>\r\n    </div>\r\n\r\n</div>",
                    styles: [""]
                }] }
    ];
    DataControl2Component.propDecorators = {
        map: [{ type: Input }],
        column: [{ type: Input }],
        record: [{ type: Input }],
        notReadonly: [{ type: Input }],
        settings: [{ type: Input }]
    };
    return DataControl2Component;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DataControl3Component = /** @class */ (function () {
    function DataControl3Component() {
        this.rightToLeft = false;
        this.settings = new ColumnCollection(undefined, (/**
         * @return {?}
         */
        function () { return true; }), undefined, undefined);
        this.ngErrorStateMatches = new /** @class */ (function (_super) {
            __extends(class_1, _super);
            function class_1(parent) {
                var _this = _super.call(this) || this;
                _this.parent = parent;
                return _this;
            }
            /**
             * @return {?}
             */
            class_1.prototype.isErrorState = /**
             * @return {?}
             */
            function () {
                return !!this.parent.getError();
            };
            return class_1;
        }(ErrorStateMatcher))(this);
    }
    Object.defineProperty(DataControl3Component.prototype, "column", {
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.map = {
                column: value
            };
            this.map.column.__decorateDataSettings(this.map);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    DataControl3Component.prototype.showDescription = /**
     * @return {?}
     */
    function () {
        return (this.map.column) && this.map.getValue || !this._getEditable();
    };
    /**
     * @return {?}
     */
    DataControl3Component.prototype.showClick = /**
     * @return {?}
     */
    function () {
        if (!this.map.click)
            return false;
        if (this.map.allowClick === undefined) {
            return true;
        }
        return this.map.allowClick(this.record);
    };
    /**
     * @return {?}
     */
    DataControl3Component.prototype.getClickIcon = /**
     * @return {?}
     */
    function () {
        if (this.map.clickIcon)
            return this.map.clickIcon;
        return 'keyboard_arrow_down';
    };
    /**
     * @return {?}
     */
    DataControl3Component.prototype.dataControlStyle = /**
     * @return {?}
     */
    function () {
        return this.settings.__dataControlStyle(this.map);
    };
    /**
     * @return {?}
     */
    DataControl3Component.prototype._getColumn = /**
     * @return {?}
     */
    function () {
        if (!this.map.column)
            return new StringColumn();
        return this.settings.__getColumn(this.map, this.record);
    };
    /**
     * @return {?}
     */
    DataControl3Component.prototype._getEditable = /**
     * @return {?}
     */
    function () {
        if (this.notReadonly)
            return true;
        return this.settings._getEditable(this.map);
    };
    /**
     * @return {?}
     */
    DataControl3Component.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    DataControl3Component.prototype.isSelect = /**
     * @return {?}
     */
    function () {
        if (this.map.dropDown)
            return true;
        return false;
    };
    /**
     * @return {?}
     */
    DataControl3Component.prototype.showTextBox = /**
     * @return {?}
     */
    function () {
        return !this.isSelect() && !this.showCheckbox();
    };
    /**
     * @return {?}
     */
    DataControl3Component.prototype.showCheckbox = /**
     * @return {?}
     */
    function () {
        return this.settings._getColDataType(this.map) == 'checkbox';
    };
    /**
     * @return {?}
     */
    DataControl3Component.prototype.getError = /**
     * @return {?}
     */
    function () {
        return this.settings._getError(this.map, this.record);
    };
    /**
     * @return {?}
     */
    DataControl3Component.prototype.getStyle = /**
     * @return {?}
     */
    function () {
        if (this.showDescription()) {
            if (this.map.hideDataOnInput || !this._getEditable()) {
                return { display: 'none' };
            }
            return { width: '50px' };
        }
        return {
            width: '100%'
        };
    };
    /**
     * @return {?}
     */
    DataControl3Component.prototype.getFloatLabel = /**
     * @return {?}
     */
    function () {
        if (this.showDescription()) {
            if (this.settings._getColDisplayValue(this.map, this.record))
                return 'always';
        }
        return '';
    };
    DataControl3Component.decorators = [
        { type: Component, args: [{
                    selector: 'data-control3',
                    template: "\r\n<div class=\"data-control3\" #myDiv >\r\n        \r\n        <div style=\"display:flex;width:100%;\" *ngIf=\"showTextBox()\">\r\n            <input #theId matInput [(ngModel)]=\"_getColumn().inputValue\" type=\"{{settings._getColDataType(map)}}\"\r\n                (ngModelChange)=\"settings._colValueChanged(map,record)\" [errorStateMatcher]=\"ngErrorStateMatches\"\r\n                [ngStyle]=\"getStyle()\" />\r\n            <div *ngIf=\"showDescription()\" style=\"white-space: nowrap;\r\n            overflow: hidden;\r\n            text-overflow: ellipsis;\r\n            padding-left:10px;\">\r\n                {{settings._getColDisplayValue(map,record)}}&nbsp;</div>\r\n        </div>\r\n        <div *ngIf=\"isSelect()\" class=\"my-select\" [class.rtl-select]=\"rightToLeft\">\r\n            <select matNativeControl [(ngModel)]=\"_getColumn().inputValue\" \r\n                (ngModelChange)=\"settings._colValueChanged(map,record)\">\r\n                <option *ngFor=\"let v of map.dropDown.items\" value=\"{{v.id}}\">{{v.caption}}</option>\r\n\r\n            </select>\r\n        </div>\r\n\r\n        <button mat-icon-button *ngIf=\"showClick()\" (click)=\"settings._click(map,record)\" class=\"row-button\">\r\n            <mat-icon style=\"height:19px;\">{{getClickIcon()}}  </mat-icon>\r\n        </button>\r\n\r\n        \r\n    <div *ngIf=\"showCheckbox()\">\r\n        <mat-checkbox #theId1 [(ngModel)]=\"_getColumn().inputValue\"\r\n            (ngModelChange)=\"settings._colValueChanged(map,record)\" class=\"fix-label\"></mat-checkbox>\r\n        <mat-error *ngIf=\"getError()\" [id]=\"theId1\">{{getError()}}</mat-error>\r\n    </div>\r\n\r\n</div>\r\n<mat-error *ngIf=\"getError()\" [id]=\"theId\" style=\"font-size: 75%;\">{{getError()}}</mat-error>",
                    styles: [".my-select::after{content:\"\";width:0;height:0;border-left:5px solid transparent;border-right:5px solid transparent;border-top:5px solid;position:absolute;top:50%;right:0;pointer-events:none;color:rgba(0,0,0,.54);margin-top:-5px}.rtl-select::after{right:auto;left:0}.my-select{position:relative;width:100%}.data-control3{display:flex;width:100%}.row-button{height:auto;line-height:normal}"]
                }] }
    ];
    DataControl3Component.propDecorators = {
        map: [{ type: Input }],
        column: [{ type: Input }],
        rightToLeft: [{ type: Input }],
        record: [{ type: Input }],
        notReadonly: [{ type: Input }],
        settings: [{ type: Input }]
    };
    return DataControl3Component;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DataGridComponent = /** @class */ (function () {
    function DataGridComponent() {
        this.displayButtons = true;
        this.displayVCR = true;
        this.rowButtons = [];
        this.keys = [];
        this.page = 1;
    }
    /**
     * @param {?} c
     * @return {?}
     */
    DataGridComponent.prototype.isFiltered = /**
     * @param {?} c
     * @return {?}
     */
    function (c) {
        return this.settings.columns.filterHelper.isFiltered(c);
    };
    /**
     * @param {?} b
     * @param {?} row
     * @return {?}
     */
    DataGridComponent.prototype.getButtonCssClass = /**
     * @param {?} b
     * @param {?} row
     * @return {?}
     */
    function (b, row) {
        if (!b.cssClass)
            return "";
        if (isFunction$1(b.cssClass))
            return ((/** @type {?} */ (b.cssClass)))(row);
        return b.cssClass.toString();
    };
    /**
     * @private
     * @param {?} b
     * @return {?}
     */
    DataGridComponent.prototype.addButton = /**
     * @private
     * @param {?} b
     * @return {?}
     */
    function (b) {
        if (!b.click)
            b.click = (/**
             * @param {?} r
             * @return {?}
             */
            function (r) { });
        if (!b.visible)
            b.visible = (/**
             * @param {?} r
             * @return {?}
             */
            function (r) { return true; });
        if (!b.cssClass)
            b.cssClass = (/**
             * @param {?} r
             * @return {?}
             */
            function (r) { return "btn"; });
        else if (!isFunction$1(b.cssClass)) {
            /** @type {?} */
            var x_1 = b.cssClass;
            b.cssClass = (/** @type {?} */ (((/**
             * @param {?} r
             * @return {?}
             */
            function (r) { return x_1; }))));
        }
        this.rowButtons.push(b);
        return b;
    };
    /**
     * @param {?} row
     * @return {?}
     */
    DataGridComponent.prototype.rowClicked = /**
     * @param {?} row
     * @return {?}
     */
    function (row) {
        this.settings.setCurrentRow(row);
    };
    /**
     * @return {?}
     */
    DataGridComponent.prototype.nextPage = /**
     * @return {?}
     */
    function () {
        this.page++;
    };
    /**
     * @return {?}
     */
    DataGridComponent.prototype.previousPage = /**
     * @return {?}
     */
    function () {
        if (this.page <= 1)
            return;
        this.page--;
    };
    /**
     * @param {?} what
     * @param {?} r
     * @return {?}
     */
    DataGridComponent.prototype.catchErrors = /**
     * @param {?} what
     * @param {?} r
     * @return {?}
     */
    function (what, r) {
        var _this = this;
        what.catch((/**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            _this.showError(r);
        }));
    };
    /**
     * @private
     * @param {?} row
     * @return {?}
     */
    DataGridComponent.prototype.showError = /**
     * @private
     * @param {?} row
     * @return {?}
     */
    function (row) {
        /** @type {?} */
        var message = row.error;
        if (!message)
            message = "";
        /** @type {?} */
        var foundStateErrors = false;
        row.__iterateColumns().forEach((/**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            if (c.error) {
                if (!foundStateErrors) {
                    foundStateErrors = true;
                    message = "";
                }
                /** @type {?} */
                var m = c.caption + ": ";
                m += c.error;
                message += m + "\n";
            }
        }));
        alert(message);
    };
    /**
     * @return {?}
     */
    DataGridComponent.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        var _this = this;
        var e_1, _a;
        if (!this.settings)
            return;
        this.rowButtons = [];
        if (this.settings.allowUpdate) {
            this.addButton({
                name: "",
                cssClass: "glyphicon glyphicon-ok btn-success",
                visible: (/**
                 * @param {?} r
                 * @return {?}
                 */
                function (r) { return r.wasChanged(); }),
                click: (/**
                 * @param {?} r
                 * @return {?}
                 */
                function (r) {
                    _this.catchErrors(_this.settings._doSavingRow(r), r);
                }),
            });
            this.addButton({
                name: "",
                cssClass: "btn btn-danger glyphicon glyphicon-ban-circle",
                visible: (/**
                 * @param {?} r
                 * @return {?}
                 */
                function (r) { return r.wasChanged(); }),
                click: (/**
                 * @param {?} r
                 * @return {?}
                 */
                function (r) {
                    r.reset();
                })
            });
        }
        if (this.settings.allowDelete)
            this.addButton({
                name: '',
                visible: (/**
                 * @param {?} r
                 * @return {?}
                 */
                function (r) { return !isNewRow(r); }),
                click: (/**
                 * @param {?} r
                 * @return {?}
                 */
                function (r) {
                    if (_this.settings.setCurrentRow && _this.settings.settings.confirmDelete) {
                        _this.settings.settings.confirmDelete(r, (/**
                         * @return {?}
                         */
                        function () { return _this.catchErrors(r.delete(), r); }));
                    }
                    else
                        _this.catchErrors(r.delete(), r);
                }),
                cssClass: "btn-danger glyphicon glyphicon-trash"
            });
        if (this.settings._buttons)
            try {
                for (var _b = __values(this.settings._buttons), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    this.addButton(b);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        if (!this.records && this.settings) {
            this.settings.getRecords().then((/**
             * @param {?} r
             * @return {?}
             */
            function (r) {
                _this.records = r;
            }));
        }
    };
    /**
     * @param {?} row
     * @return {?}
     */
    DataGridComponent.prototype._getRowClass = /**
     * @param {?} row
     * @return {?}
     */
    function (row) {
        /** @type {?} */
        var r = '';
        if (this.settings.rowClass)
            r += this.settings.rowClass(row);
        if (row == this.settings.currentRow)
            r += " active";
        return r;
    };
    DataGridComponent.decorators = [
        { type: Component, args: [{
                    selector: 'data-grid',
                    template: "\n\n  <div *ngIf=\"settings&&settings.columns&& settings.columns.designMode\">\n<pre>\n{{settings.columns.__columnSettingsTypeScript()}}\n</pre>\n\n\n  </div>\n  <div  >\n  <div  *ngIf=\"settings && records && displayVCR\">\n    <button class=\"btn glyphicon glyphicon-pencil btn-primary\" *ngIf=\"settings.columns.allowDesignMode\" (click)=\"settings.columns.designMode=!settings.columns.designMode\"></button>\n    <button class=\"btn glyphicon glyphicon-chevron-left\" *ngIf=\"settings.page>1\" (click)=\"settings.previousPage()\"></button>\n    <button class=\"btn glyphicon glyphicon-chevron-right\" *ngIf=\"records.items&& records.items.length>0\" (click)=\"settings.nextPage()\"></button>\n    <button class=\"btn btn-primary glyphicon glyphicon-plus\" *ngIf=\"settings.allowUpdate &&settings.allowInsert\" (click)=\"settings.addNewRow()\"></button>\n    <button class=\"btn glyphicon glyphicon glyphicon-cog\" (click)=\"settings.userChooseColumns()\"></button>\n    <button class=\"btn glyphicon glyphicon glyphicon-filter\" (click)=\"dataFilter.userFilterButton()\"></button>\n    <button class=\"btn glyphicon glyphicon glyphicon-repeat\" (click)=\"settings.getRecords()\"></button>\n\n        \n \n  </div>\n  <Data-Filter [settings]=\"settings\" #dataFilter></Data-Filter>\n  <div *ngIf=\"settings.showSelectColumn\" class=\"selectColumnsArea\">\n  lines per page\n  <select class=\"form-control\" style=\"width:100px;display:inline-block\" [(ngModel)]=\"settings.rowsPerPage\" (change)=\"settings.getRecords()\">\n          <option *ngFor=\"let r of settings.rowsPerPageOptions\" value=\"{{r}}\">{{r}}</option>\n      </select><br/>\n  Select Columns\n  <ol>\n  <li *ngFor=\"let c of settings.currList; let i=index\">\n      <select [(ngModel)]=\"settings.currList[i]\" class=\"form-control selectColumnCombo\" (change)=\"settings.columns.colListChanged()\">\n          <option *ngFor=\"let o of settings.origList\" [ngValue]=\"o\">{{o.caption}}</option>\n      </select>\n      <button class=\"btn btn-sm glyphicon glyphicon-trash\" *ngIf=\"settings.currList.length>1\" (click)=\"settings.deleteCol(c)\"></button>\n      <button class=\"btn btn-sm  glyphicon glyphicon-plus\" (click)=\"settings.addCol(c)\"></button>\n      <button class=\"btn btn-sm  glyphicon glyphicon-chevron-down\" *ngIf=\"i<settings.currList.length-1\"(click)=\"settings.columns.moveCol(c,1)\"></button>\n      <button class=\"btn btn-sm  glyphicon glyphicon-chevron-up\" *ngIf=\"i>0\" (click)=\"settings.columns.moveCol(c,-1)\"></button>\n  </li>\n</ol>\n<button (click)=\"settings.resetColumns()\" class=\"btn glyphicon glyphicon-repeat\"></button>\n</div>\n<div>\n    <table class=\"table table-bordered table-condensed table-hover table-striped \" *ngIf=\"settings&&settings.columns\">\n\n      <thead>\n        <tr>\n          <th *ngFor=\"let map of settings.columns.getGridColumns()\" class=\"headerWithFilter\" [style.width]=\"settings.columns.__dataControlStyle(map)\">\n\n            <span (click)=\"settings.sort(map.column)\">{{map.caption}}</span>\n\n\n            <span class=\"glyphicon glyphicon-filter filterButton\" [class.filteredFilterButton]=\"isFiltered(map.column)\"\n              (click)=\"settings.columns.showFilterDialog(map)\"></span>\n            <div class=\"filterDialog col-sm-4\" *ngIf=\"settings.columns._shouldShowFilterDialog(map)\">\n              <div class=\"form-group\">\n                <data-control [settings]=\"settings.columns\" [map]=\"map\" [record]=\"settings.columns.filterHelper.filterRow\" [notReadonly]=\"true\"></data-control>\n              </div>\n              <button class=\"btn glyphicon glyphicon-ok btn-success\" (click)=\"settings.columns.filterRows(map)\"></button>\n              <button class=\"btn glyphicon glyphicon-remove btn-primary\" (click)=\"settings.columns.clearFilter(map)\"></button>\n\n            </div>\n            <span class=\"glyphicon glyphicon-chevron-up pull-right\" *ngIf=\"settings.sortedAscending(map.column)\"></span>\n            <span class=\"glyphicon glyphicon-chevron-down pull-right\" *ngIf=\"settings.sortedDescending(map.column)\"></span>\n            <column-designer [settings]=\"settings.columns\" [map]=\"map\"></column-designer>\n\n\n\n\n\n          </th>\n          <th *ngIf=\"rowButtons&& rowButtons.length>0&&displayButtons\" [class.col-xs-1]=\"rowButtons&&rowButtons.length<3\" [class.col-xs-2]=\"rowButtons.length>=3\"></th>\n        </tr>\n      </thead>\n      <tbody>\n        <tr *ngFor=\"let record of records\" [className]=\"_getRowClass(record)\" (click)=\"rowClicked(record)\">\n\n          <td *ngFor=\"let map of settings.columns.getGridColumns()\" [className]=\"settings.columns._getColumnClass(map,record)\">\n            <data-control [settings]=\"settings.columns\" [map]=\"map\" [record]=\"record\"></data-control>\n          </td>\n          <td *ngIf=\"rowButtons.length>0&&displayButtons\" style=\"white-space:nowrap\">\n            <span *ngFor=\"let b of rowButtons\">\n              <button class=\"btn {{getButtonCssClass(b,record) }}\" *ngIf=\"b.visible(record)\" (click)=\"b.click(record)\">{{b.name}}</button>\n            </span>\n          </td>\n        </tr>\n\n      </tbody>\n    </table>\n  </div>\n  <data-area *ngIf=\"!settings.hideDataArea\" [settings]=\"settings\" [columns]=\"2\"></data-area>\n  ",
                    styles: ["\n\n.filterDialog {\n    background-color: white;\n    position: absolute;\n    padding: 10px;\n    border-color: gray;\n    border-width: 2px;\n    border-style: solid;\n    z-index: 800;\n    border-radius: 5px;\n\n}\n\n    .filterDialog .form-group {\n        margin-right: 0;\n        margin-left: 0;\n    }\n\n.designModeButton span {\n    visibility: hidden;\n}\n\n.designModeButton:hover span {\n    visibility: visible\n}\n.selectColumnCombo{\n  display:inline-block;\n  width:auto;\n}\n.selectColumnsArea{\n  display:block;\n}\n\n.headerWithFilter {\n}\n.headerWithFilter .filterButton{\n    visibility:hidden;\n}\n    .headerWithFilter .filteredFilterButton {\n        visibility: visible;\n    }\n    .headerWithFilter:hover .filterButton {\n        visibility: visible;\n    }\n\n.filterButton {\n}\ntable input {\n    min-width:75px;\n}\ntable select {\n    min-width:100px\n}"]
                }] }
    ];
    DataGridComponent.propDecorators = {
        displayButtons: [{ type: Input }],
        displayVCR: [{ type: Input }],
        records: [{ type: Input }],
        settings: [{ type: Input }]
    };
    return DataGridComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ColumnDesigner = /** @class */ (function () {
    function ColumnDesigner() {
    }
    ColumnDesigner.decorators = [
        { type: Component, args: [{
                    selector: 'column-designer',
                    template: "\n<div *ngIf=\"map.designMode\" class=\"columnDesigner\">\n    <div class=\"form-group\">\n        <input type=\"text\" class=\"form-control\" [(ngModel)]=\"map.caption\">\n    </div>\n    <div class=\"form-group\">\n      <label >Width</label>\n      <div class=\"input-group\">\n      <input type=\"text\" class=\"form-control\" [(ngModel)]=\"map.width\">\n      <span class=\"input-group-btn\">\n        <button class=\"btn btn-default\" type=\"button\" (click)=\"settings.__changeWidth(map,-10)\">-</button>\n      </span>\n      <span class=\"input-group-btn\">\n      <button class=\"btn btn-default\" type=\"button\" (click)=\"settings.__changeWidth(map,10)\">+</button>\n    </span>\n    </div><!-- /input-group -->\n      \n    </div>\n\n    <label>Input Type</label>\n    <div class=\"form-group\">\n        <select class=\"form-control\" [(ngModel)]=\"map.inputType\" placeholder=\"inputType\">\n            <option value=\"\" selected>text</option>\n            <option value=\"number\">number</option>\n            <option value=\"date\">date</option>\n            <option value=\"checkbox\">checkbox</option>\n        </select>\n    </div>\n\n    <div class=\"form-group\">\n      <label>\n           <input type=\"checkbox\"  [(ngModel)]=\"map.readonly\"> Readonly\n      </label>\n    </div>\n\n\n    <div class=\"form-group\">\n\n        <button class=\"btn btn-success glyphicon glyphicon-ok pull-left\" (click)=\"settings.designColumn(map)\"></button>\n        <div class=\"btn-group pull-right\">\n                <button class=\"btn btn-danger glyphicon glyphicon-trash \" (click)=\"settings.deleteCol(map)\"></button>\n                <button class=\"btn btn-primary glyphicon glyphicon-plus \" (click)=\"settings.addCol(map)\"></button>\n                <button class=\"btn btn-primary glyphicon glyphicon-chevron-left\" (click)=\"settings.moveCol(map,-1)\"></button>\n                <button class=\"btn btn-primary glyphicon glyphicon-chevron-right\" (click)=\"settings.moveCol(map,1)\"></button>\n        </div>\n    </div>\n</div>\n<span class=\"designModeButton pull-right\">\n<span class=\"glyphicon glyphicon-pencil \" (click)=\"settings.designColumn(map)\" *ngIf=\"settings.allowDesignMode\"></span>\n</span>\n",
                    styles: [".columnDesigner {\n  background-color: white;\n  position: absolute;\n  padding: 10px;\n  border-color: gray;\n  border-width: 2px;\n  border-style: solid;\n  z-index: 800;\n  border-radius: 5px;\n  width: 300px;\n}\n\n  .columnDesigner .form-group {\n      margin-right: 0;\n      margin-left: 0;\n  }"]
                }] }
    ];
    ColumnDesigner.propDecorators = {
        map: [{ type: Input }],
        settings: [{ type: Input }]
    };
    return ColumnDesigner;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DataFilterInfoComponent = /** @class */ (function () {
    function DataFilterInfoComponent() {
        this.showFilterButton = false;
        this.showAddFilter = false;
        this.editFilterVisible = false;
    }
    /**
     * @param {?} col
     * @return {?}
     */
    DataFilterInfoComponent.prototype.getCurrentFilterValue = /**
     * @param {?} col
     * @return {?}
     */
    function (col) {
        /** @type {?} */
        var m = this.settings.origList.find((/**
         * @param {?} x
         * @return {?}
         */
        function (x) { return x.column == col; }));
        return this.settings.columns._getColDisplayValue(m, this.settings.filterHelper.filterRow);
    };
    /**
     * @return {?}
     */
    DataFilterInfoComponent.prototype.cancelAddFilter = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @param {?} col
     * @return {?}
     */
    DataFilterInfoComponent.prototype.showEditFilter = /**
     * @param {?} col
     * @return {?}
     */
    function (col) {
        this.filterColumnToAdd = this.settings.origList.find((/**
         * @param {?} x
         * @return {?}
         */
        function (x) { return x.column == col; }));
        this.editFilterVisible = true;
        this.showAddFilter = false;
    };
    /**
     * @return {?}
     */
    DataFilterInfoComponent.prototype.userFilterButton = /**
     * @return {?}
     */
    function () {
        this.showFilterButton = !this.showFilterButton;
        this.settings.initOrigList();
        if (this.settings.filterHelper.filterColumns.length == 0)
            this.showAddAnotherFilterDialog();
    };
    /**
     * @return {?}
     */
    DataFilterInfoComponent.prototype.showAddAnotherFilterDialog = /**
     * @return {?}
     */
    function () {
        this.showAddFilter = true;
        this.filterColumnToAdd = undefined;
    };
    /**
     * @return {?}
     */
    DataFilterInfoComponent.prototype.confirmEditFilter = /**
     * @return {?}
     */
    function () {
        this.settings.columns.filterRows(this.filterColumnToAdd);
        this.editFilterVisible = false;
    };
    /**
     * @return {?}
     */
    DataFilterInfoComponent.prototype.clearEditFilter = /**
     * @return {?}
     */
    function () {
        this.settings.columns.clearFilter(this.filterColumnToAdd);
        this.editFilterVisible = false;
    };
    /**
     * @return {?}
     */
    DataFilterInfoComponent.prototype.addFilter = /**
     * @return {?}
     */
    function () {
        this.settings.columns.filterRows(this.filterColumnToAdd);
        this.showAddFilter = false;
    };
    /**
     * @return {?}
     */
    DataFilterInfoComponent.prototype.cancelAddNewFilter = /**
     * @return {?}
     */
    function () {
        this.showAddFilter = false;
    };
    DataFilterInfoComponent.decorators = [
        { type: Component, args: [{
                    selector: 'Data-Filter',
                    template: "<div *ngIf=\"this.showFilterButton\">\r\n    <ul>\r\n        <li *ngFor=\"let map of settings.columns.filterHelper.filterColumns\" (click)=\"this.showEditFilter(map)\">\r\n            {{map.caption}}: {{this.getCurrentFilterValue(map)}}\r\n        </li>\r\n        <li (click)=\"this.showAddAnotherFilterDialog()\" *ngIf=\"!showAddFilter&&!editFilterVisible\">...</li>\r\n    </ul>\r\n    <div *ngIf=\"this.editFilterVisible\">\r\n        {{this.filterColumnToAdd.caption}}:\r\n        <data-control2 *ngIf=\"this.filterColumnToAdd\" [settings]=\"settings.columns\" [map]=\"this.filterColumnToAdd\"\r\n            [record]=\"settings.columns.filterHelper.filterRow\" [notReadonly]=\"true\"></data-control2>\r\n        <button mat-icon-button (click)=\"this.confirmEditFilter()\">\r\n            <mat-icon>check</mat-icon>\r\n        </button>\r\n        <button mat-icon-button (click)=\"this.clearEditFilter()\">\r\n            <mat-icon>clear</mat-icon>\r\n        </button>\r\n    </div>\r\n    <div *ngIf=\"this.showAddFilter\">\r\n        <select [(ngModel)]=\"this.filterColumnToAdd\" class=\"form-control selectColumnCombo\"\r\n            (change)=\"settings.columns.colListChanged()\">\r\n            <option *ngFor=\"let o of settings.origList\" [ngValue]=\"o\">{{o.caption}} </option>\r\n        </select>\r\n        <data-control2 *ngIf=\"this.filterColumnToAdd\" [settings]=\"settings.columns\" [map]=\"this.filterColumnToAdd\"\r\n            [record]=\"settings.columns.filterHelper.filterRow\" [notReadonly]=\"true\"></data-control2>\r\n        <button mat-icon-button (click)=\"this.addFilter()\"><mat-icon>check</mat-icon></button>\r\n        <button mat-icon-button (click)=\"this.cancelAddNewFilter()\"><mat-icon>clear</mat-icon></button>\r\n    </div>\r\n</div>"
                }] }
    ];
    DataFilterInfoComponent.propDecorators = {
        settings: [{ type: Input }]
    };
    return DataFilterInfoComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DataAreaCompnent = /** @class */ (function () {
    function DataAreaCompnent() {
        this.settings = { columns: new ColumnCollection((/**
             * @return {?}
             */
            function () { return undefined; }), (/**
             * @return {?}
             */
            function () { return false; }), undefined, (/**
             * @return {?}
             */
            function () { return true; })), lines: [] };
        this.labelWidth = 4;
        this.columns = 1;
    }
    /**
     * @return {?}
     */
    DataAreaCompnent.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.settings && this.settings.columns) {
            this.settings.columns.onColListChange((/**
             * @return {?}
             */
            function () { return _this.lastCols = undefined; }));
            /** @type {?} */
            var areaSettings = (/** @type {?} */ (this.settings));
            if (areaSettings.settings) {
                if (areaSettings.settings.labelWidth)
                    this.labelWidth = areaSettings.settings.labelWidth;
                if (areaSettings.settings.numberOfColumnAreas)
                    this.columns = areaSettings.settings.numberOfColumnAreas;
            }
        }
    };
    /**
     * @return {?}
     */
    DataAreaCompnent.prototype.getColumnsClass = /**
     * @return {?}
     */
    function () {
        if (this.columns >= 1)
            return "col-sm-" + 12 / this.columns;
    };
    /**
     * @return {?}
     */
    DataAreaCompnent.prototype.theColumns = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var cols = this.settings.columns.getNonGridColumns();
        if (cols == this.lastAllCols)
            return this.lastCols;
        this.lastAllCols = cols;
        /** @type {?} */
        var r = [];
        this.lastCols = r;
        for (var i = 0; i < this.columns; i++) {
            r.push([]);
        }
        /** @type {?} */
        var itemsPerCol = Math.round(cols.length / this.columns);
        for (var i = 0; i < cols.length; i++) {
            r[Math.floor(i / itemsPerCol)].push(cols[i]);
        }
        return this.lastCols;
    };
    DataAreaCompnent.decorators = [
        { type: Component, args: [{
                    selector: 'data-area',
                    template: "\n\n<div class=\"form-horizontal row\" *ngIf=\"settings.columns&&settings.columns.__showArea()\" >\n\n        <div class=\"{{getColumnsClass()}}\" *ngFor=\"let col of theColumns()\">\n            <div class=\"form-group {{settings.columns._getColumnClass(map,settings.columns.currentRow())}}\" *ngFor=\"let map of col\" >\n                <div class=\"col-sm-{{labelWidth}}\">\n                    <label class=\"control-label\" *ngIf=\"!map.designMode\">{{map.caption}}</label>\n                    <column-designer [settings]=\"settings.columns\" [map]=\"map\"></column-designer>\n                </div>\n                <div class=\"col-sm-{{12-labelWidth}}\">\n                    <data-control [settings]=\"settings.columns\" [map]=\"map\" [record]=\"settings.columns.currentRow()\"></data-control>\n                </div>\n            </div>\n        </div>\n</div>\n\n\n"
                }] }
    ];
    DataAreaCompnent.propDecorators = {
        settings: [{ type: Input }],
        labelWidth: [{ type: Input }],
        columns: [{ type: Input }]
    };
    return DataAreaCompnent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DataGrid2Component = /** @class */ (function () {
    function DataGrid2Component() {
        this.rightToLeft = false;
        this.displayButtons = true;
        this.displayVCR = true;
        this.rowButtons = [];
        this.keys = [];
        this.page = 1;
    }
    /**
     * @return {?}
     */
    DataGrid2Component.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        if (window && window.getComputedStyle && this.dataGridDiv) {
            this.rightToLeft = window.getComputedStyle(this.dataGridDiv.nativeElement, null).getPropertyValue('direction') == 'rtl';
        }
    };
    /**
     * @param {?} map
     * @return {?}
     */
    DataGrid2Component.prototype.getColFlex = /**
     * @param {?} map
     * @return {?}
     */
    function (map) {
        return '0 0 ' + this.getColWidth(map);
    };
    /**
     * @param {?} map
     * @return {?}
     */
    DataGrid2Component.prototype.getColWidth = /**
     * @param {?} map
     * @return {?}
     */
    function (map) {
        /** @type {?} */
        var x = this.settings.columns.__dataControlStyle(map);
        if (!x)
            x = '200px';
        return x;
    };
    /**
     * @return {?}
     */
    DataGrid2Component.prototype.test = /**
     * @return {?}
     */
    function () {
        //this.dataGridDiv.nativeElement.scrollTop = 0;
    };
    /**
     * @return {?}
     */
    DataGrid2Component.prototype.getTotalRows = /**
     * @return {?}
     */
    function () {
        if (this.settings.totalRows)
            return Math.ceil(this.settings.totalRows / this.settings.rowsPerPage);
        if (this.rightToLeft)
            return 'רבים';
        return 'many';
    };
    /**
     * @param {?} x
     * @return {?}
     */
    DataGrid2Component.prototype.dragStart = /**
     * @param {?} x
     * @return {?}
     */
    function (x) {
        this.tempDragColumn = x;
    };
    /**
     * @param {?} x
     * @param {?} event
     * @return {?}
     */
    DataGrid2Component.prototype.dragOver = /**
     * @param {?} x
     * @param {?} event
     * @return {?}
     */
    function (x, event) {
        event.preventDefault();
    };
    /**
     * @param {?} x
     * @return {?}
     */
    DataGrid2Component.prototype.onDrop = /**
     * @param {?} x
     * @return {?}
     */
    function (x) {
        /** @type {?} */
        var oldPosition = this.settings.columns.items.indexOf(this.tempDragColumn);
        this.settings.columns.items.splice(oldPosition, 1);
        /** @type {?} */
        var newPosition = this.settings.columns.items.indexOf(x);
        if (newPosition == oldPosition)
            newPosition++;
        this.settings.columns.items.splice(newPosition, 0, this.tempDragColumn);
        this.settings.columns.colListChanged();
    };
    /**
     * @return {?}
     */
    DataGrid2Component.prototype._getHeight = /**
     * @return {?}
     */
    function () {
        if (this.height) {
            if ((+this.height).toString() == this.height)
                return this.height + "px";
            return this.height;
        }
    };
    /**
     * @param {?} c
     * @return {?}
     */
    DataGrid2Component.prototype.isFiltered = /**
     * @param {?} c
     * @return {?}
     */
    function (c) {
        return this.settings.columns.filterHelper.isFiltered(c);
    };
    /**
     * @param {?} b
     * @param {?} row
     * @return {?}
     */
    DataGrid2Component.prototype.getButtonCssClass = /**
     * @param {?} b
     * @param {?} row
     * @return {?}
     */
    function (b, row) {
        if (!b.cssClass)
            return "";
        if (isFunction$1(b.cssClass))
            return ((/** @type {?} */ (b.cssClass)))(row);
        return b.cssClass.toString();
    };
    /**
     * @private
     * @param {?} b
     * @return {?}
     */
    DataGrid2Component.prototype.addButton = /**
     * @private
     * @param {?} b
     * @return {?}
     */
    function (b) {
        if (!b.click)
            b.click = (/**
             * @param {?} r
             * @return {?}
             */
            function (r) { });
        if (!b.visible)
            b.visible = (/**
             * @param {?} r
             * @return {?}
             */
            function (r) { return true; });
        if (!b.cssClass)
            b.cssClass = (/**
             * @param {?} r
             * @return {?}
             */
            function (r) { return "btn"; });
        else if (!isFunction$1(b.cssClass)) {
            /** @type {?} */
            var x_1 = b.cssClass;
            b.cssClass = (/** @type {?} */ (((/**
             * @param {?} r
             * @return {?}
             */
            function (r) { return x_1; }))));
        }
        this.rowButtons.push(b);
        return b;
    };
    /**
     * @param {?} row
     * @return {?}
     */
    DataGrid2Component.prototype.rowClicked = /**
     * @param {?} row
     * @return {?}
     */
    function (row) {
        this.settings.setCurrentRow(row);
    };
    /**
     * @return {?}
     */
    DataGrid2Component.prototype.nextPage = /**
     * @return {?}
     */
    function () {
        this.page++;
    };
    /**
     * @return {?}
     */
    DataGrid2Component.prototype.previousPage = /**
     * @return {?}
     */
    function () {
        if (this.page <= 1)
            return;
        this.page--;
    };
    /**
     * @param {?} what
     * @param {?} r
     * @return {?}
     */
    DataGrid2Component.prototype.catchErrors = /**
     * @param {?} what
     * @param {?} r
     * @return {?}
     */
    function (what, r) {
        var _this = this;
        what.catch((/**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            _this.showError(r);
        }));
    };
    /**
     * @private
     * @param {?} row
     * @return {?}
     */
    DataGrid2Component.prototype.showError = /**
     * @private
     * @param {?} row
     * @return {?}
     */
    function (row) {
        /** @type {?} */
        var message = row.error;
        if (!message)
            message = "";
        /** @type {?} */
        var foundStateErrors = false;
        row.__iterateColumns().forEach((/**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            if (c.error) {
                if (!foundStateErrors) {
                    foundStateErrors = true;
                    message = "";
                }
                /** @type {?} */
                var m = c.caption + ": ";
                m += c.error;
                message += m + "\n";
            }
        }));
        alert(message);
    };
    /**
     * @return {?}
     */
    DataGrid2Component.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        var _this = this;
        var e_1, _a;
        if (!this.settings)
            return;
        this.rowButtons = [];
        if (this.settings.allowUpdate) {
            this.addButton({
                name: "",
                icon: 'check',
                cssClass: "glyphicon glyphicon-ok btn-success",
                visible: (/**
                 * @param {?} r
                 * @return {?}
                 */
                function (r) { return r.wasChanged(); }),
                click: (/**
                 * @param {?} r
                 * @return {?}
                 */
                function (r) {
                    _this.catchErrors(_this.settings._doSavingRow(r), r);
                }),
            });
            this.addButton({
                name: "",
                icon: 'cancel',
                cssClass: "btn btn-danger glyphicon glyphicon-ban-circle",
                visible: (/**
                 * @param {?} r
                 * @return {?}
                 */
                function (r) { return r.wasChanged(); }),
                click: (/**
                 * @param {?} r
                 * @return {?}
                 */
                function (r) {
                    r.reset();
                })
            });
        }
        if (this.settings.allowDelete)
            this.addButton({
                name: '',
                visible: (/**
                 * @param {?} r
                 * @return {?}
                 */
                function (r) {
                    return r && !r.isNew();
                }),
                icon: 'delete',
                click: (/**
                 * @param {?} r
                 * @return {?}
                 */
                function (r) {
                    if (_this.settings.setCurrentRow && _this.settings.settings.confirmDelete) {
                        _this.settings.settings.confirmDelete(r, (/**
                         * @return {?}
                         */
                        function () { return _this.catchErrors(r.delete(), r); }));
                    }
                    else
                        _this.catchErrors(r.delete(), r);
                }),
                cssClass: "btn-danger glyphicon glyphicon-trash"
            });
        if (this.settings._buttons)
            try {
                for (var _b = __values(this.settings._buttons), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    this.addButton(b);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        if (!this.records && this.settings) {
            this.settings.getRecords().then((/**
             * @param {?} r
             * @return {?}
             */
            function (r) {
                _this.records = r;
            }));
        }
    };
    /**
     * @param {?} row
     * @return {?}
     */
    DataGrid2Component.prototype._getRowClass = /**
     * @param {?} row
     * @return {?}
     */
    function (row) {
        /** @type {?} */
        var r = 'dataGridRow ';
        if (this.settings.rowClass)
            r += this.settings.rowClass(row);
        if (row == this.settings.currentRow)
            r += " active";
        return r;
    };
    /**
     * @param {?} col
     * @param {?} row
     * @return {?}
     */
    DataGrid2Component.prototype._getRowColumnClass = /**
     * @param {?} col
     * @param {?} row
     * @return {?}
     */
    function (col, row) {
        return this.settings.columns._getColumnClass(col, row) + ' dataGridDataCell';
    };
    DataGrid2Component.decorators = [
        { type: Component, args: [{
                    selector: 'data-grid2',
                    template: "<div>\r\n  <div>\r\n    <div class=\"dataGrid\" #dataGridDiv *ngIf=\"settings&&settings.columns\" [style.height]=\"_getHeight()\">\r\n      <div class=\"inner-wrapper\">\r\n        <div class=\"dataGridHeaderArea\">\r\n          <div class=\"dataGridRow\">\r\n            <div class=\"dataGridHeaderCell headerWithFilter\" *ngFor=\"let map of settings.columns.getGridColumns()\"\r\n              [style.flex]=\"getColFlex(map)\" [style.width]=\"getColWidth(map)\" draggable=\"true\"\r\n              (dragstart)=\"dragStart(map)\" (dragover)=\"dragOver(map,$event)\" (drop)=\"onDrop(map)\">\r\n\r\n              <span (click)=\"settings.sort(map.column)\">{{map.caption}}</span>\r\n\r\n\r\n              <span class=\"filterButton\" [class.filteredFilterButton]=\"isFiltered(map.column)\"\r\n                (click)=\"settings.columns.showFilterDialog(map)\">\r\n                <mat-icon>details</mat-icon>\r\n              </span>\r\n              <div class=\"filterDialog col-sm-4\" *ngIf=\"settings.columns._shouldShowFilterDialog(map)\">\r\n                <div class=\"form-group\">\r\n                  <data-control2 [settings]=\"settings.columns\" [map]=\"map\"\r\n                    [record]=\"settings.columns.filterHelper.filterRow\" [notReadonly]=\"true\"></data-control2>\r\n                </div>\r\n                <button mat-icon-button (click)=\"settings.columns.filterRows(map)\">\r\n                  <mat-icon>check</mat-icon>\r\n                </button>\r\n                <button mat-icon-button (click)=\"settings.columns.clearFilter(map)\">\r\n                  <mat-icon>clear</mat-icon>\r\n                </button>\r\n\r\n              </div>\r\n              <mat-icon *ngIf=\"settings.sortedAscending(map.column)\">arrow_downward</mat-icon>\r\n              <mat-icon class=\"glyphicon glyphicon-chevron-down pull-right\"\r\n                *ngIf=\"settings.sortedDescending(map.column)\">arrow_upward</mat-icon>\r\n            </div>\r\n            <div class=\"dataGridButtonHeaderCell\" *ngIf=\"rowButtons&& rowButtons.length>0&&displayButtons\"\r\n              [class.col-xs-1]=\"rowButtons&&rowButtons.length<3\"></div>\r\n          </div>\r\n        </div>\r\n        <div class=\"dataGridBodyArea\">\r\n          <div class=\"dataGridRow\" *ngFor=\"let record of records\" [className]=\"_getRowClass(record)\"\r\n            (click)=\"rowClicked(record)\">\r\n\r\n            <div class=\"dataGridDataCell\" *ngFor=\"let map of settings.columns.getGridColumns()\"\r\n              [className]=\"_getRowColumnClass(map,record)\" [style.flex]=\"getColFlex(map)\"\r\n              [style.width]=\"getColWidth(map)\">\r\n              <data-control3 [settings]=\"settings.columns\" [map]=\"map\" [record]=\"record\" [rightToLeft]=\"rightToLeft\"></data-control3>\r\n            </div>\r\n            <div class=\"dataGridButtonCell\" *ngIf=\"rowButtons.length>0&&displayButtons\" style=\"white-space:nowrap\">\r\n              <ng-container *ngFor=\"let b of rowButtons\">\r\n                <button mat-icon-button *ngIf=\"b.visible(record)&&b.icon\" (click)=\"b.click(record)\" class=\"row-button\">\r\n                  <mat-icon *ngIf=\"b.icon\">{{b.icon}} </mat-icon> {{b.name}}\r\n                </button>\r\n                <button mat-raised-button *ngIf=\"b.visible(record)&&!b.icon\" (click)=\"b.click(record)\" class=\"row-button\">\r\n                   {{b.name}}\r\n                </button>\r\n              </ng-container>\r\n\r\n            </div>\r\n          </div>\r\n\r\n        </div>\r\n      </div>\r\n    </div>\r\n    <div class=\"dataGridFooterArea\" *ngIf=\"records\">\r\n      <div class=\"dataGridFooterButtonGroup\">\r\n        <button mat-icon-button (click)=\"settings.userChooseColumns()\">\r\n          <mat-icon>settings</mat-icon>\r\n        </button>\r\n        <button mat-icon-button (click)=\"dataFilter.userFilterButton()\">\r\n          <mat-icon>details</mat-icon>\r\n        </button>\r\n        {{rightToLeft?'\u05E9\u05D5\u05E8\u05D5\u05EA \u05D1\u05D3\u05E3': 'lines per page'}}\r\n        <select class=\"form-control\" style=\"width:80px;display:inline-block\" [(ngModel)]=\"settings.rowsPerPage\"\r\n          (change)=\"settings.getRecords()\">\r\n          <option *ngFor=\"let r of settings.rowsPerPageOptions\" value=\"{{r}}\">{{r}}</option>\r\n        </select></div>\r\n      <div class=\"dataGridFooterButtonGroup\">\r\n        <button mat-icon-button (click)=\"settings.firstPage()\">\r\n          <mat-icon>{{rightToLeft?'last_page':'first_page'}} </mat-icon>\r\n        </button>\r\n        <button mat-icon-button [disabled]=\"settings.page==1\" (click)=\"settings.previousPage()\">\r\n          <mat-icon>{{rightToLeft?'chevron_right':'chevron_left'}}</mat-icon>\r\n        </button>\r\n        {{rightToLeft?'\u05E2\u05DE\u05D5\u05D3':'Page'}} {{settings.page}} {{rightToLeft?' \u05DE\u05EA\u05D5\u05DA ':' of '}} {{getTotalRows()}}\r\n        <button mat-icon-button [disabled]=\"!(records.items&& records.items.length>0)\" (click)=\"settings.nextPage()\">\r\n          <mat-icon>{{!rightToLeft?'chevron_right':'chevron_left'}}</mat-icon>\r\n        </button>\r\n        <button mat-icon-button *ngIf=\"settings.allowUpdate &&settings.allowInsert\" (click)=\"settings.addNewRow()\">\r\n          <mat-icon>add</mat-icon>\r\n        </button>\r\n      </div>\r\n     \r\n\r\n\r\n      <Data-Filter [settings]=\"settings\" #dataFilter></Data-Filter>\r\n      <div *ngIf=\"settings.showSelectColumn\" class=\"selectColumnsArea\">\r\n        Select Columns\r\n        <ol>\r\n          <li *ngFor=\"let c of settings.currList; let i=index\">\r\n            <select [(ngModel)]=\"settings.currList[i]\" class=\"form-control selectColumnCombo\"\r\n              (change)=\"settings.columns.colListChanged()\">\r\n              <option *ngFor=\"let o of settings.origList\" [ngValue]=\"o\">{{o.caption}}</option>\r\n            </select>\r\n            <input [(ngModel)]=\"c.width\" style=\"width:50px;display:inline;\" >\r\n            <button mat-icon-button  *ngIf=\"settings.currList.length>1\"\r\n              (click)=\"settings.deleteCol(c)\"><mat-icon>cancel</mat-icon></button>\r\n            <button  mat-icon-button (click)=\"settings.addCol(c)\"><mat-icon>add</mat-icon></button>\r\n            <button mat-icon-button *ngIf=\"i<settings.currList.length-1\"\r\n              (click)=\"settings.columns.moveCol(c,1)\"><mat-icon>keyboard_arrow_down</mat-icon></button>\r\n            <button mat-icon-button *ngIf=\"i>0\"\r\n              (click)=\"settings.columns.moveCol(c,-1)\"><mat-icon>keyboard_arrow_up</mat-icon></button>\r\n          </li>\r\n        </ol>\r\n        <button (click)=\"settings.resetColumns()\" class=\"btn glyphicon glyphicon-repeat\"></button>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <data-area2 *ngIf=\"!settings.hideDataArea\" [settings]=\"settings\" ></data-area2>",
                    styles: [".row-button{height:auto;line-height:normal}.inner-wrapper{display:inline-block}.dataGrid{overflow:auto;border:1px solid #e0e0e0}.dataGridRow{display:flex}.dataGridHeaderArea{position:-webkit-sticky;position:sticky;top:0;clear:both;background-color:#f5f5f5;z-index:3}.dataGridFooterButtonGroup{display:inline-block}.dataGridFooterArea{width:100%;padding:4px;bottom:0;left:0;background-color:#f5f5f5;border:1px solid #e0e0e0}.dataGridDataCell,.dataGridHeaderCell{padding:4px}.dataGridHeaderCell{height:36px}.dataGridDataCell{border-top:1px solid #e0e0e0}.filterDialog{background-color:#fff;position:absolute;padding:10px;z-index:800;border-radius:5px;width:200px;border:2px solid gray}.filterDialog .form-group{margin-right:0;margin-left:0}.designModeButton span{visibility:hidden}.designModeButton:hover span{visibility:visible}.selectColumnCombo{display:inline-block;width:auto}.selectColumnsArea{display:block}.headerWithFilter .filterButton{visibility:hidden}.headerWithFilter .filteredFilterButton,.headerWithFilter:hover .filterButton{visibility:visible}table input{min-width:75px}table select{min-width:100px}"]
                }] }
    ];
    DataGrid2Component.propDecorators = {
        dataGridDiv: [{ type: ViewChild, args: ['dataGridDiv',] }],
        width: [{ type: Input }],
        height: [{ type: Input }],
        displayButtons: [{ type: Input }],
        displayVCR: [{ type: Input }],
        records: [{ type: Input }],
        settings: [{ type: Input }]
    };
    return DataGrid2Component;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var RestDataProvider = /** @class */ (function () {
    function RestDataProvider(url, http) {
        this.url = url;
        this.http = http;
    }
    /**
     * @param {?} name
     * @return {?}
     */
    RestDataProvider.prototype.provideFor = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        return new ActualRestDataProvider(this.url + '/' + name, this.http);
    };
    return RestDataProvider;
}());
var ActualRestDataProvider = /** @class */ (function () {
    function ActualRestDataProvider(url, http) {
        this.url = url;
        this.http = http;
    }
    /**
     * @param {?} where
     * @return {?}
     */
    ActualRestDataProvider.prototype.count = /**
     * @param {?} where
     * @return {?}
     */
    function (where) {
        /** @type {?} */
        var url = new UrlBuilder(this.url);
        url.add("__action", "count");
        if (where) {
            where.__applyToConsumer(new FilterConsumnerBridgeToUrlBuilder(url));
        }
        return this.http.get(url.url).then((/**
         * @param {?} r
         * @return {?}
         */
        function (r) { return +(r.count); }));
    };
    /**
     * @param {?} options
     * @return {?}
     */
    ActualRestDataProvider.prototype.find = /**
     * @param {?} options
     * @return {?}
     */
    function (options) {
        /** @type {?} */
        var url = new UrlBuilder(this.url);
        if (options) {
            if (options.where) {
                options.where.__applyToConsumer(new FilterConsumnerBridgeToUrlBuilder(url));
            }
            if (options.orderBy && options.orderBy.Segments) {
                /** @type {?} */
                var sort_1 = '';
                /** @type {?} */
                var order_1 = '';
                options.orderBy.Segments.forEach((/**
                 * @param {?} c
                 * @return {?}
                 */
                function (c) {
                    if (sort_1.length > 0) {
                        sort_1 += ", ";
                        order_1 += ", ";
                    }
                    sort_1 += c.column.jsonName;
                    order_1 += c.descending ? "desc" : "asc";
                }));
                url.add('_sort', sort_1);
                url.add('_order', order_1);
            }
            if (options.limit)
                url.add('_limit', options.limit);
            if (options.page)
                url.add('_page', options.page);
            if (options.additionalUrlParameters)
                url.addObject(options.additionalUrlParameters);
        }
        return this.http.get(url.url);
    };
    /**
     * @param {?} id
     * @param {?} data
     * @return {?}
     */
    ActualRestDataProvider.prototype.update = /**
     * @param {?} id
     * @param {?} data
     * @return {?}
     */
    function (id, data) {
        return this.http.put(this.url + '/' + encodeURIComponent(id), data);
    };
    /**
     * @param {?} id
     * @return {?}
     */
    ActualRestDataProvider.prototype.delete = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        return this.http.delete(this.url + '/' + encodeURIComponent(id));
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ActualRestDataProvider.prototype.insert = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        return this.http.post(this.url, data);
    };
    return ActualRestDataProvider;
}());
/**
 * @param {?} add
 * @return {?}
 */
function JsonContent(add) {
    add('Content-type', "application/json");
}
var angularHttpProvider = /** @class */ (function () {
    function angularHttpProvider(http) {
        this.http = http;
    }
    /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    angularHttpProvider.prototype.post = /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    function (url, data) {
        return this.http.post(url, data).toPromise();
    };
    /**
     * @param {?} url
     * @return {?}
     */
    angularHttpProvider.prototype.delete = /**
     * @param {?} url
     * @return {?}
     */
    function (url) {
        return this.http.delete(url).toPromise().then((/**
         * @param {?} x
         * @return {?}
         */
        function (x) { }));
    };
    /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    angularHttpProvider.prototype.put = /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    function (url, data) {
        return this.http.put(url, data).toPromise();
    };
    /**
     * @param {?} url
     * @return {?}
     */
    angularHttpProvider.prototype.get = /**
     * @param {?} url
     * @return {?}
     */
    function (url) {
        return this.http.get(url).toPromise();
    };
    return angularHttpProvider;
}());
var restDataProviderHttpProviderUsingFetch = /** @class */ (function () {
    function restDataProviderHttpProviderUsingFetch(addRequestHeader) {
        this.addRequestHeader = addRequestHeader;
        if (!addRequestHeader)
            this.addRequestHeader = (/**
             * @return {?}
             */
            function () { });
    }
    /**
     * @param {?} url
     * @return {?}
     */
    restDataProviderHttpProviderUsingFetch.prototype.get = /**
     * @param {?} url
     * @return {?}
     */
    function (url) {
        return myFetch(url, undefined, this.addRequestHeader).then((/**
         * @param {?} r
         * @return {?}
         */
        function (r) {
            return r;
        }));
    };
    /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    restDataProviderHttpProviderUsingFetch.prototype.put = /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    function (url, data) {
        return myFetch(url, {
            method: 'put',
            body: JSON.stringify(data)
        }, this.addRequestHeader, JsonContent);
    };
    /**
     * @param {?} url
     * @return {?}
     */
    restDataProviderHttpProviderUsingFetch.prototype.delete = /**
     * @param {?} url
     * @return {?}
     */
    function (url) {
        /** @type {?} */
        var h = new Headers();
        this.addRequestHeader((/**
         * @param {?} name
         * @param {?} value
         * @return {?}
         */
        function (name, value) { return h.append(name, value); }));
        return fetch(url, { method: 'delete', credentials: 'include' }).then(onSuccess$1, onError$1);
    };
    /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    restDataProviderHttpProviderUsingFetch.prototype.post = /**
     * @param {?} url
     * @param {?} data
     * @return {?}
     */
    function (url, data) {
        return myFetch(url, {
            method: 'post',
            body: JSON.stringify(data)
        }, this.addRequestHeader, JsonContent);
    };
    return restDataProviderHttpProviderUsingFetch;
}());
/** @type {?} */
var wrapFetch = {
    wrap: (/**
     * @return {?}
     */
    function () { return (/**
     * @return {?}
     */
    function () { }); })
};
/**
 * @param {?} url
 * @param {?} init
 * @param {...?} addRequestHeader
 * @return {?}
 */
function myFetch(url, init) {
    var addRequestHeader = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        addRequestHeader[_i - 2] = arguments[_i];
    }
    if (!init)
        init = {};
    if (!init.headers)
        init.headers = new Headers();
    /** @type {?} */
    var h = (/** @type {?} */ (init.headers));
    addRequestHeader.forEach((/**
     * @param {?} x
     * @return {?}
     */
    function (x) { return x((/**
     * @param {?} n
     * @param {?} v
     * @return {?}
     */
    function (n, v) { return h.append(n, v); })); }));
    init.credentials = 'include';
    /** @type {?} */
    var x = wrapFetch.wrap();
    return fetch(url, init).then((/**
     * @param {?} response
     * @return {?}
     */
    function (response) {
        x();
        return onSuccess$1(response);
    }), (/**
     * @param {?} error
     * @return {?}
     */
    function (error) {
        console.log(error);
        x();
        throw Promise.resolve(error);
    }));
}
/**
 * @param {?} response
 * @return {?}
 */
function onSuccess$1(response) {
    if (response.status == 204)
        return;
    if (response.status >= 200 && response.status < 300)
        return response.json();
    else
        throw response.json().then((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            if (!x.message)
                x.message = response.statusText;
            return x;
        }));
}
/**
 * @param {?} error
 * @return {?}
 */
function onError$1(error) {
    throw Promise.resolve(error);
}
/**
 * @abstract
 * @template inParam, outParam
 */
var Action = /** @class */ (function () {
    function Action(serverUrl, actionUrl, addRequestHeader) {
        this.serverUrl = serverUrl;
        this.actionUrl = actionUrl;
        if (!addRequestHeader)
            addRequestHeader = (/**
             * @return {?}
             */
            function () { });
        if (!actionUrl) {
            this.actionUrl = this.constructor.name;
            if (this.actionUrl.endsWith('Action'))
                this.actionUrl = this.actionUrl.substring(0, this.actionUrl.length - 6);
        }
    }
    /**
     * @param {?} pIn
     * @return {?}
     */
    Action.prototype.run = /**
     * @param {?} pIn
     * @return {?}
     */
    function (pIn) {
        return Action.provider.post(this.serverUrl + this.actionUrl, pIn);
    };
    /**
     * @param {?} reg
     * @return {?}
     */
    Action.prototype.__register = /**
     * @param {?} reg
     * @return {?}
     */
    function (reg) {
        var _this = this;
        reg(this.actionUrl, (/**
         * @param {?} d
         * @param {?} req
         * @param {?} res
         * @return {?}
         */
        function (d, req, res) { return __awaiter(_this, void 0, void 0, function () {
            var r, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.execute(d, req)];
                    case 1:
                        r = _a.sent();
                        res.success(r);
                        return [3 /*break*/, 3];
                    case 2:
                        err_1 = _a.sent();
                        res.error(err_1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        }); }));
    };
    Action.provider = new restDataProviderHttpProviderUsingFetch();
    return Action;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var InMemoryDataProvider = /** @class */ (function () {
    function InMemoryDataProvider() {
        this.rows = {};
    }
    /**
     * @template T
     * @param {?} name
     * @param {?} factory
     * @return {?}
     */
    InMemoryDataProvider.prototype.provideFor = /**
     * @template T
     * @param {?} name
     * @param {?} factory
     * @return {?}
     */
    function (name, factory) {
        if (!this.rows[name])
            this.rows[name] = [];
        return new ActualInMemoryDataProvider(factory, this.rows[name]);
    };
    /**
     * @return {?}
     */
    InMemoryDataProvider.prototype.toString = /**
     * @return {?}
     */
    function () { return "InMemoryDataProvider"; };
    return InMemoryDataProvider;
}());
/**
 * @template T
 */
var  /**
 * @template T
 */
ActualInMemoryDataProvider = /** @class */ (function () {
    function ActualInMemoryDataProvider(factory, rows) {
        this.factory = factory;
        this.rows = rows;
        if (!rows)
            rows = [];
    }
    /**
     * @param {?=} where
     * @return {?}
     */
    ActualInMemoryDataProvider.prototype.count = /**
     * @param {?=} where
     * @return {?}
     */
    function (where) {
        return __awaiter(this, void 0, void 0, function () {
            var rows, j, i, x;
            return __generator(this, function (_a) {
                rows = this.rows;
                j = 0;
                for (i = 0; i < rows.length; i++) {
                    if (!where) {
                        j++;
                    }
                    else {
                        x = new FilterConsumerBridgeToObject(rows[i]);
                        where.__applyToConsumer(x);
                        if (x.ok)
                            j++;
                    }
                }
                return [2 /*return*/, j];
            });
        });
    };
    /**
     * @param {?=} options
     * @return {?}
     */
    ActualInMemoryDataProvider.prototype.find = /**
     * @param {?=} options
     * @return {?}
     */
    function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var rows;
            var _this = this;
            return __generator(this, function (_a) {
                rows = this.rows;
                if (options) {
                    if (options.where) {
                        rows = rows.filter((/**
                         * @param {?} i
                         * @return {?}
                         */
                        function (i) {
                            /** @type {?} */
                            var x = new FilterConsumerBridgeToObject(i);
                            options.where.__applyToConsumer(x);
                            return x.ok;
                        }));
                    }
                    if (options.orderBy) {
                        rows = rows.sort((/**
                         * @param {?} a
                         * @param {?} b
                         * @return {?}
                         */
                        function (a, b) {
                            /** @type {?} */
                            var r = 0;
                            for (var i = 0; i < options.orderBy.Segments.length; i++) {
                                /** @type {?} */
                                var seg = options.orderBy.Segments[i];
                                /** @type {?} */
                                var left = a[seg.column.jsonName];
                                /** @type {?} */
                                var right = b[seg.column.jsonName];
                                if (left > right)
                                    r = 1;
                                else if (left < right)
                                    r = -1;
                                if (r != 0) {
                                    if (seg.descending)
                                        r *= -1;
                                    return r;
                                }
                            }
                            return r;
                        }));
                    }
                    rows = pageArray(rows, options);
                }
                if (rows)
                    return [2 /*return*/, rows.map((/**
                         * @param {?} i
                         * @return {?}
                         */
                        function (i) {
                            return _this.map(i);
                        }))];
                return [2 /*return*/];
            });
        });
    };
    /**
     * @param {?} i
     * @return {?}
     */
    ActualInMemoryDataProvider.prototype.map = /**
     * @param {?} i
     * @return {?}
     */
    function (i) {
        /** @type {?} */
        var r = JSON.parse(JSON.stringify(i));
        return r;
    };
    /**
     * @private
     * @param {?} id
     * @return {?}
     */
    ActualInMemoryDataProvider.prototype.idMatches = /**
     * @private
     * @param {?} id
     * @return {?}
     */
    function (id) {
        if (!this.entity)
            this.entity = this.factory();
        /** @type {?} */
        var f = this.entity.__idColumn.isEqualTo(id);
        return (/**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            /** @type {?} */
            var x = new FilterConsumerBridgeToObject(item);
            f.__applyToConsumer(x);
            return x.ok;
        });
    };
    /**
     * @param {?} id
     * @param {?} data
     * @return {?}
     */
    ActualInMemoryDataProvider.prototype.update = /**
     * @param {?} id
     * @param {?} data
     * @return {?}
     */
    function (id, data) {
        /** @type {?} */
        var idMatches = this.idMatches(id);
        for (var i = 0; i < this.rows.length; i++) {
            if (idMatches(this.rows[i])) {
                this.rows[i] = Object.assign({}, this.rows[i], data);
                return Promise.resolve(this.map(this.rows[i]));
            }
        }
        throw new Error("couldn't find id to update: " + id);
    };
    /**
     * @param {?} id
     * @return {?}
     */
    ActualInMemoryDataProvider.prototype.delete = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        /** @type {?} */
        var idMatches = this.idMatches(id);
        for (var i = 0; i < this.rows.length; i++) {
            if (idMatches(this.rows[i])) {
                this.rows.splice(i, 1);
                return Promise.resolve();
            }
        }
        throw new Error("couldn't find id to delete: " + id);
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ActualInMemoryDataProvider.prototype.insert = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        if (data.id)
            this.rows.forEach((/**
             * @param {?} i
             * @return {?}
             */
            function (i) {
                if (data.id == i.id)
                    throw Error("id already exists");
            }));
        this.rows.push(JSON.parse(JSON.stringify(data)));
        return Promise.resolve(JSON.parse(JSON.stringify(data)));
    };
    return ActualInMemoryDataProvider;
}());
/**
 * @param {?} rows
 * @param {?=} options
 * @return {?}
 */
function pageArray(rows, options) {
    if (!options)
        return rows;
    if (!options.limit)
        return rows;
    /** @type {?} */
    var page = 1;
    if (options.page)
        page = options.page;
    if (page < 1)
        page = 1;
    /** @type {?} */
    var x = 0;
    return rows.filter((/**
     * @param {?} i
     * @return {?}
     */
    function (i) {
        x++;
        /** @type {?} */
        var max = page * options.limit;
        /** @type {?} */
        var min = max - options.limit;
        return x > min && x <= max;
    }));
}
var FilterConsumerBridgeToObject = /** @class */ (function () {
    function FilterConsumerBridgeToObject(row) {
        this.row = row;
        this.ok = true;
    }
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumerBridgeToObject.prototype.isEqualTo = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        if (this.row[col.jsonName] != val)
            this.ok = false;
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumerBridgeToObject.prototype.isDifferentFrom = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        if (this.row[col.jsonName] == val)
            this.ok = false;
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumerBridgeToObject.prototype.isGreaterOrEqualTo = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        if (this.row[col.jsonName] < val)
            this.ok = false;
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumerBridgeToObject.prototype.isGreaterThan = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        if (this.row[col.jsonName] <= val)
            this.ok = false;
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumerBridgeToObject.prototype.isLessOrEqualTo = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        if (this.row[col.jsonName] > val)
            this.ok = false;
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumerBridgeToObject.prototype.isLessThan = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        if (this.row[col.jsonName] >= val)
            this.ok = false;
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumerBridgeToObject.prototype.isContains = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        /** @type {?} */
        var v = this.row[col.jsonName];
        if (!v) {
            this.ok = false;
            return;
        }
        /** @type {?} */
        var s = '' + v;
        if (s.indexOf(val) < 0)
            this.ok = false;
    };
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    FilterConsumerBridgeToObject.prototype.isStartsWith = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        /** @type {?} */
        var v = this.row[col.jsonName];
        if (!v) {
            this.ok = false;
            return;
        }
        /** @type {?} */
        var s = '' + v;
        if (s.indexOf(val) != 0)
            this.ok = false;
    };
    return FilterConsumerBridgeToObject;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Context = /** @class */ (function () {
    function Context(http) {
        this._onServer = false;
        this.cache = {};
        this._lookupCache = [];
        if (http instanceof HttpClient) {
            /** @type {?} */
            var prov = new angularHttpProvider(http);
            this._dataSource = new RestDataProvider(Context.apiBaseUrl, prov
            //,new restDataProviderHttpProviderUsingFetch()
            );
            Action.provider = prov;
        }
        else {
            this._dataSource = new InMemoryDataProvider();
        }
    }
    /**
     * @return {?}
     */
    Context.prototype.clearAllCache = /**
     * @return {?}
     */
    function () {
        this.cache = {};
        this._lookupCache = [];
    };
    /**
     * @return {?}
     */
    Context.prototype.isSignedIn = /**
     * @return {?}
     */
    function () {
        return !!this.user;
    };
    Object.defineProperty(Context.prototype, "onServer", {
        get: /**
         * @return {?}
         */
        function () {
            return this._onServer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Context.prototype, "user", {
        get: /**
         * @return {?}
         */
        function () { return this._user; },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} info
     * @return {?}
     */
    Context.prototype._setUser = /**
     * @param {?} info
     * @return {?}
     */
    function (info) {
        this._user = info;
    };
    /**
     * @param {?} roles
     * @return {?}
     */
    Context.prototype.isAllowed = /**
     * @param {?} roles
     * @return {?}
     */
    function (roles) {
        var e_1, _a;
        if (roles == undefined)
            return undefined;
        if (roles instanceof Array) {
            try {
                for (var roles_1 = __values(roles), roles_1_1 = roles_1.next(); !roles_1_1.done; roles_1_1 = roles_1.next()) {
                    var role = roles_1_1.value;
                    if (this.isAllowed(role) === true) {
                        return true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (roles_1_1 && !roles_1_1.done && (_a = roles_1.return)) _a.call(roles_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return false;
        }
        if (isFunction(roles)) {
            return ((/** @type {?} */ (roles)))(this);
        }
        if (isBoolean(roles))
            return roles;
        if (roles instanceof Role) {
            roles = roles.key;
        }
        if (!this.user)
            return false;
        if (isString(roles))
            if (this.user.roles.indexOf(roles.toString()) >= 0)
                return true;
        return false;
    };
    /**
     * @template lookupIdType, T
     * @param {?} c
     * @return {?}
     */
    Context.prototype.create = /**
     * @template lookupIdType, T
     * @param {?} c
     * @return {?}
     */
    function (c) {
        /** @type {?} */
        var e = new c(this);
        e.setSource(this._dataSource);
        e._setContext(this);
        return e;
    };
    /**
     * @template lookupIdType, T
     * @param {?} c
     * @return {?}
     */
    Context.prototype.for = /**
     * @template lookupIdType, T
     * @param {?} c
     * @return {?}
     */
    function (c) {
        /** @type {?} */
        var classType = (/** @type {?} */ (c));
        if (this.cache[classType.__key])
            return (/** @type {?} */ (this.cache[classType.__key]));
        return this.cache[classType.__key] = new SpecificEntityHelper(this.create(c), this._lookupCache, this);
    };
    Context.apiBaseUrl = 'api';
    Context.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    Context.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    return Context;
}());
var ServerContext = /** @class */ (function (_super) {
    __extends(ServerContext, _super);
    function ServerContext() {
        var _this = _super.call(this, undefined) || this;
        _this._onServer = true;
        return _this;
    }
    /**
     * @param {?} req
     * @return {?}
     */
    ServerContext.prototype.setReq = /**
     * @param {?} req
     * @return {?}
     */
    function (req) {
        this.req = req;
        this._user = req.user ? req.user : undefined;
    };
    /**
     * @param {?} dataProvider
     * @return {?}
     */
    ServerContext.prototype.setDataProvider = /**
     * @param {?} dataProvider
     * @return {?}
     */
    function (dataProvider) {
        this._dataSource = dataProvider;
    };
    /**
     * @return {?}
     */
    ServerContext.prototype.getOrigin = /**
     * @return {?}
     */
    function () {
        return this.req.getHeader('origin');
    };
    return ServerContext;
}(Context));
/**
 * @template lookupIdType, T
 */
var  /**
 * @template lookupIdType, T
 */
SpecificEntityHelper = /** @class */ (function () {
    function SpecificEntityHelper(entity, _lookupCache, context) {
        this.entity = entity;
        this._lookupCache = _lookupCache;
        this.context = context;
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    SpecificEntityHelper.prototype.lookup = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        /** @type {?} */
        var key = this.entity.__getName();
        /** @type {?} */
        var lookup;
        this._lookupCache.forEach((/**
         * @param {?} l
         * @return {?}
         */
        function (l) {
            if (l.key == key)
                lookup = l.lookup;
        }));
        if (!lookup) {
            lookup = new Lookup(this.entity);
            this._lookupCache.push({ key: key, lookup: lookup });
        }
        return lookup.get(filter);
    };
    /**
     * @param {?} filter
     * @return {?}
     */
    SpecificEntityHelper.prototype.lookupAsync = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        /** @type {?} */
        var key = this.entity.__getName();
        /** @type {?} */
        var lookup;
        this._lookupCache.forEach((/**
         * @param {?} l
         * @return {?}
         */
        function (l) {
            if (l.key == key)
                lookup = l.lookup;
        }));
        if (!lookup) {
            lookup = new Lookup(this.entity);
            this._lookupCache.push({ key: key, lookup: lookup });
        }
        return lookup.whenGet(filter);
    };
    /**
     * @param {?=} where
     * @return {?}
     */
    SpecificEntityHelper.prototype.count = /**
     * @param {?=} where
     * @return {?}
     */
    function (where) {
        return __awaiter(this, void 0, void 0, function () {
            var dl;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dl = new DataList(this.entity);
                        return [4 /*yield*/, dl.count(where)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * @param {?} where
     * @param {?=} what
     * @return {?}
     */
    SpecificEntityHelper.prototype.foreach = /**
     * @param {?} where
     * @param {?=} what
     * @return {?}
     */
    function (where, what) {
        return __awaiter(this, void 0, void 0, function () {
            var e_2, _a, options, items, items_1, items_1_1, item, e_2_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        options = {};
                        if (where) {
                            options.where = where(this.entity);
                        }
                        return [4 /*yield*/, this.entity.source.find(options)];
                    case 1:
                        items = _b.sent();
                        _b.label = 2;
                    case 2:
                        _b.trys.push([2, 7, 8, 9]);
                        items_1 = __values(items), items_1_1 = items_1.next();
                        _b.label = 3;
                    case 3:
                        if (!!items_1_1.done) return [3 /*break*/, 6];
                        item = items_1_1.value;
                        return [4 /*yield*/, what(item)];
                    case 4:
                        _b.sent();
                        _b.label = 5;
                    case 5:
                        items_1_1 = items_1.next();
                        return [3 /*break*/, 3];
                    case 6: return [3 /*break*/, 9];
                    case 7:
                        e_2_1 = _b.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 9];
                    case 8:
                        try {
                            if (items_1_1 && !items_1_1.done && (_a = items_1.return)) _a.call(items_1);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 9: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?=} options
     * @return {?}
     */
    SpecificEntityHelper.prototype.find = /**
     * @param {?=} options
     * @return {?}
     */
    function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var dl;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dl = new DataList(this.entity);
                        return [4 /*yield*/, dl.get(options)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /**
     * @param {?=} where
     * @return {?}
     */
    SpecificEntityHelper.prototype.findFirst = /**
     * @param {?=} where
     * @return {?}
     */
    function (where) {
        return __awaiter(this, void 0, void 0, function () {
            var r;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.entity.source.find({ where: where ? where(this.entity) : undefined })];
                    case 1:
                        r = _a.sent();
                        if (r.length == 0)
                            return [2 /*return*/, undefined];
                        return [2 /*return*/, r[0]];
                }
            });
        });
    };
    /**
     * @param {?} items
     * @return {?}
     */
    SpecificEntityHelper.prototype.toPojoArray = /**
     * @param {?} items
     * @return {?}
     */
    function (items) {
        /** @type {?} */
        var exc = new ColumnHashSet();
        exc.add.apply(exc, __spread(this.entity._getExcludedColumns(this.entity, this.context)));
        return Promise.all(items.map((/**
         * @param {?} f
         * @return {?}
         */
        function (f) { return f.__toPojo(exc); })));
    };
    /**
     * @return {?}
     */
    SpecificEntityHelper.prototype.create = /**
     * @return {?}
     */
    function () {
        return this.entity.source.createNewItem();
    };
    /**
     * @param {?=} settings
     * @return {?}
     */
    SpecificEntityHelper.prototype.gridSettings = /**
     * @param {?=} settings
     * @return {?}
     */
    function (settings) {
        return new GridSettings(this.entity, settings);
    };
    return SpecificEntityHelper;
}());
/** @type {?} */
var allEntities = [];
/**
 * @template T
 * @param {?} theEntityClass
 * @return {?}
 */
function EntityClass(theEntityClass) {
    /** @type {?} */
    var original = theEntityClass;
    /** @type {?} */
    var f = /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var _this = _super.apply(this, __spread(args)) || this;
            _this._setFactoryClassAndDoInitColumns(f);
            if (!_this.__options.name) {
                _this.__options.name = original.name;
            }
            return _this;
        }
        return class_1;
    }(theEntityClass));
    allEntities.push(f);
    f.__key = theEntityClass.name + allEntities.indexOf(f);
    return f;
}
/**
 * @abstract
 */
var  /**
 * @abstract
 */
DirectSQL = /** @class */ (function () {
    function DirectSQL() {
    }
    return DirectSQL;
}());
// @dynamic
var  
// @dynamic
Role = /** @class */ (function () {
    function Role(key) {
        this.key = key;
    }
    /**
     * @param {?} allowed
     * @return {?}
     */
    Role.not = /**
     * @param {?} allowed
     * @return {?}
     */
    function (allowed) {
        return (/**
         * @param {?} c
         * @return {?}
         */
        function (c) { return !c.isAllowed(allowed); });
    };
    return Role;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var authToken = 'authorization';
var JwtSessionManager = /** @class */ (function () {
    function JwtSessionManager(context) {
        this.context = context;
    }
    /**
     * @return {?}
     */
    JwtSessionManager.prototype.loadSessionFromCookie = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var c = document.cookie;
        /** @type {?} */
        var i = c.indexOf(authToken + '=');
        if (i >= 0) {
            c = c.substring(i + authToken.length + 2).trim();
            i = c.indexOf(';');
            if (i >= 0) {
                c = c.substring(0, i - 1);
            }
            this._setToken(c);
        }
    };
    /**
     * @param {?} jwtToken
     * @param {?=} rememberOnDevice
     * @return {?}
     */
    JwtSessionManager.prototype.setToken = /**
     * @param {?} jwtToken
     * @param {?=} rememberOnDevice
     * @return {?}
     */
    function (jwtToken, rememberOnDevice) {
        if (rememberOnDevice === void 0) { rememberOnDevice = false; }
        return __awaiter(this, void 0, void 0, function () {
            var c;
            return __generator(this, function (_a) {
                if (jwtToken) {
                    this._setToken(jwtToken);
                    c = authToken + "=" + jwtToken;
                    c += ';path=/';
                    if (rememberOnDevice)
                        c += '; expires = Thu, 01 Jan 2076 00:00:00 GMT';
                    document.cookie = c;
                    return [2 /*return*/, true];
                }
                else
                    this.signout();
                return [2 /*return*/, false];
            });
        });
    };
    /**
     * @private
     * @param {?} token
     * @return {?}
     */
    JwtSessionManager.prototype._setToken = /**
     * @private
     * @param {?} token
     * @return {?}
     */
    function (token) {
        this.currentToken = token;
        /** @type {?} */
        var user = undefined;
        if (this.currentToken) {
            {
                try {
                    user = new JwtHelperService().decodeToken(token);
                }
                catch (err) {
                    console.log(err);
                }
            }
        }
        this.context._setUser(user);
        if (this.tokenInfoChanged)
            this.tokenInfoChanged();
    };
    /**
     * @return {?}
     */
    JwtSessionManager.prototype.signout = /**
     * @return {?}
     */
    function () {
        this._setToken('');
        document.cookie = authToken + '=; expires = Thu, 01 Jan 1970 00:00:00 GMT';
    };
    JwtSessionManager.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    JwtSessionManager.ctorParameters = function () { return [
        { type: Context }
    ]; };
    return JwtSessionManager;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var RouteHelperService = /** @class */ (function () {
    function RouteHelperService(router, injector) {
        this.router = router;
        this.injector = injector;
    }
    /**
     * @param {?} toComponent
     * @return {?}
     */
    RouteHelperService.prototype.navigateToComponent = /**
     * @param {?} toComponent
     * @return {?}
     */
    function (toComponent) {
        var _this = this;
        /** @type {?} */
        var done = false;
        this.router.config.forEach((/**
         * @param {?} path
         * @return {?}
         */
        function (path) {
            if (done)
                return;
            if (path.component == toComponent) {
                done = true;
                _this.router.navigate(['/' + path.path]);
            }
        }));
        if (!done)
            console.warn("couldn't find path for ", toComponent, this.router.config);
    };
    /**
     * @param {?} route
     * @return {?}
     */
    RouteHelperService.prototype.canNavigateToRoute = /**
     * @param {?} route
     * @return {?}
     */
    function (route) {
        var e_1, _a;
        if (!route.canActivate)
            return true;
        try {
            for (var _b = __values(route.canActivate), _c = _b.next(); !_c.done; _c = _b.next()) {
                var guard = _c.value;
                /** @type {?} */
                var g = (/** @type {?} */ (this.injector.get(guard)));
                if (g && g.canActivate) {
                    /** @type {?} */
                    var r = new dummyRoute();
                    r.routeConfig = route;
                    /** @type {?} */
                    var canActivate = g.canActivate(r, undefined);
                    if (!canActivate)
                        return false;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return true;
    };
    RouteHelperService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    RouteHelperService.ctorParameters = function () { return [
        { type: Router },
        { type: Injector }
    ]; };
    return RouteHelperService;
}());
// @dynamic
var SignedInGuard = /** @class */ (function () {
    function SignedInGuard(context, router, helper) {
        this.context = context;
        this.router = router;
        this.helper = helper;
    }
    /**
     * @return {?}
     */
    SignedInGuard.prototype.isAllowed = /**
     * @return {?}
     */
    function () {
        return true;
    };
    /**
     * @param {?} route
     * @return {?}
     */
    SignedInGuard.prototype.canActivate = /**
     * @param {?} route
     * @return {?}
     */
    function (route) {
        if (this.context.isSignedIn() && this.context.isAllowed(this.isAllowed())) {
            return true;
        }
        if (!(route instanceof dummyRoute)) {
            /** @type {?} */
            var x = SignedInGuard.componentToNavigateIfNotAllowed;
            if (x != undefined) {
                this.helper.navigateToComponent(x);
            }
            else
                this.router.navigate(['/']);
        }
        return false;
    };
    SignedInGuard.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    SignedInGuard.ctorParameters = function () { return [
        { type: Context },
        { type: Router },
        { type: RouteHelperService }
    ]; };
    return SignedInGuard;
}());
var NotSignedInGuard = /** @class */ (function () {
    function NotSignedInGuard(context, router) {
        this.context = context;
        this.router = router;
    }
    /**
     * @param {?} route
     * @return {?}
     */
    NotSignedInGuard.prototype.canActivate = /**
     * @param {?} route
     * @return {?}
     */
    function (route) {
        if (this.context.isSignedIn())
            return false;
        return true;
    };
    NotSignedInGuard.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    NotSignedInGuard.ctorParameters = function () { return [
        { type: Context },
        { type: Router }
    ]; };
    return NotSignedInGuard;
}());
var dummyRoute = /** @class */ (function (_super) {
    __extends(dummyRoute, _super);
    function dummyRoute() {
        return _super.call(this) || this;
    }
    return dummyRoute;
}(ActivatedRouteSnapshot));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var WaitComponent = /** @class */ (function () {
    function WaitComponent() {
    }
    /**
     * @return {?}
     */
    WaitComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    WaitComponent.decorators = [
        { type: Component, args: [{
                    selector: 'app-wait',
                    template: "<mat-progress-spinner [mode]=\"'indeterminate'\" >\r\n</mat-progress-spinner>",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    WaitComponent.ctorParameters = function () { return []; };
    return WaitComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
var BusyService = /** @class */ (function () {
    function BusyService(dialog) {
        this.dialog = dialog;
        this.id = 0;
        this.numOfWaits = 0;
        this.disableWait = false;
        BusyService.singleInstance = this;
    }
    /**
     * @template t
     * @param {?} what
     * @return {?}
     */
    BusyService.prototype.donotWait = /**
     * @template t
     * @param {?} what
     * @return {?}
     */
    function (what) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.disableWait = true;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, , 3, 4]);
                        return [4 /*yield*/, what()];
                    case 2: return [2 /*return*/, (_a.sent())];
                    case 3:
                        this.disableWait = false;
                        return [7 /*endfinally*/];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @template t
     * @param {?} what
     * @return {?}
     */
    BusyService.prototype.donotWaitNonAsync = /**
     * @template t
     * @param {?} what
     * @return {?}
     */
    function (what) {
        this.disableWait = true;
        try {
            return (what());
        }
        finally {
            this.disableWait = false;
        }
    };
    /**
     * @param {?} id
     * @param {?} what
     * @return {?}
     */
    BusyService.prototype.log = /**
     * @param {?} id
     * @param {?} what
     * @return {?}
     */
    function (id, what) {
        //console.log(what + ' id:' + this.id + ' w:' + this.numOfWaits);
    };
    /**
     * @template t
     * @param {?} what
     * @return {?}
     */
    BusyService.prototype.doWhileShowingBusy = /**
     * @template t
     * @param {?} what
     * @return {?}
     */
    function (what) {
        return __awaiter(this, void 0, void 0, function () {
            var x;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        x = this.showBusy();
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, , 3, 4]);
                        return [4 /*yield*/, what()];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        x();
                        return [7 /*endfinally*/];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    BusyService.prototype.showBusy = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var id = this.id++;
        if (this.disableWait)
            return (/**
             * @return {?}
             */
            function () { });
        this.log(id, 'start busy ');
        if (this.numOfWaits == 0) {
            setTimeout((/**
             * @return {?}
             */
            function () {
                if (_this.numOfWaits > 0 && !_this.waitRef) {
                    _this.log(id, 'actual start busy ');
                    _this.waitRef = _this.dialog.open(WaitComponent, { disableClose: true });
                }
            }), 300);
        }
        this.numOfWaits++;
        return (/**
         * @return {?}
         */
        function () {
            _this.numOfWaits--;
            _this.log(id, 'close busy ');
            if (_this.numOfWaits == 0) {
                _this.log(id, 'close top busy ');
                if (_this.waitRef) {
                    _this.log(id, 'actual close top busy ');
                    _this.waitRef.close();
                    _this.waitRef = undefined;
                }
            }
        });
    };
    BusyService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    BusyService.ctorParameters = function () { return [
        { type: MatDialog }
    ]; };
    return BusyService;
}());
var LoaderInterceptor = /** @class */ (function () {
    function LoaderInterceptor(busy) {
        this.busy = busy;
    }
    /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    LoaderInterceptor.prototype.intercept = /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    function (req, next) {
        /** @type {?} */
        var x = this.busy.showBusy();
        return next.handle(req).pipe(finalize((/**
         * @return {?}
         */
        function () { return x(); })));
    };
    LoaderInterceptor.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    LoaderInterceptor.ctorParameters = function () { return [
        { type: BusyService }
    ]; };
    return LoaderInterceptor;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DataArea2Compnent = /** @class */ (function () {
    function DataArea2Compnent() {
        this.settings = { columns: new ColumnCollection((/**
             * @return {?}
             */
            function () { return undefined; }), (/**
             * @return {?}
             */
            function () { return false; }), undefined, (/**
             * @return {?}
             */
            function () { return true; })), lines: [] };
    }
    DataArea2Compnent.decorators = [
        { type: Component, args: [{
                    selector: 'data-area2',
                    template: "<ng-container *ngFor=\"let line of settings.lines\">\r\n  \r\n    <div class=\"one-line\">\r\n        <data-control2 [settings]=\"settings.columns\" [map]=\"map\" [record]=\"settings.columns.currentRow()\"\r\n            *ngFor=\"let map of line\">\r\n        </data-control2>\r\n    </div>\r\n</ng-container>\r\n<div  *ngIf=\"!settings.lines\">\r\n    <data-control2 [settings]=\"settings.columns\" [map]=\"map\" [record]=\"settings.columns.currentRow()\"\r\n        *ngFor=\"let map of settings.columns.items\">\r\n    </data-control2>\r\n</div>\r\n",
                    encapsulation: ViewEncapsulation.None,
                    styles: [".one-line{display:flex;justify-content:space-between}.one-line>*{padding-left:.2em;padding-right:.2em;flex-basis:1px;flex-grow:1}.one-line>:first-child{padding-right:0}.one-line>:last-child{padding-left:0}"]
                }] }
    ];
    DataArea2Compnent.propDecorators = {
        settings: [{ type: Input }]
    };
    return DataArea2Compnent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var RadWebModule = /** @class */ (function () {
    function RadWebModule() {
    }
    RadWebModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [DataControlComponent, DataControl2Component, DataArea2Compnent, DataGridComponent, ColumnDesigner, DataFilterInfoComponent, DataAreaCompnent, DataGrid2Component, WaitComponent, DataControl3Component],
                    imports: [FormsModule, CommonModule, HttpClientModule, MatProgressSpinnerModule, MatDialogModule, BrowserAnimationsModule,
                        MatFormFieldModule,
                        MatButtonModule,
                        MatInputModule, MatIconModule, ReactiveFormsModule, MatCheckboxModule],
                    providers: [Context, JwtSessionManager, NotSignedInGuard, SignedInGuard, RouteHelperService,
                        BusyService,
                        { provide: HTTP_INTERCEPTORS, useClass: LoaderInterceptor, multi: true }],
                    exports: [DataControlComponent, DataControl2Component, DataGridComponent, ColumnDesigner, DataFilterInfoComponent, DataAreaCompnent, DataGrid2Component, DataArea2Compnent],
                    entryComponents: [WaitComponent]
                },] }
    ];
    return RadWebModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LogSQLConnectionProvider = /** @class */ (function () {
    function LogSQLConnectionProvider(origin, allQueries) {
        this.origin = origin;
        this.allQueries = allQueries;
    }
    /**
     * @return {?}
     */
    LogSQLConnectionProvider.prototype.createCommand = /**
     * @return {?}
     */
    function () {
        return new LogSQLCommand(this.origin.createCommand(), this.allQueries);
    };
    return LogSQLConnectionProvider;
}());
var LogSQLCommand = /** @class */ (function () {
    function LogSQLCommand(origin, allQueries) {
        this.origin = origin;
        this.allQueries = allQueries;
        this.args = {};
    }
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    LogSQLCommand.prototype.addParameterToCommandAndReturnParameterName = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        /** @type {?} */
        var r = this.origin.addParameterToCommandAndReturnParameterName(col, val);
        this.args[r] = val;
        return r;
    };
    /**
     * @param {?} sql
     * @return {?}
     */
    LogSQLCommand.prototype.query = /**
     * @param {?} sql
     * @return {?}
     */
    function (sql) {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.allQueries) {
                            console.log('Query:', sql);
                            console.log("Arguments:", this.args);
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.origin.query(sql)];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        err_1 = _a.sent();
                        console.log('Query:', sql);
                        console.log("Arguments", this.args);
                        console.log('Error:', err_1);
                        throw err_1;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    return LogSQLCommand;
}());
// @dynamic
/**
 * @template T
 */
var ActualSQLServerDataProvider = /** @class */ (function () {
    function ActualSQLServerDataProvider(entityFactory, name, sql, factory) {
        this.entityFactory = entityFactory;
        this.name = name;
        this.sql = sql;
        this.factory = factory;
        this.sql = ActualSQLServerDataProvider.decorateSqlConnectionProvider(sql);
    }
    /**
     * @param {?} sql
     * @return {?}
     */
    ActualSQLServerDataProvider.decorateSqlConnectionProvider = /**
     * @param {?} sql
     * @return {?}
     */
    function (sql) {
        return new LogSQLConnectionProvider(sql, ActualSQLServerDataProvider.LogToConsole);
    };
    /**
     * @return {?}
     */
    ActualSQLServerDataProvider.prototype.createDirectSQLCommand = /**
     * @return {?}
     */
    function () {
        return this.sql.createCommand();
    };
    /**
     * @param {?} where
     * @return {?}
     */
    ActualSQLServerDataProvider.prototype.count = /**
     * @param {?} where
     * @return {?}
     */
    function (where) {
        if (!this.entity)
            this.entity = this.entityFactory();
        /** @type {?} */
        var select = 'select count(*) from ' + this.entity.__getDbName();
        /** @type {?} */
        var r = this.sql.createCommand();
        if (where) {
            /** @type {?} */
            var wc = new FilterConsumerBridgeToSqlRequest(r);
            where.__applyToConsumer(wc);
            select += wc.where;
        }
        return r.query(select).then((/**
         * @param {?} r
         * @return {?}
         */
        function (r) {
            return r.rows[0].count;
        }));
    };
    /**
     * @param {?=} options
     * @return {?}
     */
    ActualSQLServerDataProvider.prototype.find = /**
     * @param {?=} options
     * @return {?}
     */
    function (options) {
        if (!this.entity)
            this.entity = this.entityFactory();
        /** @type {?} */
        var select = 'select ';
        /** @type {?} */
        var colKeys = [];
        this.entity.__iterateColumns().forEach((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            if (x.__isVirtual()) ;
            else {
                if (colKeys.length > 0)
                    select += ', ';
                select += x.__getDbName();
                colKeys.push(x);
            }
        }));
        select += ' from ' + this.entity.__getDbName();
        /** @type {?} */
        var r = this.sql.createCommand();
        if (options) {
            if (options.where) {
                /** @type {?} */
                var where = new FilterConsumerBridgeToSqlRequest(r);
                options.where.__applyToConsumer(where);
                select += where.where;
            }
            if (options.orderBy) {
                /** @type {?} */
                var first_1 = true;
                options.orderBy.Segments.forEach((/**
                 * @param {?} c
                 * @return {?}
                 */
                function (c) {
                    if (first_1) {
                        select += ' Order By ';
                        first_1 = false;
                    }
                    else
                        select += ', ';
                    select += c.column.__getDbName();
                    if (c.descending)
                        select += ' desc';
                }));
            }
            if (options.limit) {
                /** @type {?} */
                var page = 1;
                if (options.page)
                    page = options.page;
                if (page < 1)
                    page = 1;
                select += ' limit ' + options.limit + ' offset ' + (page - 1) * options.limit;
            }
        }
        return r.query(select).then((/**
         * @param {?} r
         * @return {?}
         */
        function (r) {
            return r.rows.map((/**
             * @param {?} y
             * @return {?}
             */
            function (y) {
                /** @type {?} */
                var result = {};
                for (var x in y) {
                    /** @type {?} */
                    var col = colKeys[r.getColumnIndex(x)];
                    result[col.jsonName] = col.__getStorage().fromDb(y[x]);
                }
                return result;
            }));
        }));
    };
    /**
     * @param {?} id
     * @param {?} data
     * @return {?}
     */
    ActualSQLServerDataProvider.prototype.update = /**
     * @param {?} id
     * @param {?} data
     * @return {?}
     */
    function (id, data) {
        var _this = this;
        if (!this.entity)
            this.entity = this.entityFactory();
        /** @type {?} */
        var r = this.sql.createCommand();
        /** @type {?} */
        var f = new FilterConsumerBridgeToSqlRequest(r);
        this.entity.__idColumn.isEqualTo(id).__applyToConsumer(f);
        /** @type {?} */
        var statement = 'update ' + this.entity.__getDbName() + ' set ';
        /** @type {?} */
        var added = false;
        /** @type {?} */
        var resultFilter = this.entity.__idColumn.isEqualTo(id);
        if (data.id != undefined)
            resultFilter = this.entity.__idColumn.isEqualTo(data.id);
        this.entity.__iterateColumns().forEach((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            if (x instanceof CompoundIdColumn) {
                resultFilter = x.resultIdFilter(id, data);
            }
            if (x.__dbReadOnly()) ;
            else {
                /** @type {?} */
                var v = x.__getStorage().toDb(data[x.jsonName]);
                if (v != undefined) {
                    if (!added)
                        added = true;
                    else
                        statement += ', ';
                    statement += x.__getDbName() + ' = ' + r.addParameterToCommandAndReturnParameterName(x, v);
                }
            }
        }));
        statement += f.where;
        return r.query(statement).then((/**
         * @return {?}
         */
        function () {
            return _this.find({ where: resultFilter }).then((/**
             * @param {?} y
             * @return {?}
             */
            function (y) { return y[0]; }));
        }));
    };
    /**
     * @param {?} id
     * @return {?}
     */
    ActualSQLServerDataProvider.prototype.delete = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        var _this = this;
        if (!this.entity)
            this.entity = this.entityFactory();
        /** @type {?} */
        var r = this.sql.createCommand();
        /** @type {?} */
        var f = new FilterConsumerBridgeToSqlRequest(r);
        this.entity.__idColumn.isEqualTo(id).__applyToConsumer(f);
        /** @type {?} */
        var statement = 'delete from ' + this.entity.__getDbName();
        statement += f.where;
        return r.query(statement).then((/**
         * @return {?}
         */
        function () {
            return _this.find({ where: _this.entity.__idColumn.isEqualTo(id) }).then((/**
             * @param {?} y
             * @return {?}
             */
            function (y) { return y[0]; }));
        }));
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ActualSQLServerDataProvider.prototype.insert = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        var _this = this;
        if (!this.entity)
            this.entity = this.entityFactory();
        /** @type {?} */
        var r = this.sql.createCommand();
        /** @type {?} */
        var f = new FilterConsumerBridgeToSqlRequest(r);
        /** @type {?} */
        var cols = '';
        /** @type {?} */
        var vals = '';
        /** @type {?} */
        var added = false;
        /** @type {?} */
        var resultFilter = this.entity.__idColumn.isEqualTo(data[this.entity.__idColumn.jsonName]);
        this.entity.__iterateColumns().forEach((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            if (x instanceof CompoundIdColumn) {
                resultFilter = x.resultIdFilter(undefined, data);
            }
            if (x.__dbReadOnly()) ;
            else {
                /** @type {?} */
                var v = x.__getStorage().toDb(data[x.jsonName]);
                if (v != undefined) {
                    if (!added)
                        added = true;
                    else {
                        cols += ', ';
                        vals += ', ';
                    }
                    cols += x.__getDbName();
                    vals += r.addParameterToCommandAndReturnParameterName(x, v);
                }
            }
        }));
        /** @type {?} */
        var statement = "insert into " + this.entity.__getDbName() + " (" + cols + ") values (" + vals + ")";
        return r.query(statement).then((/**
         * @return {?}
         */
        function () {
            return _this.find({ where: resultFilter }).then((/**
             * @param {?} y
             * @return {?}
             */
            function (y) {
                return y[0];
            }));
        }));
    };
    ActualSQLServerDataProvider.LogToConsole = false;
    return ActualSQLServerDataProvider;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var WebSqlDataProvider = /** @class */ (function () {
    function WebSqlDataProvider(databaseName) {
        this.databaseName = databaseName;
        //@ts-ignore
        this.db = window.openDatabase(databaseName, '1.0', databaseName, 2 * 1024 * 1024);
    }
    /**
     * @template T
     * @param {?} name
     * @param {?} factory
     * @return {?}
     */
    WebSqlDataProvider.prototype.provideFor = /**
     * @template T
     * @param {?} name
     * @param {?} factory
     * @return {?}
     */
    function (name, factory) {
        var _this = this;
        return new ActualSQLServerDataProvider((/**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var e = factory();
            /** @type {?} */
            var result = '';
            e.__iterateColumns().forEach((/**
             * @param {?} x
             * @return {?}
             */
            function (x) {
                if (!x.__dbReadOnly()) {
                    if (result.length != 0)
                        result += ',';
                    result += '\r\n  ';
                    result += _this.addColumnSqlSyntax(x);
                    if (x == e.__idColumn)
                        result += ' primary key';
                }
            }));
            _this.db.transaction((/**
             * @param {?} t
             * @return {?}
             */
            function (t) { return t.executeSql('create table if not exists ' + e.__getDbName() + ' (' + result + '\r\n)'); }));
            return e;
        }), name, new WebSqlBridgeToSQLConnection(this.db), factory);
    };
    /**
     * @private
     * @param {?} x
     * @return {?}
     */
    WebSqlDataProvider.prototype.addColumnSqlSyntax = /**
     * @private
     * @param {?} x
     * @return {?}
     */
    function (x) {
        /** @type {?} */
        var result = x.__getDbName();
        if (x instanceof DateTimeColumn)
            result += " integer";
        else if (x instanceof DateColumn)
            result += " integer";
        else if (x instanceof BoolColumn)
            result += " integer default 0 not null";
        else if (x instanceof NumberColumn) {
            if (x.__numOfDecimalDigits == 0)
                result += " integer default 0 not null";
            else
                result += ' real default 0 not null';
        }
        else if (x instanceof ClosedListColumn) {
            result += ' integer default 0 not null';
        }
        else
            result += " text default '' not null ";
        return result;
    };
    /**
     * @return {?}
     */
    WebSqlDataProvider.prototype.toString = /**
     * @return {?}
     */
    function () { return "WebSqlDataProvider"; };
    return WebSqlDataProvider;
}());
var WebSqlBridgeToSQLConnection = /** @class */ (function () {
    //@ts-ignore
    function WebSqlBridgeToSQLConnection(source) {
        this.source = source;
    }
    /**
     * @return {?}
     */
    WebSqlBridgeToSQLConnection.prototype.createCommand = /**
     * @return {?}
     */
    function () {
        return new WebSqlBridgeToSQLCommand(this.source);
    };
    return WebSqlBridgeToSQLConnection;
}());
var WebSqlBridgeToSQLCommand = /** @class */ (function () {
    //@ts-ignore
    function WebSqlBridgeToSQLCommand(source) {
        this.source = source;
        this.values = [];
    }
    /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    WebSqlBridgeToSQLCommand.prototype.addParameterToCommandAndReturnParameterName = /**
     * @param {?} col
     * @param {?} val
     * @return {?}
     */
    function (col, val) {
        this.values.push(val);
        return '~' + this.values.length + '~';
    };
    /**
     * @param {?} sql
     * @return {?}
     */
    WebSqlBridgeToSQLCommand.prototype.query = /**
     * @param {?} sql
     * @return {?}
     */
    function (sql) {
        var _this = this;
        return new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        function (resolve, reject) {
            return _this.source.transaction((/**
             * @param {?} t
             * @return {?}
             */
            function (t) {
                /** @type {?} */
                var s = sql;
                /** @type {?} */
                var v = [];
                /** @type {?} */
                var m = s.match(/~\d+~/g);
                if (m != null)
                    m.forEach((/**
                     * @param {?} mr
                     * @return {?}
                     */
                    function (mr) {
                        s = s.replace(mr, '?');
                        v.push(_this.values[Number.parseInt(mr.substring(1, mr.length - 1)) - 1]);
                    }));
                t.executeSql(s, v, (/**
                 * @param {?} t1
                 * @param {?} r
                 * @return {?}
                 */
                function (t1, r) { return resolve(new WebSqlBridgeToSQLQueryResult(r)); }), (/**
                 * @param {?} t2
                 * @param {?} err
                 * @return {?}
                 */
                function (t2, err) {
                    reject(err.message);
                    return undefined;
                }));
            }));
        }));
    };
    return WebSqlBridgeToSQLCommand;
}());
var WebSqlBridgeToSQLQueryResult = /** @class */ (function () {
    //@ts-ignore
    function WebSqlBridgeToSQLQueryResult(r) {
        this.r = r;
        this.rows = [];
        for (var i = 0; i < r.rows.length; i++) {
            this.rows.push(r.rows.item(i));
        }
    }
    /**
     * @param {?} index
     * @return {?}
     */
    WebSqlBridgeToSQLQueryResult.prototype.getcolumnNameAtIndex = /**
     * @param {?} index
     * @return {?}
     */
    function (index) {
        return undefined;
    };
    /**
     * @param {?} name
     * @return {?}
     */
    WebSqlBridgeToSQLQueryResult.prototype.getColumnIndex = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        if (this.rows.length == 0)
            return -1;
        /** @type {?} */
        var i = 0;
        for (var m in this.rows[0]) {
            if (m == name)
                return i;
            i++;
        }
        return -1;
    };
    return WebSqlBridgeToSQLQueryResult;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
var  /**
 * @template T
 */
JsonStorageDataProvider = /** @class */ (function () {
    function JsonStorageDataProvider(helper) {
        this.helper = helper;
    }
    /**
     * @param {?=} options
     * @return {?}
     */
    JsonStorageDataProvider.prototype.find = /**
     * @param {?=} options
     * @return {?}
     */
    function (options) {
        return this.helper.doWork((/**
         * @param {?} dp
         * @param {?} save
         * @return {?}
         */
        function (dp, save) { return dp.find(options); }));
    };
    /**
     * @param {?=} where
     * @return {?}
     */
    JsonStorageDataProvider.prototype.count = /**
     * @param {?=} where
     * @return {?}
     */
    function (where) {
        return this.helper.doWork((/**
         * @param {?} dp
         * @param {?} save
         * @return {?}
         */
        function (dp, save) { return dp.count(where); }));
    };
    /**
     * @param {?} id
     * @param {?} data
     * @return {?}
     */
    JsonStorageDataProvider.prototype.update = /**
     * @param {?} id
     * @param {?} data
     * @return {?}
     */
    function (id, data) {
        return this.helper.doWork((/**
         * @param {?} dp
         * @param {?} save
         * @return {?}
         */
        function (dp, save) { return dp.update(id, data).then((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            save();
            return x;
        })); }));
    };
    /**
     * @param {?} id
     * @return {?}
     */
    JsonStorageDataProvider.prototype.delete = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        return this.helper.doWork((/**
         * @param {?} dp
         * @param {?} save
         * @return {?}
         */
        function (dp, save) { return dp.delete(id).then((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            save();
            return x;
        })); }));
    };
    /**
     * @param {?} data
     * @return {?}
     */
    JsonStorageDataProvider.prototype.insert = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        return this.helper.doWork((/**
         * @param {?} dp
         * @param {?} save
         * @return {?}
         */
        function (dp, save) { return dp.insert(data).then((/**
         * @param {?} x
         * @return {?}
         */
        function (x) {
            save();
            return x;
        })); }));
    };
    return JsonStorageDataProvider;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 */
var  /**
 * @template T
 */
DataApi = /** @class */ (function () {
    function DataApi(rowType, options) {
        var _a, _b, _c;
        this.rowType = rowType;
        this.options = options;
        this.excludedColumns = new ColumnHashSet();
        this.readonlyColumns = new ColumnHashSet();
        if (!options)
            this.options = {};
        if (this.options.readonlyColumns)
            (_a = this.readonlyColumns).add.apply(_a, __spread(this.options.readonlyColumns(rowType)));
        if (this.options.excludeColumns) {
            (_b = this.excludedColumns).add.apply(_b, __spread(this.options.excludeColumns(rowType)));
            (_c = this.readonlyColumns).add.apply(_c, __spread(this.options.excludeColumns(rowType)));
        }
    }
    /**
     * @return {?}
     */
    DataApi.prototype.getRoute = /**
     * @return {?}
     */
    function () {
        if (!this.options.name)
            return this.rowType.__getName();
        return this.options.name;
    };
    /**
     * @param {?} response
     * @param {?} id
     * @return {?}
     */
    DataApi.prototype.get = /**
     * @param {?} response
     * @param {?} id
     * @return {?}
     */
    function (response, id) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.options.allowRead == false) {
                            response.methodNotAllowed();
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.doOnId(response, id, (/**
                             * @param {?} row
                             * @return {?}
                             */
                            function (row) { return __awaiter(_this, void 0, void 0, function () { var _a, _b; return __generator(this, function (_c) {
                                switch (_c.label) {
                                    case 0:
                                        _b = (_a = response).success;
                                        return [4 /*yield*/, row.__toPojo(this.excludedColumns)];
                                    case 1: return [2 /*return*/, _b.apply(_a, [_c.sent()])];
                                }
                            }); }); }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} response
     * @param {?} request
     * @return {?}
     */
    DataApi.prototype.count = /**
     * @param {?} response
     * @param {?} request
     * @return {?}
     */
    function (response, request) {
        return __awaiter(this, void 0, void 0, function () {
            var where, _a, _b, _c, err_1;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 2, , 3]);
                        where = this.buildWhere(request);
                        _b = (_a = response).success;
                        _c = {};
                        return [4 /*yield*/, this.rowType.source.count(where)];
                    case 1:
                        _b.apply(_a, [(_c.count = +(_d.sent()), _c)]);
                        return [3 /*break*/, 3];
                    case 2:
                        err_1 = _d.sent();
                        response.error(err_1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} response
     * @param {?} request
     * @return {?}
     */
    DataApi.prototype.getArray = /**
     * @param {?} response
     * @param {?} request
     * @return {?}
     */
    function (response, request) {
        return __awaiter(this, void 0, void 0, function () {
            var findOptions_1, sort, dir, dirItems_1, limit, err_2;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.options.allowRead == false) {
                            response.methodNotAllowed();
                            return [2 /*return*/];
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        findOptions_1 = {};
                        if (this.options && this.options.get) {
                            Object.assign(findOptions_1, this.options.get);
                        }
                        findOptions_1.where = this.buildWhere(request);
                        if (request) {
                            sort = (/** @type {?} */ (request.get("_sort")));
                            if (sort != undefined) {
                                dir = request.get('_order');
                                dirItems_1 = [];
                                if (dir)
                                    dirItems_1 = dir.split(',');
                                findOptions_1.orderBy = new Sort();
                                sort.split(',').forEach((/**
                                 * @param {?} name
                                 * @param {?} i
                                 * @return {?}
                                 */
                                function (name, i) {
                                    /** @type {?} */
                                    var col = _this.rowType.__getColumnByJsonName(name.trim());
                                    if (col) {
                                        findOptions_1.orderBy.Segments.push({
                                            column: col,
                                            descending: i < dirItems_1.length && dirItems_1[i].toLowerCase().trim().startsWith("d")
                                        });
                                    }
                                }));
                            }
                            limit = +request.get("_limit");
                            if (!limit)
                                limit = 25;
                            findOptions_1.limit = limit;
                            findOptions_1.page = +request.get("_page");
                        }
                        return [4 /*yield*/, this.rowType.source.find(findOptions_1)
                                .then((/**
                             * @param {?} r
                             * @return {?}
                             */
                            function (r) { return __awaiter(_this, void 0, void 0, function () {
                                var _a, _b;
                                var _this = this;
                                return __generator(this, function (_c) {
                                    switch (_c.label) {
                                        case 0:
                                            _b = (_a = response).success;
                                            return [4 /*yield*/, Promise.all(r.map((/**
                                                 * @param {?} y
                                                 * @return {?}
                                                 */
                                                function (y) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                                    switch (_a.label) {
                                                        case 0: return [4 /*yield*/, y.__toPojo(this.excludedColumns)];
                                                        case 1: return [2 /*return*/, _a.sent()];
                                                    }
                                                }); }); })))];
                                        case 1:
                                            _b.apply(_a, [_c.sent()]);
                                            return [2 /*return*/];
                                    }
                                });
                            }); }))];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_2 = _a.sent();
                        response.error(err_2);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @private
     * @param {?} request
     * @return {?}
     */
    DataApi.prototype.buildWhere = /**
     * @private
     * @param {?} request
     * @return {?}
     */
    function (request) {
        /** @type {?} */
        var where;
        if (this.options && this.options.get && this.options.get.where)
            where = this.options.get.where(this.rowType);
        if (request) {
            this.rowType.__iterateColumns().forEach((/**
             * @param {?} col
             * @return {?}
             */
            function (col) {
                /**
                 * @param {?} key
                 * @param {?} theFilter
                 * @return {?}
                 */
                function addFilter(key, theFilter) {
                    /** @type {?} */
                    var val = request.get(col.jsonName + key);
                    if (val != undefined) {
                        /** @type {?} */
                        var addFilter_1 = (/**
                         * @param {?} val
                         * @return {?}
                         */
                        function (val) {
                            /** @type {?} */
                            var f = theFilter(col.fromRawValue(val));
                            if (f) {
                                if (where)
                                    where = new AndFilter(where, f);
                                else
                                    where = f;
                            }
                        });
                        if (val instanceof Array) {
                            val.forEach((/**
                             * @param {?} v
                             * @return {?}
                             */
                            function (v) {
                                addFilter_1(v);
                            }));
                        }
                        else
                            addFilter_1(val);
                    }
                }
                addFilter('', (/**
                 * @param {?} val
                 * @return {?}
                 */
                function (val) { return col.isEqualTo(val); }));
                addFilter('_gt', (/**
                 * @param {?} val
                 * @return {?}
                 */
                function (val) { return col.isGreaterThan(val); }));
                addFilter('_gte', (/**
                 * @param {?} val
                 * @return {?}
                 */
                function (val) { return col.isGreaterOrEqualTo(val); }));
                addFilter('_lt', (/**
                 * @param {?} val
                 * @return {?}
                 */
                function (val) { return col.isLessThan(val); }));
                addFilter('_lte', (/**
                 * @param {?} val
                 * @return {?}
                 */
                function (val) { return col.isLessOrEqualTo(val); }));
                addFilter('_ne', (/**
                 * @param {?} val
                 * @return {?}
                 */
                function (val) { return col.isDifferentFrom(val); }));
                addFilter('_contains', (/**
                 * @param {?} val
                 * @return {?}
                 */
                function (val) {
                    /** @type {?} */
                    var c = (/** @type {?} */ (col));
                    if (c != null && c.isContains) {
                        return c.isContains(val);
                    }
                }));
                addFilter('_st', (/**
                 * @param {?} val
                 * @return {?}
                 */
                function (val) {
                    /** @type {?} */
                    var c = (/** @type {?} */ (col));
                    if (c != null && c.isContains) {
                        return c.isStartsWith(val);
                    }
                }));
            }));
        }
        return where;
    };
    /**
     * @private
     * @param {?} response
     * @param {?} id
     * @param {?} what
     * @return {?}
     */
    DataApi.prototype.doOnId = /**
     * @private
     * @param {?} response
     * @param {?} id
     * @param {?} what
     * @return {?}
     */
    function (response, id, what) {
        return __awaiter(this, void 0, void 0, function () {
            var where, err_3;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        where = this.rowType.__idColumn.isEqualTo(id);
                        if (this.options && this.options.get && this.options.get.where)
                            where = new AndFilter(where, this.options.get.where(this.rowType));
                        return [4 /*yield*/, this.rowType.source.find({ where: where })
                                .then((/**
                             * @param {?} r
                             * @return {?}
                             */
                            function (r) { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            if (!(r.length == 0)) return [3 /*break*/, 1];
                                            response.notFound();
                                            return [3 /*break*/, 4];
                                        case 1:
                                            if (!(r.length > 1)) return [3 /*break*/, 2];
                                            response.error({ message: "id is not unique" });
                                            return [3 /*break*/, 4];
                                        case 2: return [4 /*yield*/, what(r[0])];
                                        case 3:
                                            _a.sent();
                                            _a.label = 4;
                                        case 4: return [2 /*return*/];
                                    }
                                });
                            }); }))];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        err_3 = _a.sent();
                        response.error(err_3);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} response
     * @param {?} id
     * @param {?} body
     * @return {?}
     */
    DataApi.prototype.put = /**
     * @param {?} response
     * @param {?} id
     * @param {?} body
     * @return {?}
     */
    function (response, id, body) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.options.allowUpdate) {
                            response.methodNotAllowed();
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.doOnId(response, id, (/**
                             * @param {?} row
                             * @return {?}
                             */
                            function (row) { return __awaiter(_this, void 0, void 0, function () {
                                var _a, _b;
                                return __generator(this, function (_c) {
                                    switch (_c.label) {
                                        case 0:
                                            row.__fromPojo(body, this.readonlyColumns);
                                            return [4 /*yield*/, row.save(this.options.validate, this.options.onSavingRow)];
                                        case 1:
                                            _c.sent();
                                            _b = (_a = response).success;
                                            return [4 /*yield*/, row.__toPojo(this.excludedColumns)];
                                        case 2:
                                            _b.apply(_a, [_c.sent()]);
                                            return [2 /*return*/];
                                    }
                                });
                            }); }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} response
     * @param {?} id
     * @return {?}
     */
    DataApi.prototype.delete = /**
     * @param {?} response
     * @param {?} id
     * @return {?}
     */
    function (response, id) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.options.allowDelete) {
                            response.methodNotAllowed();
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.doOnId(response, id, (/**
                             * @param {?} row
                             * @return {?}
                             */
                            function (row) { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, row.delete()];
                                        case 1:
                                            _a.sent();
                                            response.deleted();
                                            return [2 /*return*/];
                                    }
                                });
                            }); }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} response
     * @param {?} body
     * @return {?}
     */
    DataApi.prototype.post = /**
     * @param {?} response
     * @param {?} body
     * @return {?}
     */
    function (response, body) {
        return __awaiter(this, void 0, void 0, function () {
            var r, _a, _b, err_4;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!this.options.allowInsert) {
                            response.methodNotAllowed();
                            return [2 /*return*/];
                        }
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 4, , 5]);
                        r = this.rowType.source.createNewItem();
                        r.__fromPojo(body, this.readonlyColumns);
                        return [4 /*yield*/, r.save(this.options.validate, this.options.onSavingRow)];
                    case 2:
                        _c.sent();
                        _b = (_a = response).created;
                        return [4 /*yield*/, r.__toPojo(this.excludedColumns)];
                    case 3:
                        _b.apply(_a, [_c.sent()]);
                        return [3 /*break*/, 5];
                    case 4:
                        err_4 = _c.sent();
                        response.error(err_4);
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    return DataApi;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LocalStorageDataProvider = /** @class */ (function () {
    function LocalStorageDataProvider() {
    }
    /**
     * @template T
     * @param {?} name
     * @param {?} factory
     * @return {?}
     */
    LocalStorageDataProvider.prototype.provideFor = /**
     * @template T
     * @param {?} name
     * @param {?} factory
     * @return {?}
     */
    function (name, factory) {
        return new JsonStorageDataProvider(new LocalJsonStorage(name, factory));
    };
    return LocalStorageDataProvider;
}());
var LocalJsonStorage = /** @class */ (function () {
    function LocalJsonStorage(key, factory) {
        this.key = key;
        this.factory = factory;
    }
    /**
     * @template T
     * @param {?} what
     * @return {?}
     */
    LocalJsonStorage.prototype.doWork = /**
     * @template T
     * @param {?} what
     * @return {?}
     */
    function (what) {
        var _this = this;
        /** @type {?} */
        var data = localStorage.getItem(this.key);
        try {
            data = JSON.parse(data);
        }
        catch (err) {
            data = [];
        }
        if (!(data instanceof Array))
            data = [];
        /** @type {?} */
        var dp = new ActualInMemoryDataProvider(this.factory, data);
        return what(dp, (/**
         * @return {?}
         */
        function () { return localStorage.setItem(_this.key, JSON.stringify(data, undefined, 2)); }));
    };
    return LocalJsonStorage;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ActualDirectSQL = /** @class */ (function (_super) {
    __extends(ActualDirectSQL, _super);
    function ActualDirectSQL(dp) {
        var _this = _super.call(this) || this;
        _this.dp = dp;
        _this.dp = ActualSQLServerDataProvider.decorateSqlConnectionProvider(dp);
        return _this;
    }
    /**
     * @param {?} sql
     * @return {?}
     */
    ActualDirectSQL.prototype.execute = /**
     * @param {?} sql
     * @return {?}
     */
    function (sql) {
        /** @type {?} */
        var c = this.dp.createCommand();
        return c.query(sql);
    };
    return ActualDirectSQL;
}(DirectSQL));
var myServerAction = /** @class */ (function (_super) {
    __extends(myServerAction, _super);
    function myServerAction(name, types, options, originalMethod) {
        var _this = _super.call(this, Context.apiBaseUrl + '/', name) || this;
        _this.types = types;
        _this.options = options;
        _this.originalMethod = originalMethod;
        return _this;
    }
    /**
     * @protected
     * @param {?} info
     * @param {?} req
     * @return {?}
     */
    myServerAction.prototype.execute = /**
     * @protected
     * @param {?} info
     * @param {?} req
     * @return {?}
     */
    function (info, req) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        result = { data: {} };
                        return [4 /*yield*/, ((/** @type {?} */ (this.dataSource))).doInTransaction((/**
                             * @param {?} ds
                             * @return {?}
                             */
                            function (ds) { return __awaiter(_this, void 0, void 0, function () {
                                var context, i, _a, err_1;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            context = new ServerContext();
                                            context.setReq(req);
                                            context.setDataProvider(ds);
                                            if (!context.isAllowed(this.options.allowed))
                                                throw 'not allowed';
                                            if (this.types)
                                                for (i = 0; i < this.types.length; i++) {
                                                    if (info.args.length < i) {
                                                        info.args.push(undefined);
                                                    }
                                                    if (this.types[i] == Context || this.types[i] == ServerContext) {
                                                        info.args[i] = context;
                                                    }
                                                    else if (this.types[i] == DirectSQL && ds) {
                                                        info.args[i] = ((/** @type {?} */ ((/** @type {?} */ (ds))))).getDirectSql();
                                                    }
                                                }
                                            _b.label = 1;
                                        case 1:
                                            _b.trys.push([1, 3, , 4]);
                                            _a = result;
                                            return [4 /*yield*/, this.originalMethod(info.args)];
                                        case 2:
                                            _a.data = _b.sent();
                                            return [3 /*break*/, 4];
                                        case 3:
                                            err_1 = _b.sent();
                                            console.error(err_1);
                                            throw err_1;
                                        case 4: return [2 /*return*/];
                                    }
                                });
                            }); }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, result];
                }
            });
        });
    };
    return myServerAction;
}(Action));
/** @type {?} */
var actionInfo = {
    allActions: (/** @type {?} */ ([])),
    runningOnServer: false
};
/**
 * @param {?} options
 * @return {?}
 */
function ServerFunction(options) {
    return (/**
     * @param {?} target
     * @param {?} key
     * @param {?} descriptor
     * @return {?}
     */
    function (target, key, descriptor) {
        /** @type {?} */
        var originalMethod = descriptor.value;
        /** @type {?} */
        var types = Reflect.getMetadata("design:paramtypes", target, key);
        /** @type {?} */
        var serverAction = new myServerAction(key, types, options, (/**
         * @param {?} args
         * @return {?}
         */
        function (args) { return originalMethod.apply(undefined, args); }));
        descriptor.value = (/**
         * @param {...?} args
         * @return {?}
         */
        function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!!actionInfo.runningOnServer) return [3 /*break*/, 5];
                            if (!(options.blockUser === false)) return [3 /*break*/, 2];
                            return [4 /*yield*/, BusyService.singleInstance.donotWait((/**
                                 * @return {?}
                                 */
                                function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, serverAction.run({ args: args })];
                                        case 1: return [2 /*return*/, (_a.sent()).data];
                                    }
                                }); }); }))];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2: return [4 /*yield*/, serverAction.run({ args: args })];
                        case 3: return [2 /*return*/, (_a.sent()).data];
                        case 4: return [3 /*break*/, 7];
                        case 5: return [4 /*yield*/, originalMethod.apply(undefined, args)];
                        case 6: return [2 /*return*/, (_a.sent())];
                        case 7: return [2 /*return*/];
                    }
                });
            });
        });
        actionInfo.allActions.push(descriptor.value);
        descriptor.value[serverActionField] = serverAction;
        return descriptor;
    });
}
/** @type {?} */
var serverActionField = Symbol('serverActionField');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var IdEntity = /** @class */ (function (_super) {
    __extends(IdEntity, _super);
    function IdEntity(options) {
        var _this = _super.call(this, options) || this;
        _this.id = new IdColumn();
        _this.disableNewId = false;
        _this.id.allowApiUpdate = false;
        /** @type {?} */
        var x = _this.__onSavingRow;
        _this.__onSavingRow = (/**
         * @return {?}
         */
        function () {
            if (_this.isNew() && !_this.id.value && !_this.disableNewId)
                _this.id.setToNewId();
            return x();
        });
        return _this;
    }
    /**
     * @return {?}
     */
    IdEntity.prototype.setEmptyIdForNewRow = /**
     * @return {?}
     */
    function () {
        this.id.value = '';
        this.disableNewId = true;
    };
    return IdEntity;
}(Entity));
var IdColumn = /** @class */ (function (_super) {
    __extends(IdColumn, _super);
    function IdColumn() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @return {?}
     */
    IdColumn.prototype.setToNewId = /**
     * @return {?}
     */
    function () {
        this.value = v4();
    };
    return IdColumn;
}(StringColumn));
/**
 * @param {?} row
 * @param {?} column
 * @param {?=} message
 * @return {?}
 */
function checkForDuplicateValue(row, column, message) {
    return __awaiter(this, void 0, void 0, function () {
        var rows;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(row.isNew() || column.value != column.originalValue)) return [3 /*break*/, 2];
                    return [4 /*yield*/, row.source.find({ where: column.isEqualTo(column.value) })];
                case 1:
                    rows = _a.sent();
                    console.log(rows.length);
                    if (rows.length > 0)
                        column.error = message || 'Already exists';
                    _a.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    });
}
/**
 * @template type
 * @param {?} original
 * @param {?} addValues
 * @return {?}
 */
function DecorateDataColumnSettings(original, addValues) {
    /** @type {?} */
    var result = {};
    if (typeof (original) == "string")
        result.caption = original;
    else
        result = original;
    addValues(result);
    return result;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { BusyService, RadWebModule, myFetch, RestDataProvider, angularHttpProvider, restDataProviderHttpProviderUsingFetch, wrapFetch, Action, isNewRow, extractSortFromSettings, translateSort, testing, DataAreaSettings, GridSettings, FilterHelper, DataList, Sort, Lookup, UrlBuilder, FilterConsumnerBridgeToUrlBuilder, lookupRowInfo, DefaultStorage, DateTimeDateStorage, CharDateStorage, DateTimeStorage, Column, Filter, AndFilter, Entity, ColumnHashSet, CompoundIdColumn, EntitySource, __EntityValueProvider, StringColumn, DateColumn, DateTimeColumn, NumberColumn, BoolColumn, BoolStorage, ClosedListColumn, ColumnCollection, FilterConsumerBridgeToSqlRequest, makeTitle, isFunction$1 as isFunction, functionOrString, pageArray, InMemoryDataProvider, ActualInMemoryDataProvider, WebSqlDataProvider, ActualSQLServerDataProvider, JsonStorageDataProvider, DataApi, LocalStorageDataProvider, EntityClass, Context, ServerContext, SpecificEntityHelper, allEntities, DirectSQL, Role, JwtSessionManager, RouteHelperService, SignedInGuard, NotSignedInGuard, ServerFunction, ActualDirectSQL, myServerAction, actionInfo, serverActionField, checkForDuplicateValue, DecorateDataColumnSettings, IdEntity, IdColumn, ColumnDesigner as ɵf, DataAreaCompnent as ɵh, DataArea2Compnent as ɵd, DataControlComponent as ɵb, DataControl2Component as ɵc, DataControl3Component as ɵk, DataFilterInfoComponent as ɵg, DataGridComponent as ɵe, DataGrid2Component as ɵi, LoaderInterceptor as ɵa, WaitComponent as ɵj };

//# sourceMappingURL=radweb.js.map